/**
 * 常量
 * 
 * @Author : Cydow
 * @Timestamp : 2017-02-22
 */
var deviceone = require("deviceone");

var Constants = (function() { 
	// Private static attributes.
	var constants = {//定义常量
		//应用名称
		appName : "慧影时间流",
		
		//渠道类型(功能模块)
		channelType_timeflow : "timeflow",
		channelType_contact : "contact",
		
		// ------------------------- 数据同步
		//业务模块
		moduleType_timeflow: "a3447940-3682-1350-c354-47e751052",
		moduleType_contact: "d5a7e559-9e1c-4337-8ce7-00cac629cb2c",
		
		//数据同步（数据传输码）
		syncData_transCode : "8",
		
		//更新记录类型(同步)
		recordType_create : 1, //新建
		recordType_update : 2, //修改
		recordType_delete : 3, //删除
		
		//源数据类型
		datatype_timecard : "1",    //时间流-时间卡片
		datatype_contact : "2",     //联系应用-联系人
		datatype_contactcard : "3", //联系应用-名片
		datatype_contactgroups : "4", //联系人应用-群组
		datatype_groupsrelation : "5", //联系人应用-群组关系
		datatype_userecord : "6",   //信息库-本地使用记录
		datatype_sharerecord : "7", //信息库-库外共享记录
		
		// 会话状态(同步)
		sessionStatus_create : 0, // 创建会话
		sessionStatus_accept : 1, // 接受会话
		sessionStatus_reqfinish : 2, // 请求结束
		sessionStatus_resfinish : 3, // 确认结束
		sessionStatus_finish : 4, // 结束
		sessionStatus_abort : 5,  // 中止
		
		// 传输状态(同步)
		transStatus_start : 0, // 开始传输
		transStatus_upload : 1, // 数据上传中
		transStatus_uploadfinish : 2, // 数据上传完成
		transStatus_download : 3, // 数据下载中
		transStatus_downloadfinsh : 4, // 数据下载完成
		transStatus_feedback : 5,  // 响应方反馈
		transStatus_feedbacksender : 6,  // 发送发反馈，传输完成
		
		// 自动同步标识
		autoSync_tf: "autoSyncTimeFlow",  // 时间流自动同步
		autoSync_contact: "autoSyncContact", // 联系人自动同步
		// 仅在wifi下自动同步标识
		autoSync_wifi_tf: "autoSyncWifiTimeflow",  // 时间流自动同步
		autoSync_wifi_contact: "autoSyncWifiContact",  // 时间流自动同步
		
		// 上次完成同步的时间
		syncTime_tf: "syncTimeTimeFlow", // 时间流
		syncTime_contact: "syncTimeContact", // 联系人
		
		// 同步失败的数量
		syncFailNum_tf: "syncFailNumTimeFlow", // 时间流
		syncFailNum_contact: "syncFailNumContact", // 联系人
		
		// 本次数据同步完成状态
		syncDataState_tf: 'syncDataStateTf', // 缓存标识-时间流
		syncDataState_contact: 'syncDataStateContact', // 缓存标识-联系人
		syncDataState_all: 'syncDataStateAll', // 缓存标识-整体同步
		syncDataState_start: '0',  // 开始完成
		
		// ---------------------- 时间流
		//时间流-信息类别
		tfShowView_week : "weekView", // 时间流显示的视图-周视图
		tfShowView_month : "monthView", // 时间流显示的视图-月视图
		tfShowView_day : "dayView", // 时间流显示的视图-天视图
		
		//时间流-信息类别
		infoCategory_festival : 0,  //节假日信息
		infoCategory_task : 1,      //待办事宜
		infoCategory_notice : 2,    //通知通告
		infoCategory_comm : 3,      //纪念日
		infoCategory_birthday : 4,  //生日
		infoCategory_lesson : 5,    //课程
		
		//本地通知（提醒）数据类型
		notifyDataType_task : 0,       //待办开始时间
		notifyDataType_taskStatis : 1, //待办统计
		notifyDataType_comm : 2,	   //纪念日
		notifyDataType_birthday : 3,   //生日
		notifyDataType_syncData : 4,   //数据同步
		notifyDataType_clearCache1 : 5,   //清除数据
		notifyDataType_clearCacheDone : 6,   //清除数据完成
		notifyDataType_sysCalendar : 7,   //读取日历,
		notifyDataType_taskStatisYear : 8, //待办统计（年度）
		notifyDataType_clearCache2 : 9,   //清除数据
		notifyDataType_clearCache3 : 10,   //清除数据
		notifyDataType_sysCalNotify : 11,   //系统日历提醒
		notifyDataType_autoSyncData : 12,   //自动同步
		notifyDataType_countDown : 13,   //待办倒计时
		notifyDataType_taskEndTime : 14, //待办结束时间提醒
		notifyDataType_lesson : 15, //待办结束时间提醒
		
		// 数据来源（创建或分享）
		dataSource_create : '0', // 自己创建
		dataSource_share : '1',  // 分享保存
		
		// 待办完成
		taskCard_uncompleted : '0', // 待办未完成
		taskCard_completed : '1',  // 待办已完成
		
		// 系统日历数据来源
		calendarSource_sys: '0', // 系统日历
		calendarSource_tf: '1',  // 时间流
		
		// ------------------------ 联系人
		//联系人-信息类别
		infoCategory_contact : 1,   //联系人
		infoCategory_card : 2,      //电子名片
		
		//联系人导入导出类型
		contactImExport_cydow : '0',  //慧影联系人导出
		contactImExport_phone : '1',  //手机通讯录导入
		
		// 联系人二维码版本
		// 1：优化应用2.3.0版本二维码内容的数据结构
		qrcode_ver: 1,
		
		// 历法类型
		calendartype_greg: "0",   // 公历
		calendartype_lunar: "1",  // 农历
		
		//提示类型
		notifyType_disconnect : 1, //链接断开提示-数据同步
		notifyType_checkver : 2,   //检测版本-数据同步
		notifyType_checkip : 3,    //检测ip-数据同步
		notifyType_mobilenocydowid : 4,    //检测手机版慧影ID-数据同步
		notifyType_pcnocydowid : 5,    //检测pc版慧影ID-数据同步
		notifyType_noequalcydowid : 6,    //检测pc版慧影ID-数据同步
		notifyType_barcodeerror : 7,    //检测二维码不正确-数据同步
		notifyType_checkfaild : 8,    //检测二维码不正确-数据同步
		notifyType_tfmoduleerr : 9,    // 应用业务模块(时间流)不一致-数据同步
		notifyType_contactmoduleerr : 10,    // 应用业务模块（联系人）不一致-数据同步
		
		//网络异常场景
		networkFail_init : 0,      //初始化
		networkFail_search : 1,    //搜索
		
		// ------------------------ 使用记录
		//调用类型
		syscall_system : 0,      //慧影（自动）调用-使用记录
		syscall_user : 1,        //用户（手动）调用-使用记录
		syscall_system_1 : 2,    //邮件分享信息调用-使用记录
		syscall_system_2 : 3,    //云端分享信息调用-使用记录
		syscall_system_3 : 4,    //创建工作周报调用-使用记录
		syscall_system_4 : 5,    //发送邮件调用-使用记录
		syscall_system_5 : 6,    //导出信息调用-使用记录
		
		//使用或共享格式
		useformat_special : 0,     //慧影系统专用文件格式
		useformat_common : 1,      //普通文件格式
		
		// 标记
		processMark_false : "0",
		processMark_true : "1",
		
		// -------------------- 引导页序号已经到 34
		// 基础功能引导页类型（不同功能）
		guideNotify_main : "showMainGuideNotify",     //功能引导-主页面
		guideNotify_share : "showShareCardGuideNotify",   //功能引导-共享信息卡片
		guideNotify_cang : "showCangGuideNotify",     //功能引导-固定
		guideNotify_future : "showFutureGuideNotify",  //功能引导-未来卡片
		
		// 新功能引导页类型（不同功能）
		guideNotify_globalNewInfo : "guide_new_35", //全局新建信息入口引导页
		
		// 其他引导页类型（基础功能+新功能）
		guideNotify_vcardQrcode : "guide_other_5" ,// 名片详情页面二维码引导页
		guideNotify_contactQrcode : "guide_other_6", // 联系人详情页面二维码引导页
		guideNotify_tfSetUseSysCal : "guide_other_14",  // 时间流设置页面使用系统日历提醒引导页
		guideNotify_notifyOptimize : "guide_new_33", // 安卓提醒优化引导页
		
		// 新功能引导页版本标识˙
		// 从2.3.0版本开始，默认值为2，这个版本之前的值为1
		// 从2.3.1版本标识改为3
		// 从2.3.2版本标识改为4
		// 从2.3.4版本标识改为5
		// 从2.3.6版本标识改为6
		// 从2.4.0版本标识改为7
		// 从3.0.0版本标识改为8
		// 从3.0.5版本标识改为9
		// 从3.0.8版本标识改为10
		// 从3.0.9版本标识改为11
		guidePage_ver: 11,
		
		//--------------------------- 消息（云端）
		//云端分享（数据传输码）
		cloudMsg_transCode: "1",
		
		//消息处理状态
		messageHandleState_unHandle : 0,  //未处理
		messageHandleState_saveToLocal : 1,  //保存到本地
		messageHandleState_saveToCloud : 2,  //保存到云端
		messageHandleState_giveUp : 3,  //放弃
		
		//传输类型
		messageTransType_send : 0,  //发送
		messageTransType_receive : 1,  //接收
		
		//消息级别
		messageLevel_user : 0,  //用户
		messageLevel_sys : 1,  //系统
		messageLevel_app : 2,  //应用
		
		//消息业务类型
		messageActionType_share : "share", //分享
		messageActionType_exchangeCard : "exchange",  //电子名片交换
		messageActionType_demand : "demand", // 获取对方的联系人
		messageActionType_demandVCard : "demandvcard", // 获取对方名片

		messagePushType_commu: 1, //待办沟通
		messagePushType_contact: 2, //联系人分享
		messagePushType_task: 3, //待办分享
		messagePushType_vcard: 4, //名片分享
		messagePushType_comm: 5, //纪念日分享
		messagePushType_lesson: 6, //课程表分享
		
		//--------------------------- 数据版本-数据同步
		// 时间流
		curDataVerTf_task: 1, // 当前-待办
		minDataVerTf_task: 1, // 最小-待办
		curDataVerTf_comm: 1, // 当前-纪念日
		minDataVerTf_comm: 1, // 最小-纪念日
		curDataVerTf_lesson: 2, // 当前-课程
		minDataVerTf_lesson: 2, // 最小-课程
		// 联系人
		curDataVerContact_contact: 1, // 当前-联系人
		minDataVerContact_contact: 1, // 最小-联系人
		curDataVerContact_vcard: 1, // 当前-名片
		minDataVerContact_vcard: 1, // 最小-名片
		curDataVerContact_group: 1, // 当前-群组
		minDataVerContact_group: 1, // 最小-群组
		curDataVerContact_grouprel: 1, // 当前-群组关系
		minDataVerContact_grouprel: 1, // 最小-群组关系
		// 使用记录和共享记录
		curDataVer_userecord: 1, // 当前-使用记录
		minDataVer_userecord: 1, // 最小-使用记录
		
		//--------------------------- 数据版本-分享
		// 时间流
		curShareDataVerTf_task: 1, // 当前-待办
		minShareDataVerTf_task: 1, // 最小-待办
		curShareDataVerTf_comm: 1, // 当前-纪念日
		minShareDataVerTf_comm: 1, // 最小-纪念日
		curShareDataVerTf_lesson: 1, // 当前-课程表
		minShareDataVerTf_lesson: 1, // 最小-课程表
		// 联系人
		curShareDataVerContact_contact: 1, // 当前-联系人
		minShareDataVerContact_contact: 1, // 最小-联系人
		curShareDataVerContact_vcard: 1, // 当前-名片
		minShareDataVerContact_vcard: 1, // 最小-名片
		
		//--------------------------- 消息（本地）
		//本地消息标记
		localMsg_flag_unRead: 0, // 未读
		localMsg_flag_read: 1,   // 已读
		
		// 本地消息类型
		localMsgType_taskStatis : 1, //待办统计
		localMsgType_backUpToPC : 2,   //数据备份到PC
		localMsgType_clearCache : 3,   //数据清理
		localMsgType_sysCalendar : 4,   //读取日历,
		localMsgType_taskStatisYear : 5, //待办统计（年度）
		localMsgType_sysCalNotify : 6, //系统日历提醒
		// 数据同步相关
		localMsgType_syncTfFail : 7, //时间流同步失败
		localMsgType_syncTfBreak : 8, //时间流同步异常中断
		localMsgType_syncContactFail : 9, //联系人同步失败
		localMsgType_syncContactBreak : 10, //联系人同步异常中断
		localMsgType_autoSyncData : 11, //自动同步
		localMsgType_syncExpFail : 12, //信息库同步失败
		localMsgType_syncExpBreak : 13, //信息库同步异常中断
		localMsgType_syncAllBreak : 14, //整体同步异常中断
		
		//---------------------------- 消息中心
		msgCenterSource_tf: 1, // 来源-时间流
		msgCenterSource_contact: 2, // 来源-联系人
		msgCenterSource_local: 3, // 来源-本地消息
		
		msgCenterMsgType_share: 1, // 消息类型-分享
		msgCenterMsgType_commu: 2, // 消息类型-沟通
		
		msgCenterMsgStatus_unread: 0, // 消息状态-未读
		msgCenterMsgStatus_read: 1, // 消息状态-已读
		
		//---------------------------- 沟通
		// 沟通室是否存在云端
		commuRoomExistOnCl_no: 0, // 沟通室未存在云端
		commuRoomExistOnCl_yes: 1, // 沟通室存在云端
		
		// 参与人角色
		commuMemberRole_org: 1, // 发起人
		commuMemberRole_join: 2, // 参与人
		
		// 参与方式
		commuJoinWay_org: 1, // 发起
		commuJoinWay_share: 2, // 分享
		commuJoinWay_invite: 3, // 邀请
		
		// 消息访问方式
		commuMsgVisitType_all: 1, // 全部
		commuMsgVisitType_some: 2, // 指定一些
		
		// 消息业务类型
		commuMsgBsnType_dis: 1, // 讨论消息
		commuMsgBsnType_join: 2, // 加入成员消息
		commuMsgBsnType_leaveMsg: 3, // 留言消息
		commuMsgBsnType_reply: 4, // 回执消息
		commuMsgBsnType_infoChange: 5, // 修改信息通知消息
		
		// 消息数据类型
		commuMsgDataType_text: "text/plain", // 纯文本
		commuMsgDataType_json: "text/json", // json
		
		// 消息处理状态
		commuMsgHandleState_no: 0, // 未处理
		commuMsgHandleState_yes: 1, // 已处理
		commuMsgHandleState_ignore: 2, // 已忽略
		
		// 消息处理状态
		commuPushState_no: 0, // 不推送
		commuPushState_yes: 1, // 推送
		
		// 安卓桌面小部件（操作事件类型）
		widgetOperType_add: 0, // 添加待办
		widgetOperType_look: 1, // 查看待办
		
		import_notify : "import_notify", //导入联系人提示
			
		cydowServiceId: "59c3481043a10343a100c3eb" //客服（大慧小影）数据id
	}
	
	return {
		getConstant:function(name){
			return constants[name];
		}
	}
})();


module.exports.getConstants = function(_key){
	return Constants.getConstant(_key);
};