/**
 * 清理数据记录
 * 
 * @Author : Cydow
 * @Timestamp : 2019-03-08
 */
//引入组件库
var deviceone = require("deviceone");

//工具
var tools = require("tools");
//数据库
var localdb = deviceone.mm("M0026_sqlite", "localdb", "app");

/**
 * 通过id查询一条清理数据的记录
 * @param _id
 * @returns
 */
function queryDataClearRecordById(_id){
	var sql = "select * from dataclear_record where id=" + 
		tools.formatSqlValue(_id) +  ";";
	var _data = localdb.querySync(sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data[0];
}

// 通过id查询一条清理数据的记录
module.exports.queryDataClearRecordById = function(_id){
	return queryDataClearRecordById(_id);	
};

/**
 * 获取向清理数据记录表中插入一条数据sql语句
 * @param _changedData
 */
function getInsertDataClearRecordSql(_changedData){
	var _nowTime = new Date();
	var _sql_insert = "insert into dataclear_record(id, moduleid, infocategory, createtime) values("
		+ tools.formatSqlValue(_changedData.id) + ","
		+ tools.formatSqlValue(_changedData.moduleid) + ", "
		+ _changedData.infocategory + ", "
		+ _nowTime.getTime() + ");";
	return _sql_insert;
}

// 获取向清理数据记录表中插入一条数据sql语句
module.exports.getInsertDataClearRecordSql = function(_changedData){
	return getInsertDataClearRecordSql(_changedData);	
};

/**
 * 向清理数据记录表中插入一条数据
 * @param _changedData
 */
function insertDataClearRecord(_changedData){
	var _sql_insert = getInsertDataClearRecordSql(_changedData);
	var isSuccess = localdb.executeSync(_sql_insert);
	return isSuccess;
}

//向清理数据记录表中插入一条数据
module.exports.insertDataClearRecord = function(_changedData){
	return insertDataClearRecord(_changedData);	
};