/**
 * 纪念日
 * 
 * @Author : Cydow
 * @Timestamp : 2017-02-22
 */
var deviceone = require("deviceone");
// 数据库操作-周期
var dbcycle = require("dbcycle");
// 数据库操作-数据同步
var dbclsyncdata = require("dbclsyncdata");
//数据库操作-沟通
var dbcommumain = require("dbcommumain.ui");

var objectId = require("objectId");       //生成objectId
var tools = require("tools");             //工具
var constants = require("constants");     //常量
var notificationTools = require("notificationTools"); //设置提醒
var widgetTools = require("widgetTools.ui"); // 小部件工具
var calendar = require("calendar"); // 日期
var jsonTools = require("jsonTools");//json工具
var colorconstants = require("source://view/timeFlow/script/colorconstants.ui");//信息类型常量

// 数据库
var localdb = deviceone.mm("M0026_sqlite", "localdb", "app");

//信息类型
var infoCategoryComm = constants.getConstants("infoCategory_comm");

//业务模块ID
var moduleId = constants.getConstants("moduleType_timeflow");

var colors = {
		colors_uncompleted: colorconstants.colorConstants["card_orange"],
		colors_completed: colorconstants.colorConstants["card_grey"]
} 

/**
 * 通过id从mytask表中获取指定的一条数据
 * 
 * @param _id
 * @returns
 */
function get_mytaskOneData(_id) {
	var _sql = "select * from mytask where id=" + tools.formatSqlValue(_id)
			+ ";";
	var _data = localdb.querySync(_sql);
	if (_data == null || _data.length <= 0) {
		return null;
	}
	return _data[0];
}

// 通过id获取一条纪念日数据
module.exports.get_mytaskOneData = function(_id){
	return get_mytaskOneData(_id);	
};

/**
 * 插入一条纪念日数据
 * @param _changedData
 * @param _isRecord
 * @param _isSync
 * @returns
 */
function insertCommDayData(_changedData, _isRecord, _isSync) {
	var _nowTime = new Date();
	if(_changedData.id == null) {
		_changedData.id = objectId.getObjectId();
	}
	if(_changedData.calendartype == null){
		_changedData.calendartype = constants.getConstants("calendartype_greg");
	}
	if(_changedData.cycleid == null) {
		_changedData.cycleid = 8;
	}
	if(_changedData.cyclerecordid == null) {
		_changedData.cyclerecordid = objectId.getObjectId();
	}
	if(_changedData.source == null) {
		_changedData.source = constants.getConstants("dataSource_create");
	}
	if(_changedData.colors == null){
		_changedData.colors = jsonTools.jsonObjToStr(colors);
	}
	if(_changedData.deleted == null) {
		_changedData.deleted = 0;
	}
	if(_changedData.origin == null) {
		_changedData.origin = "";
	}
	if(_changedData.presrc == null) {
		_changedData.presrc = "";
	}
	if(_changedData.morefields == null) {
		_changedData.morefields = "";
	}
	if(_changedData.create_time == null) {
		_changedData.create_time = _nowTime.getTime();
	}
	if(_changedData.update_time == null) {
		_changedData.update_time = _nowTime.getTime();
	}
	if(_changedData.sync_count == null) {
		_changedData.sync_count = 1;
	}
	_changedData.sync_count = tools.getSyncSequence();
	_changedData.notifyid = tools.getNotifyId();
	var _sql_insert = "insert into mytask(id, infoid, commname, type, start," +
			" commtime, calendartype, remindtime, commcreateby, " +
			"commservice, commcretime, commevent, commproc, cycleid, " +
			"cyclerecordid, infocategory, create_time, update_time, " +
			"sync_count, notifyid, source, colors, deleted, origin, " +
			"presrc, morefields) values("
			+ tools.formatSqlValue(_changedData.id) + ","
			+ tools.formatSqlValue(_changedData.infoid) + ","
			+ tools.formatSqlValue(_changedData.commname) + ","
			+ tools.formatSqlValue(_changedData.type) + ","
			+ _changedData.start + "," // 开始时间（纪念日的显示时间），用于start字段升序查询数据
			+ _changedData.commtime + ","
			+ tools.formatSqlValue(_changedData.calendartype) + "," // 历法类型
			+ _changedData.remindtime + ","
			+ tools.formatSqlValue(_changedData.commcreateby) + ","
			+ tools.formatSqlValue(_changedData.commservice) + ","
			+ _changedData.commcretime + ","
			+ tools.formatSqlValue(_changedData.commevent) + ","
			+ tools.formatSqlValue(_changedData.commproc) + ","
			+ _changedData.cycleid + ","
			+ tools.formatSqlValue(_changedData.cyclerecordid) + ","
			+ infoCategoryComm + ","
			+ _changedData.create_time + ","
			+ _changedData.update_time + ","
			+ _changedData.sync_count + ","
			+ _changedData.notifyid + ","
			+ tools.formatSqlValue(_changedData.source) + ","
			+ tools.formatSqlValue(_changedData.colors) + ","
			+ _changedData.deleted + ","
			+ tools.formatSqlValue(_changedData.origin) + ","
			+ tools.formatSqlValue(_changedData.presrc) + ","
			+ tools.formatSqlValue(_changedData.morefields) + ");";
	var isSuccess = localdb.executeSync(_sql_insert);
	if (isSuccess) {
		//设置本地提醒
		notificationTools.setCommNotification(_changedData, true, "add");
		
		if (_isRecord) {
			// 更新记录
			var _updRecord = {
					id: _changedData.id,
					moduleid: moduleId,
					recordtype: constants.getConstants("recordType_create"), 
					datatype: constants.getConstants("datatype_timecard")
				};
			// 设置更新记录
			if(_isSync){
				dbclsyncdata.setUpdRecordUnHandle(_updRecord);
			} else {
				dbclsyncdata.setUpdRecord(_updRecord);
			}
		}
	}
	return isSuccess;
}

/**
 * 初始化并插入一条纪念日数据
 * @param _changedData
 * @param _isSync
 * @param _isRecord
 * @returns
 */
function initAndInsertCommDayData(_changedData, _isSync, _isRecord) {
	var _nowTime = new Date();
	var _nowYear = _nowTime.getFullYear();
	var _nowMonth = _nowTime.getMonth() + 1;
	var _nowDay = _nowTime.getDate();
	var _commTime = new Date();
	_commTime.setTime(_changedData.commtime);
	var _commYear = _commTime.getFullYear();
	var _commMonth = _commTime.getMonth() + 1;
	var _commDay = _commTime.getDate();
	var _commStart = _commTime;
	if (_nowYear > _commYear) {
		//如果纪念年份小于今年，不管日期如何，均显示今年的卡片。
		_commStart = _nowTime;
	}
	// 若历法类型值为空，则默认取值为公历
	if(null == _changedData.calendartype || 
			"" == _changedData.calendartype){
		_changedData.calendartype = constants.getConstants("calendartype_greg");
	}
	// 获取纪念日卡片显示时间
	_commStart = calendar.getCycleTimeOfComm({
		commtime: _commTime, 
		updtime: _commStart, 
		calendartype: _changedData.calendartype, 
		isnow: true
	});
	
	var _id = objectId.getObjectId();
	if(null != _changedData.id){
		_id = _changedData.id;
	} else {
		_changedData.id = _id;
	}
	var _cycleRecordId = objectId.getObjectId();
	var _cycleData = {
		id: _id,
		infoid: _id,
		commname: _changedData.commname,
		start: _commStart.getTime(),
		type: _changedData.type,
		commtime: _changedData.commtime,
		calendartype: _changedData.calendartype,
		remindtime: _changedData.remindtime,
		commcreateby: _changedData.commcreateby,
		commservice: _changedData.commservice,
		commcretime: _changedData.commcretime,
		commevent: _changedData.commevent,
		commproc: _changedData.commproc,
		cycleid: _changedData.cycleid,
		cyclerecordid: _cycleRecordId,
		source: _changedData.source,
		colors: _changedData.colors,
		origin: _changedData.origin,
		presrc: _changedData.presrc,
		morefields: _changedData.morefields,
		create_time: _changedData.create_time,
		update_time: _changedData.update_time
	};
	print("_cycleData " + JSON.stringify(_cycleData));
	//判断数据来源字段是否为空
	if('undefine' != _changedData.source &&
			null != _changedData.source){
		_cycleData.source = _changedData.source;
	}
	// 在周期性记录表增加一条记录
	var _cycleRecordData = {
		id : _cycleRecordId,
		taskid : _id,
		starttime : _cycleData.start,
		updtime : _cycleData.start,
		cycleid : 8,
		count : 0,
		infocategory : infoCategoryComm
	};
	dbcycle.insert_cycleRecordData(_cycleRecordData);
	
	// 插入一条纪念日数据
	return insertCommDayData(_cycleData, _isRecord, _isSync);
}

// 新建纪念日数据
module.exports.insert_commDay = function(_changedData) {
	var _isSuc = initAndInsertCommDayData(_changedData, true, true);
	// 刷新视图（桌面小部件）
	widgetTools.refresh();	
	return _isSuc;
};

// 新建纪念日数据-数据同步
module.exports.insertCommDaySyncData = function(_changedData) {
	var _colors = colors;
	if(null != _changedData.colors){
		_colors = {
				colors_uncompleted: _changedData.colors.color1,
				colors_completed: _changedData.colors.color2
		};
	}
	_changedData.colors = jsonTools.jsonObjToStr(_colors);
	
	var _isSuc = initAndInsertCommDayData(_changedData, false, true);
	// 刷新视图（桌面小部件）
	widgetTools.refresh();	
	return _isSuc;
};

//新建纪念日数据-信息库同步
module.exports.insertCommDayExpSync = function(_changedData, _record) {
	var _isSuc = initAndInsertCommDayData(_changedData, false, false);
	// 更新记录
	var _updRecord = {
			id: _changedData.id,
			moduleid: moduleId,
			recordtime: _record.recordtime,
			recordtype: constants.getConstants("recordType_create"), 
			datatype: constants.getConstants("datatype_timecard")
		};
	// 设置更新记录-已同步
	dbclsyncdata.setUpdRecord(_updRecord);
	return _isSuc;
};

// 增量插入纪念日数据（从周期记录表中获取纪念日源数据id，若满足生成规则，则生成纪念日数据）
var commLengthTime = 30 * 24 * 3600 * 1000;
function insert_commDayBySource(_changedData, _cycleRecordData) {
	var _taskid = _cycleRecordData.taskid;
	var _count = parseInt(_cycleRecordData.count);
	var isChanged = false;
	var _nowTime = new Date();
	var _nowTimeTemp = _nowTime.getTime();
	var _commTime = new Date();
	_commTime.setTime(parseInt(_changedData.commtime));
	var _updTime = new Date();
	_updTime.setTime(parseInt(_cycleRecordData.updtime));
	// 获取下个周期（重复）显示时间
	_updTime = calendar.getCycleTimeOfComm({
		commtime: _commTime,
		updtime: _updTime,
		calendartype: _changedData.calendartype,
		isnow: false
	});
	var _updTimeTemp = _updTime.getTime() - commLengthTime;
	while (_nowTimeTemp >= _updTimeTemp) {
		_changedData.id = tools.createTaskId(_taskid, ++_count);
		_changedData.start = _updTime.getTime();

		// 插入一条纪念日数据
		insertCommDayData(_changedData, false, false);

		// 获取下个周期（重复）显示时间
		_updTime = calendar.getCycleTimeOfComm({
			commtime: _commTime,
			updtime: _updTime,
			calendartype: _changedData.calendartype,
			isnow: false
		});
		_updTimeTemp = _updTime.getTime() - commLengthTime;
		isChanged = true;
	}

	if (isChanged) {
		var _cycleRecord = {
			id : _cycleRecordData.id,
			updtime : _changedData.start,
			count: _count
		};
		// 更新周期记录表指定id的数据
		dbcycle.update_cycleRecordData(_cycleRecord);
	}
};

// 增量插入纪念日数据（从周期记录表中获取纪念日源数据id，若满足生成规则，则生成纪念日数据）
module.exports.insert_commDayBySource = function(_changedData, _cycleRecordData) {
	insert_commDayBySource(_changedData, _cycleRecordData);
	// 刷新视图（桌面小部件）
	widgetTools.refresh();
};

/**
 * 更新纪念日数据
 * @param _changedData
 * @param _isRecord
 * @param _isSync
 * @returns
 */
function updCommDayData(_changedData, _isRecord, _isSync) {
	_changedData.sync_count = tools.getSyncSequence();
	var _setList = "";
	if (_changedData.commname != null) {
		if (_setList.length > 0)
			_setList += ",";
		_setList += "commname=" + tools.formatSqlValue(_changedData.commname);
	}
	if (_changedData.type != null) {
		if (_setList.length > 0)
			_setList += ",";
		_setList += "type=" + tools.formatSqlValue(_changedData.type);
	}
	if (_changedData.commtime != null) {
		if (_setList.length > 0)
			_setList += ",";
		_setList += "commtime=" + _changedData.commtime;
	}
	if (_changedData.calendartype != null) {
		if (_setList.length > 0)
			_setList += ",";
		_setList += "calendartype=" + tools.formatSqlValue(_changedData.calendartype);
	}
	if (_changedData.remindtime != null) {
		if (_setList.length > 0)
			_setList += ",";
		_setList += "remindtime=" + _changedData.remindtime;
	}
	if (_changedData.start != null) {
		if (_setList.length > 0)
			_setList += ",";
		_setList += "start=" + _changedData.start;
	}
	if (_changedData.commcretime != null) {
		if (_setList.length > 0)
			_setList += ",";
		_setList += "commcretime=" + _changedData.commcretime;
	}
	if (_changedData.commcreateby != null) {
		if (_setList.length > 0)
			_setList += ",";
		_setList += "commcreateby="
				+ tools.formatSqlValue(_changedData.commcreateby);
	}
	if (_changedData.commservice != null) {
		if (_setList.length > 0)
			_setList += ",";
		_setList += "commservice="
				+ tools.formatSqlValue(_changedData.commservice);
	}
	if (_changedData.commevent != null) {
		if (_setList.length > 0)
			_setList += ",";
		_setList += "commevent=" + tools.formatSqlValue(_changedData.commevent);
	}
	if (_changedData.commproc != null) {
		if (_setList.length > 0)
			_setList += ",";
		_setList += "commproc=" + tools.formatSqlValue(_changedData.commproc);
	}
	if (_changedData.source != null) {
		if (_setList.length > 0)
			_setList += ",";
		_setList += "source=" + tools.formatSqlValue(_changedData.source);
	}
	if (_changedData.colors != null) {
		if (_setList.length > 0)
			_setList += ",";
		_setList += "colors=" + tools.formatSqlValue(_changedData.colors);
	}
	if (_changedData.origin != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "origin=" + tools.formatSqlValue(_changedData.origin);
	}
	if (_changedData.presrc != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "presrc=" + tools.formatSqlValue(_changedData.presrc);
	}
	if (_changedData.morefields != null) {
		if (_setList.length > 0)
			_setList += ",";
		_setList += "morefields=" + tools.formatSqlValue(_changedData.morefields);
	}
	if (_changedData.update_time != null) {
		if (_setList.length > 0)
			_setList += ",";
		_setList += "update_time=" + _changedData.update_time;
	}
	if (_changedData.sync_count != null) {
		if (_setList.length > 0)
			_setList += ",";
		_setList += "sync_count=" + _changedData.sync_count;
	}
	if (_setList.length <= 0)
		return;
	var _sql_update = "";
	_sql_update = "update mytask set " + _setList + " where id="
			+ tools.formatSqlValue(_changedData.id) + ";";
	var isSuccess = localdb.executeSync(_sql_update);
	if (isSuccess) {
		//设置本地提醒
		notificationTools.setCommNotification(_changedData, true, "update");
		
		if(_isRecord){
			// 更新记录
			var _updRecord = {
					id: _changedData.id,
					moduleid: moduleId,
					recordtype: constants.getConstants("recordType_update"), 
					datatype: constants.getConstants("datatype_timecard")
				};
			// 设置更新记录
			if(_isSync){
				dbclsyncdata.setUpdRecordUnHandle(_updRecord);
			} else {
				dbclsyncdata.setUpdRecord(_updRecord);
			}
		}
	}
	return isSuccess;
}

/**
 * 更新指定纪念日所有数据
 * @param _changedData
 * @param _isSync
 * @param _isRecord
 * @returns
 */
function updCommDayAllData(_changedData, _isSync, _isRecord) {
	// 获取更新前的数据
	var _oldData = get_mytaskOneData(_changedData.id);
	var _cycleRecord = dbcycle.query_cycleRecordOneData(_oldData.cyclerecordid);
	var isSuccess = false;

	// 判断历法类型是否为空
//	if(null == _changedData.calendartype){
//		_changedData.calendartype = _oldData.calendartype;
//	}
	
	// 判断纪念日期是否改变
	var _isChangedCommTime = true;
	if (_oldData.commtime == _changedData.commtime &&
			_oldData.calendartype == _changedData.calendartype) {
		_isChangedCommTime = false;
	}
	var _nowTime = new Date();
	//当前年
	var _nowYear = _nowTime.getFullYear();
	var _commTime = new Date();
	_commTime.setTime(parseInt(_changedData.commtime));
	//修改后的纪念日期-年，月，日
	var _commYear = _commTime.getFullYear();
	var _commMonth = _commTime.getMonth() + 1;
	var _commDay = _commTime.getDate();
	var _commHours = _commTime.getHours();
	var _commMinutes = _commTime.getMinutes();
	var _commSeconds = _commTime.getSeconds();
	var _commMill = _commTime.getMilliseconds();
	var _commDataList = query_commDayDataByCycleRecordId(_cycleRecord.id);
	//标识是否存在今年的卡片
	var haveCurrYearCard = false;
	var currYearCardId = "";
	//标识是否存在未来的卡片
	var futureYearCardId = "";
	var haveFutureYearCard = false;
	_nowTime.setTime(parseInt(_cycleRecord.updtime));
	// 周期（重复）时间
	var _updTime = _nowTime.getTime();
	// 当前重复卡片数
	var _currCount = parseInt(_cycleRecord.count);
	if (_commDataList != null) {
		for (var i = 0; i < _commDataList.length; i++) {
			var _commData = _commDataList[i];
			var _commTempStart = new Date();
			_commTempStart.setTime(parseInt(_commData.start));
			var _commDataYear = _commTempStart.getFullYear();
			if(_commDataYear == _nowYear){
				currYearCardId = _commData.id;
				haveCurrYearCard = true;
			}
			if(_commDataYear > _nowYear){
				futureYearCardId = _commData.id;
				haveFutureYearCard = true;
			}
		}
	}
	//遍历该纪念日期对应周期内的所有卡片
	if (_commDataList != null) {
		for (var i = 0; i < _commDataList.length; i++) {
			var _commData = _commDataList[i];
			if (_commData == null)
				continue;
			if (_isChangedCommTime) {
				var _commTempStart = new Date();
				//当前纪念卡片的纪念日期显示时间
				_commTempStart.setTime(parseInt(_commData.start));
				var _commTempYear = _commTempStart.getFullYear();
				_commTempStart.setHours(_commHours, _commMinutes, _commSeconds, _commMill);
				//如果修改后的年份小于等于今年
				if(_commYear <= _nowYear){
					if(_commTempYear <= _nowYear){
						//今年及今年以前的卡片月份和日期做更新
						_commTempStart = calendar.getCycleTimeOfComm({
							commtime: _commTime,
							updtime: _commTempStart,
							calendartype: _changedData.calendartype,
							isnow: true
						});
						_commData.commtime = _changedData.commtime;
						_commData.start = _commTempStart.getTime();
						//最近年等于当前年
						_updTime = _commData.start;
					}else{
						// 未来的卡片，根据是不是主卡，分开处理
						if(_commData.id != _cycleRecord.taskid){
							//如果不是主卡，直接删除
							delCommDayCardData(_commData.id, false, _isSync);
						}else{
							//如果是主卡，把它的年份变更为今年的
							_commTempStart = calendar.getCycleTimeOfComm({
								commtime: _commTime,
								updtime: (new Date()),
								calendartype: _changedData.calendartype,
								isnow: true
							});
							_commData.commtime = _changedData.commtime;
							_commData.start = _commTempStart.getTime();
							//判断原list中今年的卡片是否存在
							//若存在，就把它删除
							if(haveCurrYearCard){
								delCommDayCardData(currYearCardId,
										false, _isSync);
							}
							//最近年等于当前年
							_updTime = _commData.start;
						}
					}
				}else{
					//如果修改后的年份大于今年
					if(_commTempYear <= _nowYear){
						//今年及今年以前的卡片,
						if(_commData.id != _cycleRecord.taskid){
							//如果不是主卡，直接更新即可
							_commTempStart = calendar.getCycleTimeOfComm({
								commtime: _commTime,
								updtime: _commTempStart,
								calendartype: _changedData.calendartype,
								isnow: true
							});
							_commData.commtime = _changedData.commtime;
							_commData.start = _commTempStart.getTime();
							//最近年等于当前年
							_updTime = _commData.start;
						}else{
							//如果是主卡
							//先复制一张主卡原来的年份的卡片(修改后的月和日）
							var _id = tools.createTaskId(_cycleRecord.taskid, ++_currCount);
							_commTempStart = calendar.getCycleTimeOfComm({
								commtime: _commTime,
								updtime: _commTempStart,
								calendartype: _changedData.calendartype,
								isnow: true
							});
							var _cycleData = {
									id : _id,
									infoid: _commData.infoid,
									commname : _commData.commname,
									//修改后的月，日
									start : _commTempStart.getTime(),
									type : _commData.type,
									//修改后的纪念日期
									commtime : _changedData.commtime,
									remindtime : _changedData.remindtime,
									calendartype: _changedData.calendartype,
									commcreateby : _changedData.commcreateby,
									commservice : _changedData.commservice,
									commcretime : _commData.commcretime,
									commevent : _changedData.commevent,
									commproc : _changedData.commproc,
									cycleid : _commData.cycleid,
									cyclerecordid : _cycleRecord.id,
									source: _commData.source,
									colors: _changedData.colors,
									origin: _changedData.origin,
									presrc: _changedData.presrc,
									morefields: _changedData.morefields,
									create_time: _commData.create_time,
									update_time: _changedData.update_time
							};
							insertCommDayData(_cycleData, false, false);
							//新增完了以后，修改主卡的显示时间到未来年
							_commData.commtime = _changedData.commtime;
							_commData.start = _changedData.commtime;
							//最近年等于修改到的未来年
							_updTime = _commData.start;
						}
					}else{
						//未来的卡片
						if(_commData.id != _cycleRecord.taskid){
							//不是主卡，直接删除
							delCommDayCardData(_commData.id, false, _isSync);
						}else{
							//是主卡的话，年月日全部更新，更新成新修改成的日期
							_commData.commtime = _changedData.commtime;
							_commData.start = _changedData.commtime;
							//最近年等于修改到的未来年
							_updTime = _commData.start;
						}
					}
				}
			}
			_commData.calendartype = _changedData.calendartype;
			_commData.commname = _changedData.commname;
			_commData.type = _changedData.type;
			_commData.commcreateby = _changedData.commcreateby;
			_commData.commcretime = _changedData.commcretime;
			_commData.commservice = _changedData.commservice;
			_commData.commevent = _changedData.commevent;
			_commData.commproc = _changedData.commproc;
			_commData.remindtime = _changedData.remindtime;
			_commData.source = _changedData.source;
			_commData.colors = _changedData.colors;
			_commData.origin = _changedData.origin;
			_commData.presrc = _changedData.presrc;
			_commData.morefields = _changedData.morefields;
			_commData.update_time = _changedData.update_time;
			if(_cycleRecord.taskid == _commData.id){
				isSuccess = updCommDayData(_commData, _isRecord, _isSync);
			} else {
				updCommDayData(_commData, false, _isSync);
			}
		}
		//只有时间变化了，才更新周期性记录表
		if(_isChangedCommTime){
			var _start = new Date();
			_start.setTime(parseInt(_cycleRecord.starttime));
			_start.setHours(_commHours, _commMinutes, _commSeconds, _commMill);
			_start = calendar.getCycleTimeOfComm({
				commtime: _commTime,
				updtime: _start,
				calendartype: _changedData.calendartype,
				isnow: true
			});
			var _cycleRecordData = {
				id : _cycleRecord.id,
				starttime : _start.getTime(),
				updtime : _updTime,
				count: _currCount
			};
			// 更新周期记录表指定id的数据
			dbcycle.update_cycleRecordData(_cycleRecordData);
			_cycleRecord.starttime = _cycleRecordData.starttime;
			_cycleRecord.updtime = _cycleRecordData.updtime;
			_cycleRecord.count = _cycleRecordData.count;
		}
		var _commChangedData = {
			id : _changedData.id,
			infoid: _oldData.infoid,
			commname : _changedData.commname,
			type : _changedData.type,
			commtime : _changedData.commtime,
			start : _oldData.start,
			remindtime : _changedData.remindtime,
			calendartype : _changedData.calendartype,
			commcretime : _changedData.commcretime,
			commcreateby : _changedData.commcreateby,
			commservice : _changedData.commservice,
			commevent : _changedData.commevent,
			commproc : _changedData.commproc,
			cycleid : _oldData.cycleid,
			cyclerecordid : _oldData.cyclerecordid,
			infocategory : _oldData.infocategory,
			source: _oldData.source,
			colors: _oldData.colors,
			origin: _changedData.origin,
			presrc: _changedData.presrc,
			morefields: _changedData.morefields,
			create_time : _oldData.create_time,
			update_time : _changedData.update_time
		};
		insert_commDayBySource(_commChangedData, _cycleRecord);
	}
	return isSuccess;
}

// 更新纪念日数据
module.exports.update_commDay = function(_changedData) {
	var _isSuccess = updCommDayAllData(_changedData, true, true);
	// 刷新视图（桌面小部件）
	widgetTools.refresh();
	return _isSuccess;
};

//更新纪念日数据-数据同步
module.exports.updCommDaySyncData = function(_changedData) {
	if(null != _changedData.colors){
		var _colors = {
				colors_uncompleted: _changedData.colors.color1,
				colors_completed: _changedData.colors.color2
		};
		_changedData.colors = jsonTools.jsonObjToStr(_colors);
	}
	var _isSuccess = updCommDayAllData(_changedData, false, true);
	// 刷新视图（桌面小部件）
	widgetTools.refresh();
	return _isSuccess;
};

//更新纪念日数据-信息同步
module.exports.updCommDayExpSync = function(_changedData, _record) {
	var _isSuccess = updCommDayAllData(_changedData, false, false);
	// 更新记录
	var _updRecord = {
			id: _changedData.id,
			moduleid: moduleId,
			recordtime: _record.recordtime,
			recordtype: constants.getConstants("recordType_update"), 
			datatype: constants.getConstants("datatype_timecard")
		};
	if(_record.handlestate){
		// 设置更新记录-已同步
		dbclsyncdata.setUpdRecord(_updRecord);
	} else {
		// 设置更新记录-未同步
		dbclsyncdata.setUpdRecordUnHandle(_updRecord);
	}
	return _isSuccess;
};

/**
 * 删除纪念日卡片数据
 * @param _id
 * @param _isRecord
 * @param _isSync
 * @returns
 */
function delCommDayCardData(_id, _isRecord, _isSync) {
	//移除本地提醒
	var _sql = "select notifyid,origin from mytask where id="
		+ tools.formatSqlValue(_id) + ";";
	var _commData = localdb.querySync(_sql);
	var _origin = null;
	if(null != _commData && 
			_commData.length > 0){
		notificationTools.removeLocalNotification([parseInt(_commData[0].notifyid)], 
				[_id]);
		_origin = _commData[0].origin;
	}	
	
	_sql = "delete from mytask where id="
		+ tools.formatSqlValue(_id) + ";";
	var isSuccess = localdb.executeSync(_sql);

	if (isSuccess) {
		if (_isRecord) {
			// 更新记录
			var _updRecord = {
					id: _id,
					moduleid: moduleId,
					recordtype: constants.getConstants("recordType_delete"), 
					datatype: constants.getConstants("datatype_timecard")
				};
			// 设置更新记录
			if(_isSync){
				dbclsyncdata.setUpdRecordUnHandle(_updRecord);
			} else {
				dbclsyncdata.setUpdRecord(_updRecord);
			}
		}
		// 删除沟通室相关的数据
		dbcommumain.delCommuRoomDataByOrigin(_id, _origin);
	}
	return isSuccess;
}

/**
 * 删除纪念日的所有卡片数据
 * @param _cycleRecordId
 * @param _isSync
 * @param _isRecord
 * @returns
 */
function delCommDayAllCardData(_cycleRecordId, _isSync, _isRecord) {
	var isSuccess = false;
	var _cycleRecord = dbcycle.query_taskidByCycleRecordId(_cycleRecordId);
	if (null != _cycleRecord) {
		var _commDataList = query_commDayDataIdByCycleRecordId(_cycleRecordId);
		if (null != _commDataList) {
			for (var i = 0; i < _commDataList.length; i++) {
				var _id = _commDataList[i].id;
				if (null == _id || _id == _cycleRecord.taskid)
					continue;
				delCommDayCardData(_id, false, _isSync);
			}
		}
		// 删除周期记录表对应记录
		dbcycle.delete_cyclerecordDataById(_cycleRecordId);

		// 删除纪念日数据
		isSuccess = delCommDayCardData(_cycleRecord.taskid,
				_isRecord, _isSync);
	}
	return isSuccess;
}

/**
 * 删除纪念日
 * @param _id
 * @param _cycleRecordId
 * @returns
 */
function delCommDay(_id, _cycleRecordId){
	var _taskIdObj = dbcycle.query_taskidByCycleRecordId(_cycleRecordId);
	if(null == _taskIdObj){
		delCommDayCardData(_id, true, true);
	} else {
		//删除对应的所有纪念日数据
		delCommDayAllCardData(_cycleRecordId, false, true);
	}
	// 刷新视图（桌面小部件）
	widgetTools.refresh();
}

// 删除mytask表中指定id的纪念日的所有数据
module.exports.delCommDay = function(_id, _cycleRecordId) {
	delCommDay(_id, _cycleRecordId);
};

/**
 * 删除指定纪念日的所有卡片数据-数据同步
 * @param _id
 * @returns
 */
function delCommDaySyncData(_id, _isSync, _isRecord){
	var _isSuc = false;
	var _cycleRecord = dbcycle.query_cycleRecordOneDataByTaskId(_id);
	if(null == _cycleRecord){
		_isSuc = delCommDayCardData(_id, _isRecord, _isSync);
	} else {
		_isSuc = delCommDayAllCardData(_cycleRecord.id, _isSync, _isRecord);
	}
	// 刷新视图（桌面小部件）
	widgetTools.refresh();
	return _isSuc;
}

// 删除指定纪念日的所有卡片数据-数据同步
module.exports.delCommDaySyncData = function(_id) {
	return delCommDaySyncData(_id, false, true);
};

// 删除指定纪念日的所有卡片数据-信息库同步
module.exports.delCommDayExpSync = function(_id, _record) {
	var _result = delCommDaySyncData(_id, false, false);
	// 更新记录
	var _updRecord = {
			id: _id,
			moduleid: moduleId,
			recordtime: _record.recordtime,
			recordtype: constants.getConstants("recordType_delete"), 
			datatype: constants.getConstants("datatype_timecard")
		};
	// 设置更新记录-已同步
	dbclsyncdata.setUpdRecord(_updRecord);
	return _result;
};

/**
 * 通过cyclerecordid从mytask表中获取对应的纪念日数据
 * 
 * @param cyclerecordid
 * @returns
 */
function query_commDayDataByCycleRecordId(_cycleRecordId) {
	var sql = "select * from mytask where cyclerecordid="
			+ tools.formatSqlValue(_cycleRecordId) + "order by start ASC;";
	var _data = localdb.querySync(sql);
	if (_data == null || _data.length <= 0) {
		return null;
	}
	return _data;
}

/**
 * 通过cyclerecordid从mytask表中获取对应的纪念日数据id
 * 
 * @param cyclerecordid
 * @returns
 */
function query_commDayDataIdByCycleRecordId(_cycleRecordId) {
	var sql = "select id from mytask where cyclerecordid="
			+ tools.formatSqlValue(_cycleRecordId) + "order by start ASC;";
	var _data = localdb.querySync(sql);
	if (_data == null || _data.length <= 0) {
		return null;
	}
	return _data;
}

/**
 * 异步查询指定条件和字段的卡片信息
 * @param _fields
 * @param _conditions
 * @param _callFunc
 * @returns
 */
function query_commFieldsByCondition(_fields, _conditions, _callFunc){
	var _sql ="select " +  _fields + " from mytask where infocategory="
		+ infoCategoryComm + " and ";
	if(null != _conditions && _conditions.length > 0){
		_sql += _conditions;
		localdb.query({sql: _sql}, function(_data){
			_callFunc.call(this, _data);
		});
	} else {
		_callFunc.call(this, null);
	}
}

// 异步查询指定条件和字段的卡片信息
module.exports.query_commFieldsByCondition = function(_fields, _condition, _callFunc){
	query_commFieldsByCondition(_fields, _condition, _callFunc);
};

/**
 * 查询指定纪念日数据来源字段信息
 * @param _id
 * @returns
 */
function query_commFeildSourceById(_id){
	var sql = "select source from mytask where id="
		+ tools.formatSqlValue(_id) + ";";
	var _data = localdb.querySync(sql);
	if (_data == null || _data.length <= 0) {
		return null;
	}
	return _data;
}

// 查询指定纪念日数据来源字段信息
module.exports.query_commFeildSourceById = function(_id){
	return query_commFeildSourceById(_id);
};

/**
 * 查询指定条件（id标识、类型和纪念日名称）下纪念日数据--用于同一个类型下重名判断
 * @param _id
 * @param _type
 * @param _title
 * @returns
 */
function query_commDataByTypeName(_id, _type, _name){
	var _sql ="select id from mytask where type=" 
		+ tools.formatSqlValue(_type); 
	_sql += " and commname=" + tools.formatSqlValue(_name);
	_sql += " and id not like " + tools.formatSqlValue(_id + "%") + " limit 1;";
	var _data = localdb.querySync(_sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data[0];
}

// 查询指定条件（id标识、类型和纪念日名称）下纪念日数据--用于同一个类型下重名判断
module.exports.query_commDataByTypeName = function(_id, _type, _name){
	return query_commDataByTypeName(_id, _type, _name);
};

/**
 * 查询纪念日主卡的id标识
 * @param _id
 * @returns
 */
function queryCommMainCardId(_id, _cycleRecordId){
	if(null == _cycleRecordId){
		var _commData = get_mytaskOneData(_id);
		if(null != _commData){
			_cycleRecordId = _commData.cyclerecordid;
		}
	}
	if(null != _cycleRecordId &&
			"" != _cycleRecordId){
		var _cycleRecordData = dbcycle.query_taskidByCycleRecordId(_cycleRecordId);
		if(null != _cycleRecordData){
			_id = _cycleRecordData.taskid;
		}
	}
	return _id;
}

// 查询纪念日主卡的id标识
module.exports.queryCommMainCardId = function(_id, _cycleRecordId){
	return queryCommMainCardId(_id, _cycleRecordId);
};
