/**
 * 联系人属性表
 * 
 * @Author : Cydow
 * @Timestamp : 2017-12-04
 */
//引入组件库
var deviceone = require("deviceone");

//工具
var tools = require("tools");

//数据库
var localdb = deviceone.mm("M0026_sqlite", "localdb", "app");

/**
 * 判断指定属性信息是否存在是否存在
 * @param _id
 * @param _changedData
 */
function isExistPropertiesData(_changedData){
	var _sql = "select id from contacts_properties " +
		"where id=" + tools.formatSqlValue(_changedData.id) + 
		" and type=" + tools.formatSqlValue(_changedData.type) +
		" and value=" + tools.formatSqlValue(_changedData.value) + ";";
	var _data = localdb.querySync(_sql);
	if(_data == null || _data.length <= 0){
		return false;
	}
	return true;
}

// 判断指定属性信息是否存在是否存在
module.exports.isExistPropertiesData = function(_changedData){
	return isExistPropertiesData(_changedData);	
};

/**
 * 获取插入联系人属性信息的sql语句
 * @param _id
 * @param _changedData
 */
function getInsertContactPropertySql(_id, _changedData){
	var _sql = "";
	if(null != _changedData && _changedData.length > 0){
		var _sql_insert = "insert into contacts_properties(id, type, value) values";
		var _sqls = "";
		for(var i=0; i<_changedData.length; i++){
			var _data = _changedData[i];
			if(null == _data) continue;
			if(_sqls.length > 0){
				_sqls += ",";
			}
			_sqls += "("
			_sqls +=  tools.formatSqlValue(_id) + ",";
			_sqls +=  tools.formatSqlValue(_data.type) + ",";
			_sqls +=  tools.formatSqlValue(_data.value) + ")";
		}
		if(_sqls.length > 0){
			_sqls += ";";
			_sql = _sql_insert + _sqls;
		}
	}
	return _sql;
}

//获取插入联系人属性信息的sql语句
module.exports.getInsertContactPropertySql = function(_id, _changedData){
	return getInsertContactPropertySql(_id, _changedData);	
};

/**
 * 插入联系人属性
 * @param _id
 * @param _changedData
 */
function insertContactPropData(_id, _changedData){
	var isSuccess = true;
	var _sql_insert = getInsertContactPropertySql(_id, _changedData);
	if("" != _sql_insert){
		isSuccess = localdb.executeSync(_sql_insert);
	}
	return isSuccess;
}

// 插入联系人属性
module.exports.insertContactPropData = function(_id, _changedData){
	return insertContactPropData(_id, _changedData);	
};

/**
 * 获取更新联系人属性的所有sql语句
 * @param _id
 * @param _changedData
 * @param _sqlList
 * @returns
 */
function getUpdContactPropAllSqls(_id, _changedData, _sqlList){
	// 获取删除联系人属性的sql语句
	var _sql = getDelContactPropDataSql(_id);
	_sqlList.push(_sql);
	
	// 获取插入联系人属性的sql语句
	_sql = getInsertContactPropertySql(_id, _changedData);
	if(null != _sql && 
			"" != _sql){
		_sqlList.push(_sql);
	}
}

// 获取更新联系人属性的所有sql语句
module.exports.getUpdContactPropAllSqls = function(_id, _changedData, _sqlList){
	return getUpdContactPropAllSqls(_id, _changedData, _sqlList);	
};

/**
 * 更新联系人属性
 * @param _id
 * @param _changedData
 * @returns
 */
function updContactPropData(_id, _changedData){
	var _sqlList = [];
	// 获取删除联系人属性的sql语句
	getUpdContactPropAllSqls(_id, _changedData, _sqlList);
	localdb.executeSync1(_sqlList);
}

// 更新联系人属性
module.exports.updContactPropData = function(_id, _changedData){
	return updContactPropData(_id, _changedData);	
};

/**
 * 获取删除联系人属性sql语句
 * @param _id
 * @returns
 */
function getDelContactPropDataSql(_id){
	var _sql_del = "delete from contacts_properties where id="
		+ tools.formatSqlValue(_id) + ";";
	return _sql_del;
}

//获取删除联系人属性sql语句
module.exports.getDelContactPropDataSql = function(_id){
	return getDelContactPropDataSql(_id);	
};

/**
 * 获取删除指定条件的联系人属性sql语句
 * @param _condition
 * @returns
 */
function getDelContactPropSqlByCond(_condition){
	var _sql_del = "delete from contacts_properties where " + _condition + ";";
	return _sql_del;
}

//获取删除指定条件的联系人属性sql语句
module.exports.getDelContactPropSqlByCond = function(_condition){
	return getDelContactPropSqlByCond(_condition);	
};

/**
 * 删除指定id
 * @param _id
 */
function delContactPropData(_id){
	var _sql_del = getDelContactPropDataSql(_id);
	var isSuccess = localdb.executeSync(_sql_del);
	return isSuccess;
}

//删除联系人属性表（contacts_properties）中指定id的数据
module.exports.delContactPropData = function(_id){
	return delContactPropData(_id);	
};

/**
 * 根据条件删除联系人属性
 * @param _condition
 */
function delContactPropDataByCond(_condition){
	var _sql_del = getDelContactPropSqlByCond(_condition);
	var isSuccess = localdb.executeSync(_sql_del);
	return isSuccess;
}

// 根据条件(where之后)删除联系人属性表（contacts_properties）中的数据
module.exports.delContactPropDataByCond = function(_condition){
	return delContactPropDataByCond(_condition);	
};

/**
 * 查询指定条件（_id）下联系人（或名片）属性数据
 * @param _id
 * @returns
 */
function query_contactPropertyDataById(_id){
	var _sql ="select contacts_properties.sno as sno,id,type,value,phone,cydowid " +
			"from contacts_properties left join " +
			"contacts_cydowid_relation on " +
			"contacts_properties.value = contacts_cydowid_relation.phone " + 
			"where id=" + tools.formatSqlValue(_id) + ";";
	var _data = localdb.querySync(_sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	//去掉重复电话号码
	var _propDataList = [];
	for(var i=0; i<_data.length; i++){
		var _oneData = _data[i];
		if(null == _oneData)
			continue;
		if(null != _oneData.phone &&
				"" != _oneData.phone &&
				null != _oneData.cydowid &&
				"" != _oneData.cydowid){
			var _isExist = false;
			for(var j=0; j<_propDataList.length; j++){
				var _propData = _propDataList[j];
				if(_oneData.sno == _propData.sno){
					_isExist = true;
					break;
				}
			}
			if(_isExist){
				continue;
			}
		}
		_propDataList.push(_oneData);
	}
	return _propDataList;
}

//查询指定条件（_id）下联系人（或名片）属性数据
module.exports.query_contactPropertyDataById = function(_id){
	return query_contactPropertyDataById(_id);
};

/**
 * 查询指定联系人、名片字段属性数据
 * @param _condition
 * @returns
 */
function query_propertiesByCondition(_condition){
	var sql ="select " + _condition.fields + " from contacts_properties" +
			" where id in (select id from " + _condition.tablename + 
			") " + _condition.condition + " group by id;";
	var _data = localdb.querySync(sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data;
}

//查询指定联系人、名片字段（_fields）属性数据
module.exports.query_propertiesByCondition = function(_condition){
	return query_propertiesByCondition(_condition);
};

/**
 * 查询指定条件联系人、名片字段属性数据
 * @param _condition
 * @returns
 */
function query_cydowIdAndPhoneDataByCondition(_condition){
	var _sql = "select * from contacts_properties left join " +
		"contacts_cydowid_relation on " +
		"contacts_properties.value = contacts_cydowid_relation.phone " + 
		"where " + _condition + ";";
	var _data = localdb.querySync(_sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data;
}

//查询指定条件联系人、名片字段（_fields）属性数据
module.exports.query_cydowIdAndPhoneDataByCondition = function(_condition){
	return query_cydowIdAndPhoneDataByCondition(_condition);
};

/**
 * 查询指定条件联系人、名片电话号码和邮箱数据
 * @param _condition
 * @returns
 */
function query_phoneAndEmailDataByCondition(_condition){
	var sql = "select " + _condition.fields + " from contacts_properties" +
		" where id in (select id from " + _condition.tablename + 
		") " + _condition.condition + " ;";
	var _data = localdb.querySync(sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data;
}

//查询指定条件联系人、名片字段（_fields）属性数据
module.exports.query_phoneAndEmailDataByCondition = function(_condition){
	return query_phoneAndEmailDataByCondition(_condition);
};

/**
 * 查询指定慧影号的联系人属性数据
 * @param _cydowId
 * @returns
 */
function queryPropDataByCydowId(_cydowId){
	var _sql = "select * from contacts_properties" +
		" where type='cydowid.default' and value=" +  
		tools.formatSqlValue(_cydowId) + ";";
	var _data = localdb.querySync(_sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data;
}

// 查询指定慧影号的联系人属性数据
module.exports.queryPropDataByCydowId = function(_cydowId){
	return queryPropDataByCydowId(_cydowId);
};

/**
 * 查询指定手机号的联系人属性数据
 * @param _phoneNo
 * @returns
 */
function queryPropDataByPhoneNo(_phoneNo){
	var _sql = "select * from contacts_properties" +
		" where type like 'phone%' and value=" +  
		tools.formatSqlValue(_phoneNo) + ";";
	var _data = localdb.querySync(_sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data;
}

// 查询指定手机号的联系人属性数据
module.exports.queryPropDataByPhoneNo = function(_phoneNo){
	return queryPropDataByPhoneNo(_phoneNo);
};

/**
 * 查询有慧影号，但在慧影号关系表里没有该慧影号的联系人属性数据
 * @returns
 */
function queryPropDataOnlyCydowId(){
	var _sql = "select * from contacts_properties where type like '%cydowid%' and value not in (select cydowid from contacts_cydowid_relation);"; 
	var _data = localdb.querySync(_sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data;
}

// 查询仅有慧影号的联系人属性数据
module.exports.queryPropDataOnlyCydowId = function(){
	return queryPropDataOnlyCydowId();
};
