/**
 * 电子名片
 * 
 * @Author : Cydow
 * @Timestamp : 2017-08-09
 */
//引入组件库
var deviceone = require("deviceone");

var objectId = require("objectId");      //生成objectId
var tools = require("tools");            //工具
var constants = require("constants");    //常量

//数据库
var localdb = deviceone.mm("M0026_sqlite", "localdb", "app");

/**
 * 向channel_cydow_message表中插入一条数据
 * @param _changedData
 */
function insert_messageData(_changedData){
	var _nowTime = new Date();
	if (_changedData.id == null){
		_changedData.id = objectId.getObjectId();
	}
	if (_changedData.messageid == null){
		_changedData.messageid = "";
	}
	if (_changedData.senderid == null){
		_changedData.senderid = "";
	}
	if(_changedData.sender == null){
		_changedData.sender = "";
	}
	if(_changedData.receiverid == null){
		_changedData.receiverid = "";
	}
	if(_changedData.receiver == null){
		_changedData.receiver = "";
	}
	if(_changedData.channel == null){
		_changedData.channel = "";
	}
	if(_changedData.subject == null){
		_changedData.subject = "";
	}
	if(_changedData.body == null){
		_changedData.body = "";
	}
	if(_changedData.extensions == null){
		_changedData.extensions = "";
	}
	if(_changedData.sendtime == null){
		_changedData.sendtime = _nowTime.getTime();
	}
	if(_changedData.receivetime == null){ 
		_changedData.receivetime = _nowTime.getTime() ;
	}
	if(_changedData.handlestate == null){ 
		_changedData.handlestate = 1;
	}
	if(_changedData.transtype == null){
		_changedData.transtype = 1;
	}
	if(_changedData.attachments == null){
		_changedData.attachments = "";
	}
	if(_changedData.version == null){
		_changedData.version = "";
	}
	if(_changedData.extra == null){
		_changedData.extra = "";
	}
	if(_changedData.createtime == null){
		_changedData.createtime = _nowTime.getTime();
	}
	if(_changedData.updatetime == null){
		_changedData.updatetime = _nowTime.getTime();
	}
	var _sql_insert = "insert into channel_cydow_message(id, messageid, senderid," +
			" sender, receiverid, receiver, channel, subject, body, extensions," +
			" sendtime, receivetime, handlestate, transtype, attachments, version," +
			" extra, createtime, updatetime)values("
		+ tools.formatSqlValue(_changedData.id) + ","
		+ tools.formatSqlValue(_changedData.messageid) + ","
		+ tools.formatSqlValue(_changedData.senderid) + ","
		+ tools.formatSqlValue(_changedData.sender) + ","
		+ tools.formatSqlValue(_changedData.receiverid) + ","
		+ tools.formatSqlValue(_changedData.receiver) + ","
		+ tools.formatSqlValue(_changedData.channel) + ","
		+ tools.formatSqlValue(_changedData.subject) + ","
		+ tools.formatSqlValue(_changedData.body) + ","
		+ tools.formatSqlValue(_changedData.extensions) + ","
		+ _changedData.sendtime + ","
		+ _changedData.receivetime + ","
		+ _changedData.handlestate + ","
		+ _changedData.transtype + ","
		+ tools.formatSqlValue(_changedData.attachments) + ","
		+ tools.formatSqlValue(_changedData.version) + ","
		+ tools.formatSqlValue(_changedData.extra) + ","
		+ _changedData.createtime + ","
		+ _changedData.updatetime + ");";
	var _isSuc = localdb.executeSync(_sql_insert);
	return _isSuc;
}

//向channel_cydow_message表中插入一条数据
module.exports.insert_messageData = function(_changedData){
	return insert_messageData(_changedData);	
};

/**
 * 更新channel_cydow_message表中的数据
 * @param _changedData
 */
function update_messageData(_changedData){
	var _nowTime = new Date();
	_changedData.updatetime = _nowTime.getTime();
	var _setList="";
	if (_changedData.senderid!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "senderid=" + tools.formatSqlValue(_changedData.senderid);
	}
	if (_changedData.sender!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "sender=" + tools.formatSqlValue(_changedData.sender);
	}
	if (_changedData.receiverid!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "receiverid=" + tools.formatSqlValue(_changedData.receiverid);
	}
	if (_changedData.receiver!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "receiver=" + tools.formatSqlValue(_changedData.receiver);
	}
	if (_changedData.channel!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "channel=" + tools.formatSqlValue(_changedData.channel);
	}
	if (_changedData.subject!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "subject=" + tools.formatSqlValue(_changedData.subject);
	}
	if (_changedData.body!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "body=" + tools.formatSqlValue(_changedData.body);
	}
	if (_changedData.extensions!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "extensions=" + tools.formatSqlValue(_changedData.extensions);
	}
	if (_changedData.sendtime!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "sendtime=" + _changedData.sendtime;
	}
	if (_changedData.receivetime!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "receivetime=" + _changedData.receivetime;
	}
	if (_changedData.handlestate!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "handlestate=" + _changedData.handlestate;
	}
	if (_changedData.transtype!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "transtype=" + _changedData.transtype;
	}
	if (_changedData.updatetime!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "updatetime=" + _changedData.updatetime;
	}
	if (_setList.length <= 0) return;
	var _sql_update = "update channel_cydow_message set " + _setList + " where id="
		+ tools.formatSqlValue(_changedData.id) + ";";
	var isSuccess = localdb.executeSync(_sql_update);
	if(isSuccess){
	}
	return isSuccess;
}

//更新消息（云端）数据
module.exports.update_messageData = function(_changedData){
	return update_messageData(_changedData);	
};

/**
 * 删除channel_cydow_message表中指定id的数据
 * @param _id
 */
function delete_messageData(_id){
	var _sql_del ="delete from channel_cydow_message where id="
		+ tools.formatSqlValue(_id) + ";";
	var isSuccess = localdb.executeSync(_sql_del);
	return isSuccess;
}

//删除channel_cydow_message表中指定id的数据
module.exports.delete_messageData = function(_id){
	delete_messageData(_id);	
};

/**
 * 查询指定条件（_id）下消息数据
 * @param _id
 * @returns
 */
function query_messageDataById(_id){
	var sql ="select * from channel_cydow_message where id="
		+ tools.formatSqlValue(_id) + ";";
	var _data = localdb.querySync(sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data[0];
}

//查询指定条件（_id）下消息数据
module.exports.query_messageDataById = function(_id){
	return query_messageDataById(_id);
};

/**
 * 根据消息ID和传输类型查询未处理消息数据
 * @param _messageid
 * @param _transType
 * @returns
 */
function query_msgDataByMsgIdAndTransType(_messageid, _transType){
	var sql ="select * from channel_cydow_message where messageid="
		+ tools.formatSqlValue(_messageid) 
		+ " and transtype=" + _transType
		+ " and handlestate=" + constants.getConstants("messageHandleState_unHandle") + ";";
	var _data = localdb.querySync(sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data[0];
}

//根据消息ID和传输类型查询未处理消息数据
module.exports.query_msgDataByMsgIdAndTransType = function(_messageid, _transType){
	return query_msgDataByMsgIdAndTransType(_messageid, _transType);
};

/**
 * 根据传输类型（_transType）下查询消息数据
 * @param _transType
 * @returns
 */
function query_messageDataByTransType(_transType){
	var sql ="select * from channel_cydow_message where transtype="
		+ _transType + ";";
	var _data = localdb.querySync(sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data;
}

//根据传输类型（_transType）下查询消息数据
module.exports.query_messageDataByTransType = function(_transType){
	return query_messageDataByTransType(_transType);
};

/**
 * 根据处理状态（_handleState）下查询消息数据
 * @param _handleState
 * @returns
 */
function query_msgDataByHandleState(_handleState){
	var sql ="select * from channel_cydow_message where handlestate="
		+ _handleState + ";";
	var _data = localdb.querySync(sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data;
}

//根据处理状态（_handleState）下查询消息数据
module.exports.query_msgDataByHandleState = function(_handleState){
	return query_msgDataByHandleState(_handleState);
};

/**
 * 根据渠道传输类型及处理状态查询消息数据
 * @param _handleState
 * @param _transType
 * @param _channel
 * @returns
 */
function query_msgDataByChannelStateTransType(_handleState, _transType, _channel){
	var sql ="select * from channel_cydow_message where handlestate="
		+ _handleState + " and transtype=" 
		+ _transType + " and channel=" 
		+ tools.formatSqlValue(_channel) + " order by receivetime DESC;";
	deviceone.print("sql: " + sql);
	var _data = localdb.querySync(sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data;
}

//根据渠道传输类型及处理状态查询消息数据
module.exports.query_msgDataByChannelStateTransType = function(_handleState, _transType, _channel){
	return query_msgDataByChannelStateTransType(_handleState, _transType, _channel);
};

/**
 * 根据渠道及传输类型查询未处理消息的数量
 * @param _handleState
 * @param _transType
 * @param _channel
 * @returns
 */
function query_msgNumByChannelStateTransType(_handleState, _transType, _channel){
	var sql ="select count(*) as num from channel_cydow_message where handlestate="
		+ _handleState + " and transtype=" 
		+ _transType + " and channel=" 
		+ tools.formatSqlValue(_channel) + ";";
	var _data = localdb.querySync(sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data[0];
}

//根据渠道及传输类型查询未处理消息的数量
module.exports.query_msgNumByChannelStateTransType = function(_handleState, _transType, _channel){
	return query_msgNumByChannelStateTransType(_handleState, _transType, _channel);
};

/**
 * 根据传输类型查询未处理消息的数量
 * @param _handleState
 * @param _transType
 * @returns
 */
function query_msgNumByStateTransType(_handleState, _transType){
	var sql ="select count(*) as num from channel_cydow_message where handlestate="
		+ _handleState + " and transtype=" 
		+ _transType + ";";
	deviceone.print("sql: " + sql);
	var _data = localdb.querySync(sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data[0];
}

//根据传输类型查询未处理消息的数量
module.exports.query_msgNumByStateTransType = function(_handleState, _transType){
	return query_msgNumByStateTransType(_handleState, _transType);
};

/**
 * 查询指定条件消息是否存在
 * @param _condition
 * @param _binds
 * @param _callFunc
 * @returns
 */
function isExistMsgDataAsync(_condition, _binds, _callFunc){
	var _sql ="select id from channel_cydow_message";
	if(null != _condition && _condition.length > 0){
		_sql += " where " + _condition;
	}
	_sql += ";";
	localdb.query(_sql, _binds, function(_data){
		if(_data == null || _data.length <= 0){
			_callFunc.call(this, false);
		} else {
			_callFunc.call(this, true);
		}
	});
}

//查询指定条件消息是否存在
module.exports.isExistMsgDataAsync = function(_condition, _binds, _callFunc){
	isExistMsgDataAsync(_condition, _binds, _callFunc);
};
