/**
 * 操作数据库
 * 
 * @Author : Cydow
 * @Timestamp : 2017-02-21
 */
var deviceone = require("deviceone");
var do_nf = deviceone.sm("do_Notification");
var do_storage = deviceone.sm("do_Storage");
var do_initData = deviceone.sm("do_InitData");
var do_dataCache = sm("do_DataCache");
var do_page = sm("do_Page");
var do_global = sm("do_Global");

//数据库
var localdb = deviceone.mm("M0026_sqlite", "localdb", "app");
var pipsdb = deviceone.mm("M0026_sqlite", "localdb_pips", "app");

//日志工具
var logTools = require("logTools.ui");
//标识
var Tag = "[dbmodel]";

//生成uuid
var uuid = require("uuid");
var objectId = require("objectId"); //生成objectId
var calendar = require("calendar"); //日期计算
var chinesePinYin = require("chinesePinYin"); // 拼音
var tools = require("tools"); //工具
var jsonTools = require("jsonTools"); //json工具
var constants = require("constants"); //常量
var notificationTools = require("notificationTools"); //设置提醒
var typeconstants = require("typeconstants.ui"); //信息类型常量
//初始化应用库sql语句
var dbinitsqls = require("dbinitsqls.ui");

//js资源文件路径管理
var jsPathManager = require("jsPathManager.ui");
// 全局数据服务
var dataService = require(jsPathManager.getGlobalDataServicePath());
// 信息库数据同步服务
var dbExpSync = require(jsPathManager.getExpSyncDBPath());
//文本资源
var string = require(jsPathManager.getStringPath());
// 全局常量
var globalConst = require(jsPathManager.getGlobalConstPath());
//信息类型常量
var infoTypeConst = require(jsPathManager.getInfoTypeConstPath());
// 信息库常量
var expConst = require(jsPathManager.getExpConstPath());
// 信息库服务
var expService = require(jsPathManager.getExpServicePath());
// 时间工具
var timeTools = require(jsPathManager.getTimeToolPath());
// 同步工具
var syncDataTools = require("syncDataTools");
// 数据同步-全局常量
var syncGlobalConst = require(jsPathManager.getSyncConstPath());
// 重复类型工具
var cycleTypeTools = require(jsPathManager.getCycleTypeToolsPath());
// 联系人属性常量
var contactPropConst = require(jsPathManager.getContactPropConstPath());
//数据同步-工具
var syncTools = require(jsPathManager.getSyncToolPath());
// 旧数据处理-信息库
var wrongDataHandler = require(jsPathManager.getWrongDataHandlePath());
//数据升级
var dataUpgrade = require(jsPathManager.getDataUpgradePath());

var dbtask = require("dbtask"); //待办事宜
var dbcomm = require("dbcomm"); //纪念日
var dbbirthday = require("dbbirthday"); //生日
var dbsyncdata = require("dbsyncdata"); //数据同步
var dbcycle = require("dbcycle"); //周期
var dbuser = require("dbuser"); //用户
var dbcontacts = require("dbcontacts"); //联系人
var dbcontactcard = require("dbcontactcard"); // 名片
var dbcontactproperties = require("dbcontactproperties"); //联系人（或名片）属性
var dbcydowidrelation = require("dbcydowidrelation"); //慧影号关联表
var dbcontactgroups = require("dbcontactgroups"); // 联系人群组
var dbcontactgroupsrel = require("dbcontactgroupsrel"); // 联系人群组关系
var dbcleardata = require("dbcleardata"); // 数据清理记录

// 从缓存中取设备信息
var deviceInfo = do_global.getMemory("deviceInfo");
// 从缓存取用户信息
var userInfo = do_global.getMemory("userInfo");

// 迁移数据库表状态key标识
var migrateDbStateKey = globalConst.dataCacheKey.migrateDbStateKey;

/**
 * 判断数据库是否存在
 * @param _tableName
 * @returns {Boolean}
 */
function existTable(_tableName){
	var sql="select 1 from sqlite_master where type='table' and name='" + _tableName.replace(/'/g, "''") + "';";
	var _data=localdb.querySync(sql);
	if(_data != null && _data.length > 0){
		return true;
	}
	return false;
}

/**
 * 获取objectId
 * @returns
 */
function getObjectId(){
	return objectId.getObjectId();
}

// 获取objectId
module.exports.getObjectId = function(){
	return getObjectId();
}

/**
 * 执行异步方法（参数为拼接好的sql语句和操作类型）
 * @param _sql
 * @param _operType
 * @param _callFunc
 * @returns
 */
function executeAsync(_sql, _operType, _callFunc){
	// 若操作是查询，则执行查询方法
	if("query" == _operType){
		localdb.query(_sql, _callFunc);
	}
}

// 执行异步方法
module.exports.executeAsync = function(_sql, _operType, _callFunc){
	executeAsync(_sql, _operType, _callFunc);
}

//获取更新计数
module.exports.getSyncSequence = function(){
	return tools.getSyncSequence();
};

//通过id获取一条待办数据
module.exports.get_mytaskOne = function(_id){
	return dbtask.get_mytaskOneData(_id);	
};

/**
 * 生成数据（从周期性记录表中获取源数据id，并通过id增量生成其他周期性待办卡片和纪念日数据）
 * 
 * @returns
 */
function insert_mytaskOneCycleType(){
	var _cycleRecordList = dbcycle.query_cycleRecordAllData();
	print("----------_cycleRecordList " + JSON.stringify(_cycleRecordList));
	if(null != _cycleRecordList){
		for(var i=0; i<_cycleRecordList.length; i++){
			var _cycleRecordData = _cycleRecordList[i];
			if(_cycleRecordData == null){
				continue;
			}
			if(_cycleRecordData.infocategory == constants.getConstants("infoCategory_lesson")){
				continue;
			}
			var _data = dbtask.get_mytaskOneData(_cycleRecordData.taskid);
			if(_data == null){
				continue;
			}
			if(_data.infocategory == constants.getConstants("infoCategory_task")){
				dbtask.insert_mytaskOneCycleType(_data, _cycleRecordData);
			} else if(_data.infocategory == constants.getConstants("infoCategory_comm")){
				dbcomm.insert_commDayBySource(_data, _cycleRecordData);
			} else if(_data.infocategory == constants.getConstants("infoCategory_birthday")){
				dbbirthday.insertBirthdayBySource(_data, _cycleRecordData);
			}
		}
	}
}

//生成数据（从周期性记录表中获取源数据id，并通过id增量生成其他周期性待办卡片和纪念日数据）
module.exports.insert_mytaskCycleType = function(){
	insert_mytaskOneCycleType();
};

//-------------------------------------- 时间流
//待办事宜
//插入一条待办数据
module.exports.insert_mytask = function(_changedData){
	dbtask.insert_mytask(_changedData);
};

//更新待办数据
module.exports.update_mytask = function(_changedData){
	dbtask.update_mytask(_changedData);
};

//通过id删除一条待办数据
module.exports.delTaskData = function(_id, _cycleRecordId, _cycleId){
	dbtask.delTaskData(_id, _cycleRecordId, _cycleId);
};

//定时清除待办数据（当前年份之前的待办）
module.exports.clearAgoTask = function(){
	return dbtask.clearAgoTask();
};

//查询待办总数量（按照标题去重）
module.exports.query_countMyTask = function(){
	return dbtask.query_countMyTask();
};

//查询指定条件下的待办卡片数量（开始时间在指定范围内的待办卡片数量）
module.exports.query_mytaskNumByTime = function(_startTime, _endTime){
	return dbtask.query_mytaskNumByTime(_startTime, _endTime);
};

//查询指定条件下的各类型待办卡片数量（开始时间在指定范围内的待办卡片数量）
module.exports.queryTaskTypeNumByTime = function(_startTime, _endTime){
	return dbtask.queryTaskTypeNumByTime(_startTime, _endTime);
};

//查询指定条件下的待办卡片开始时间和结束时间（开始时间在指定时间范围内的待办卡片）
module.exports.query_mytaskStartAndEndByTime = function(_startTime, _endTime){
	return dbtask.query_mytaskStartAndEndByTime(_startTime, _endTime);
};

// 查询指定条件（id标识、类型和事项名称）下待办数据--用于同一个类型下重名判断
module.exports.query_taskDataByTypeTitle = function(_id, _type, _title){
	return dbtask.query_taskDataByTypeTitle(_id, _type, _title);
};

/**
 * 检测是否存在时间流信息
 * @returns
 */
function isExistTFData(){
	var sql ="select id from mytask;";
	var _data = localdb.querySync(sql);
	if(_data == null || _data.length <= 0){
		return false;
	}
	return true;
}

// 检测是否存在时间流信息
module.exports.isExistTFData = function(){
	return isExistTFData();
};

//--------------------------------------
//周期
//通过taskid（源数据id）从周期记录表（cyclerecord）中获取指定的一条数据
module.exports.query_cycleRecordDataByTaskId = function(_id){
	return dbcycle.query_cycleRecordOneDataByTaskId(_id);
};

// 通过周期记录id从周期记录表（cyclerecord）中获取源数据taskid
module.exports.query_taskidByCycleRecordId = function(_id){
	return dbcycle.query_taskidByCycleRecordId(_id);
};

//通过id（周期记录id）从周期记录表（cyclerecord）中获取指定的一条数据
module.exports.query_cycleRecordOneData = function(_id){
	return dbcycle.query_cycleRecordOneData(_id);
};

//插入一条周期记录
module.exports.insert_cycleRecord = function(_cycleRecordData){
	dbcycle.insert_cycleRecordData(_cycleRecordData);
};

//--------------------------------------
//数据同步

//查询更新计数器
module.exports.query_updCount = function(_moduleId){
	return dbsyncdata.query_updCount(_moduleId);
}

//通过更新计数查询更新记录
module.exports.query_updrecordBySyncCount = function(_syncCount, _moduleId){
	return dbsyncdata.query_updrecordBySyncCount(_syncCount, _moduleId);
}

//通过id查询更新记录
module.exports.query_updrecordById = function(_id){
	return dbsyncdata.query_updrecordById(_id);
}

//通过同步方id和业务模块id查询同步计数器
module.exports.query_synccountOne = function(_syncid, _moduleId){
	return dbsyncdata.query_synccountOne(_syncid, _moduleId);
};

//更新同步计数器
module.exports.sync_synccount = function(_syncData){
	return dbsyncdata.sync_synccount(_syncData);
};

//更新同步记录
module.exports.sync_syncrecord = function(_syncData){
	return dbsyncdata.sync_syncrecord(_syncData);
};

//根据同步状态查询同步记录
module.exports.query_syncrecordByState = function(_syncId, _moduleId){
	return dbsyncdata.query_syncrecordByState(_syncId, _moduleId);
}

//--------------------------------------
//纪念日
//新建纪念日数据
module.exports.insert_commDay =  function(_changedData){
	dbcomm.insert_commDay(_changedData);
};

//更新纪念日数据
module.exports.update_commDay = function(_changedData){
	dbcomm.update_commDay(_changedData);
};

//删除纪念日数据
module.exports.delCommDay = function(_id, _cycleRecordId){
	dbcomm.delCommDay(_id, _cycleRecordId);
};

// 查询指定条件（id标识、类型和纪念日名称）下纪念日数据--用于同一个类型下重名判断
module.exports.query_commDataByTypeName = function(_id, _type, _name){
	return dbcomm.query_commDataByTypeName(_id, _type, _name);
};

//--------------------------------------
//用户
//新增用户数据
module.exports.insert_cydowUserData =  function(_changedData){
	dbuser.insert_cydowUserData(_changedData);
};

//更新用户数据
module.exports.update_cydowUserData = function(_changedData){
	dbuser.update_cydowUserData(_changedData);
};

//删除用户数据
module.exports.delete_cydowUserData = function(_id){
	dbuser.delete_cydowUserData(_id);
};

//查询指定id的用户数据
module.exports.query_userDataById = function(_id){
	return dbuser.query_userDataById(_id);
};

//--------------------------------------
//联系人
//更新联系人头像数据
module.exports.update_contactHeadData = function(_changedData){
	dbcontacts.update_contactHeadData(_changedData);
};

//检测联系人是否存在（通过id）
module.exports.isExistContactDataById = function(_id){
	return dbcontacts.isExistContactDataById(_id);
};

//查询指定id的联系人数据
module.exports.query_contactDataById = function(_id){
	return dbcontacts.query_contactDataById(_id);
};

//查询指定id的联系人的属性数据
module.exports.query_contactPropertiesDataById = function(_id){
	return dbcontactproperties.query_contactPropertyDataById(_id);
};

//--------------------------------------
//电子名片
//更新名片头像数据
module.exports.update_vcardHeadData = function(_changedData){
	dbcontactcard.update_vcardHeadData(_changedData);
};

//查询指定id的电子名片数据
module.exports.query_contactCardDataById = function(_id){
	return dbcontactcard.query_contactCardDataById(_id);
};

//检测名片是否存在（通过id）
module.exports.isExistVCardDataById = function(_id){
	return dbcontactcard.isExistVCardDataById(_id);
};

// 设置默认名片-数据同步
module.exports.setDefVCardSyncData = function(){
	dbcontactcard.setDefVCardSyncData();
};

//--------------------------------------
// 联系人群组
// 插入一条群组数据-数据同步
module.exports.insertGroupSyncData = function(_changedData){
	return dbcontactgroups.insertGroupSyncData(_changedData);
};

//更新一条群组数据-数据同步
module.exports.update_syncDataGroupsData = function(_changedData){
	var _data = dbcontactgroups.query_groupsDataById(_changedData.id);
	if(tools.isNull(_data)){
		return dbcontactgroups.insertGroupSyncData(_changedData);
	} else {
		return dbcontactgroups.updGroupSyncData(_changedData);
	}
};

// 通过群组名称获取群组数据-数据同步
module.exports.query_groupsDataByName = function(_name){
	return dbcontactgroups.query_groupsDataByName(_name);
};

// 获取指定群组的数据-数据同步
module.exports.query_groupsDataById = function(_id){
	return dbcontactgroups.query_groupsDataById(_id);
};

//检测群组是否存在（通过id）
module.exports.isExistGroupDataById = function(_id){
	return dbcontactgroups.isExistGroupDataById(_id);
};

//--------------------------------------
//联系人群组关系
// 插入一条群组关系数据-数据同步
module.exports.insertGroupsRelSyncData =  function(_changedData){
	var	_saveResult = dbcontactgroupsrel.insertGroupsRelSyncData(_changedData);
	return _saveResult;
};

//更新一条群组关系数据-数据同步
module.exports.updGroupRelSyncData =  function(_changedData){
	// 查询指定联系人群组关系数据
	var _groupRelData = dbcontactgroupsrel.queryGroupRelByGroupAndContactId(_changedData.groupid,
			_changedData.contactid);
	// 若群组关系人不存在，则插入一条群组关系数据；否则，更新群组关系数据
	if(tools.isNull(_groupRelData)){
		// 插入一条群组关系数据
		_saveResult = dbcontactgroupsrel.insertGroupsRelSyncData(_changedData);
	} else {
		// 若本地指定群组关系数据较新，则默认成功；否则更新本地群组关系数据
		if(_groupRelData.updatetime >= _changedData.updatetime){
			_saveResult = true;
		} else {
			_saveResult = dbcontactgroupsrel.updGroupRelSyncData(_changedData);
		}
	}
	return _saveResult;
};

// ------------------------ 数据清理
//根据数据标识ID查询数据清理记录-数据清理
module.exports.queryDataClearRecordById = function(_id){
	return dbcleardata.queryDataClearRecordById(_id);
};

/**
 * 向更新计数器表（datasync_updcount_tmp）中插入数据
 * @param _updCount
 * @param _moduleId
 */
function insert_updCountTmpData(_updCount, _moduleId){
	var _sql_insert = "insert into datasync_updcount_tmp(moduleid, updatetime, " +
		"updatecount) values("
		+ tools.formatSqlValue(_moduleId) + ","
		+ _updCount.updatetime + ","
		+ _updCount.updatecount + ");";
	localdb.executeSync(_sql_insert);
}

/**
 * 向更新记录表（datasync_updrecord_tmp）中插入数据
 * @param _updRecord
 * @param _moduleId
 */
function insert_updRecordTmpData(_updRecord, _moduleId){
	if(null == _updRecord.dataid){
		_updRecord.data = "";
	}
	var _sql_insert = "insert into datasync_updrecord_tmp(id, moduleid, recordtime, " +
		"recordtype, updatecount, dataid, datatype) values("
		+ tools.formatSqlValue(_updRecord.id) + ","	
		+ tools.formatSqlValue(_moduleId) + ","
		+ _updRecord.recordtime + ","
		+ _updRecord.recordtype + ","
		+ _updRecord.updatecount + ","
		+ tools.formatSqlValue(_updRecord.dataid) + ","
		+ tools.formatSqlValue(_updRecord.datatype) + ");";
		localdb.executeSync(_sql_insert);
}

/**
 * 向同步计数器表（datasync_synccount_tmp）中插入数据
 * @param _syncCount
 * @param _moduleId
 */
function insert_syncCountData(_syncCount, _moduleId){
	var _sql_insert = "insert into datasync_synccount_tmp(moduleid, updatetime, " +
	"syncid, synccount) values("
	+ tools.formatSqlValue(_moduleId) + ","
	+ _syncCount.updatetime + ","
	+ tools.formatSqlValue(_syncCount.syncid) + ","
	+ _syncCount.synccount + ");";
	localdb.executeSync(_sql_insert);
}

/**
 * 向同步记录表（datasync_syncrecord_tmp）中插入数据
 * @param _syncRecord
 * @param _moduleId
 */
function insert_syncRecordData(_syncRecord, _moduleId){
	var _sql_insert = "insert into datasync_syncrecord_tmp(moduleid, dataid, synctime, " +
		"syncid, syncstate) values("
		+ tools.formatSqlValue(_moduleId) + ","
		+ tools.formatSqlValue(_syncRecord.dataid) + ","
		+ _syncRecord.synctime + ","
		+ tools.formatSqlValue(_syncRecord.syncid) + ","
		+ _syncRecord.syncstate + ");";
		localdb.executeSync(_sql_insert);
}

//客服（大慧小影）数据id
var cydowServiceId = constants.getConstants("cydowServiceId");
/**
 * 处理数据库升级（18）
 * @returns
 */
function handleUpgradeDb18(){
	//用户
	if (!existTable("cydowuser")){
		var _sql_cydowuser = "create table cydowuser(userid varchar(45) primary key, "
			+ "username varchar(45), fullname varchar(45), userpass varchar(45), "
			+ "mailadd text, mobileno text, globaluid varchar(45), regdate integer, "
			+ "lastlogindate integer, lastlogindevicename varchar(45), "
			+ "lastlogindeviceid varchar(45), lastloginip varchar(45), "
			+ "status integer, userrole integer, loglevel integer, "
			+ "headurl text, otherinfo text);";
		localdb.executeSync(_sql_cydowuser);
	}
	//联系人
	if (!existTable("contacts_contact")){
		var _sql_contacts_contact = "create table contacts_contact(id varchar(45) primary key, "
			+ "infoid varchar(45), type text not null, cydowid varchar(45), "
			+ "headurl text, goodsname text, name text, gender varchar(2) default 0, "
			+ "birthday integer, mobilephone text, ownemailaddr text, fixphone, company text, "
			+ "position text, jobphone text, jobemailaddr text, comwebsite text, "
			+ "comaddr text, nativeplace text, edubackground text, degree text, "
			+ "grade varchar(32), homephone text, homeaddr text, interests text, "
			+ "meetoccasion text, groups text, remarks text, deleted integer default 0, "
			+ "createtime integer, updatetime integer);";
		localdb.executeSync(_sql_contacts_contact);
	}
	
	//我的名片
	if (!existTable("contacts_vcard")){
		var _sql_contacts_vcard = "create table contacts_vcard(id varchar(45) primary key, "
			+ "infoid varchar(45), cydowid varchar(45), headurl text, name text, "
			+ "gender varchar(2) default 0, mobilephone text, emailaddr text, "
			+ "company text, position text, fixphone text, website text, "
			+ "address text, defaultflag varchar(2) default 0, starttime integer, endtime integer, "
			+ "deleted integer default 0, notifyid integer, createtime integer, "
			+ "updatetime integer);";
		localdb.executeSync(_sql_contacts_vcard);
	}
	//导入导出记录
	if (!existTable("contacts_impexprecord")){
		var _sql_contacts_impexprecord = "create table contacts_impexprecord(id integer primary key autoincrement, "
			+ "contactid varchar(45), phonebookid varchar(45), "
			+ "type varchar(2), createtime integer, updatetime integer);";
		localdb.executeSync(_sql_contacts_impexprecord);
	}
	//消息（云端）记录
	if (!existTable("channel_cydow_message")){
		var _sql_channel_cydow_message = "create table channel_cydow_message (sno integer primary key autoincrement, " +
				"id varchar(45), messageid varchar(45), senderid varchar(128), " +
				"sender text, receiverid text, receiver blob, channel varchar(128), " +
				"subject text, body blob, extensions blob, sendtime integer, " +
				"receivetime integer, handlestate integer, transtype integer, " +
				"createtime integer, updatetime integer);";
		localdb.executeSync(_sql_channel_cydow_message);
	}
	//消息（云端）接收状态记录
	if (!existTable("channel_cydow_rcvrecord")){
		var _sql_channel_cydow_rcvrecord = "create table channel_cydow_rcvrecord (sno integer primary key autoincrement, " +
				"channel varchar(128), lastmsgid varchar(45), receivetime integer, " +
				"createtime integer, updatetime integer);";
		localdb.executeSync(_sql_channel_cydow_rcvrecord);
	}
	
	//-------------------------------
	//数据同步相关表的旧数据处理
	var _moduleId = constants.getConstants("moduleType_timeflow");
	//更新计数器表（datasync_updcount）
	if (existTable("datasync_updcount_tmp")){
		var _sql_datasync_updcount_tmp_drop = "drop table datasync_updcount_tmp;";
		localdb.executeSync(_sql_datasync_updcount_tmp_drop);
	}
	var _sql_datasync_updcount_tmp = "create table datasync_updcount_tmp(id integer primary key autoincrement, moduleid text, updatetime integer, updatecount integer);";
	localdb.executeSync(_sql_datasync_updcount_tmp);
	var _sql_datasync_updcount_select = "select * from datasync_updcount;";
	var _data = localdb.querySync(_sql_datasync_updcount_select);
	for(var i=0; i<_data.length; i++){
		var _rowdata = _data[i];
		if(null == _rowdata) continue;
		insert_updCountTmpData(_rowdata, _moduleId);
	}
	var _sql_datasync_updcount_drop = "drop table datasync_updcount;";
	localdb.executeSync(_sql_datasync_updcount_drop);
	var _sql_datasync_updcount_tmp_rename = "alter table datasync_updcount_tmp rename to datasync_updcount;";
	localdb.executeSync(_sql_datasync_updcount_tmp_rename);
	
	//更新记录表（datasync_updrecord）
	if (existTable("datasync_updrecord_tmp")){
		var _sql_datasync_updrecord_tmp_drop = "drop table datasync_updrecord_tmp;";
		localdb.executeSync(_sql_datasync_updrecord_tmp_drop);
	}
	var _sql_datasync_updrecord_tmp = "create table datasync_updrecord_tmp(id varchar(250) primary key, moduleid text, recordtime integer, recordtype integer, updatecount integer, dataid varchar(250), datatype varchar(16));";
	localdb.executeSync(_sql_datasync_updrecord_tmp);
	var _sql_datasync_updrecord_select = "select * from datasync_updrecord;";
	_data = localdb.querySync(_sql_datasync_updrecord_select);
	for(var i=0; i<_data.length; i++){
		var _rowdata = _data[i];
		if(null == _rowdata) continue;
		insert_updRecordTmpData(_rowdata, _moduleId);
	}
	var _sql_datasync_updrecord_drop = "drop table datasync_updrecord;";
	localdb.executeSync(_sql_datasync_updrecord_drop);
	var _sql_datasync_updrecord_tmp_rename = "alter table datasync_updrecord_tmp rename to datasync_updrecord;";
	localdb.executeSync(_sql_datasync_updrecord_tmp_rename);
	
	//同步计数器表（datasync_synccount）
	if (existTable("datasync_synccount_tmp")){
		var _sql_datasync_synccount_tmp_drop = "drop table datasync_synccount_tmp;";
		localdb.executeSync(_sql_datasync_synccount_tmp_drop);
	}
	var _sql_datasync_synccount_tmp = "create table datasync_synccount_tmp(id integer primary key autoincrement, moduleid text, updatetime integer, syncid varchar(250), synccount integer);";
	localdb.executeSync(_sql_datasync_synccount_tmp);
	var _sql_datasync_synccount_select = "select * from datasync_synccount;";
	_data = localdb.querySync(_sql_datasync_synccount_select);
	for(var i=0; i<_data.length; i++){
		var _rowdata = _data[i];
		if(null == _rowdata) continue;
		insert_syncCountData(_rowdata, _moduleId);
	}
	var _sql_datasync_synccount_drop = "drop table datasync_synccount;";
	localdb.executeSync(_sql_datasync_synccount_drop);
	var _sql_datasync_synccount_tmp_rename = "alter table datasync_synccount_tmp rename to datasync_synccount;";
	localdb.executeSync(_sql_datasync_synccount_tmp_rename);
	
	//同步记录表（datasync_syncrecord）
	if (existTable("datasync_syncrecord_tmp")){
		var _sql_datasync_syncrecord_tmp_drop = "drop table datasync_syncrecord_tmp;";
		localdb.executeSync(_sql_datasync_syncrecord_tmp_drop);
	}
	var _sql_datasync_syncrecord_tmp = "create table datasync_syncrecord_tmp(id integer primary key autoincrement, moduleid text, dataid varchar(250), syncid varchar(250), synctime integer, syncstate integer);";
	localdb.executeSync(_sql_datasync_syncrecord_tmp);
	var _sql_datasync_syncrecord_select = "select * from datasync_syncrecord;";
	_data = localdb.querySync(_sql_datasync_syncrecord_select);
	for(var i=0; i<_data.length; i++){
		var _rowdata = _data[i];
		if(null == _rowdata) continue;
		insert_syncRecordData(_rowdata, _moduleId);
	}
	var _sql_datasync_syncrecord_drop = "drop table datasync_syncrecord;";
	localdb.executeSync(_sql_datasync_syncrecord_drop);
	var _sql_datasync_syncrecord_tmp_rename = "alter table datasync_syncrecord_tmp rename to datasync_syncrecord;";
	localdb.executeSync(_sql_datasync_syncrecord_tmp_rename);
}

/**
 * 插入名片数据（修改表结构）
 * @returns
 */
function insertVCardTmpData(_changedData){
	var _nowTime = new Date();
	if (_changedData.id == null){
		_changedData.id = objectId.getObjectId();
	}
	if (_changedData.infoid == null){
		_changedData.infoid = "";
	}
	if(_changedData.headurl == null){
		_changedData.headurl = "";
	}
	if(_changedData.name == null){
		_changedData.name  = "";
	}
	if(_changedData.gender == null){
		_changedData.gender  = "1";
	}
	if(_changedData.company == null){
		_changedData.company  = "";
	}
	if(_changedData.department == null){
		_changedData.department  = "";
	}
	if(_changedData.position == null){
		_changedData.position  = "";
	}
	if(_changedData.website == null){
		_changedData.website  = "";
	}
	if(_changedData.defaultflag == null){
		_changedData.defaultflag = "0";
	}
	if(_changedData.starttime == null){
		_changedData.starttime  = _nowTime.getTime();
	} else {
		if(_changedData.starttime == ""){
			_changedData.starttime = null;
		}
	}
	if(_changedData.endtime == null){ 
		var _tmpTime = new Date();
		_tmpTime.setTime(_nowTime.getTime());
		_tmpTime.setFullYear(_tmpTime.getFullYear() + 10);
		_changedData.endtime  = _tmpTime.getTime();
	} else {
		if(_changedData.endtime == ""){
			_changedData.endtime = null;
		}
	}
	if(_changedData.createtime == null){
		_changedData.createtime  = _nowTime.getTime();
	}
	if(_changedData.updatetime == null){
		_changedData.updatetime  = _nowTime.getTime();
	}
	var _sql_insert = "insert into contacts_vcard_tmp(id, infoid, headurl," +
			" name, gender, company, department, position, website," +
			" defaultflag, starttime, endtime, createtime, updatetime)values("
		+ tools.formatSqlValue(_changedData.id) + ","
		+ tools.formatSqlValue(_changedData.infoid) + ","
		+ tools.formatSqlValue(_changedData.headurl) + ","
		+ tools.formatSqlValue(_changedData.name) + ","
		+ tools.formatSqlValue(_changedData.gender) + ","
		+ tools.formatSqlValue(_changedData.company) + ","
		+ tools.formatSqlValue(_changedData.department) + ","
		+ tools.formatSqlValue(_changedData.position) + ","
		+ tools.formatSqlValue(_changedData.website) + "," 
		+ tools.formatSqlValue(_changedData.defaultflag) + ","
		+ _changedData.starttime + ","
		+ _changedData.endtime + ","
		+ _changedData.createtime + ","
		+ _changedData.updatetime + ");";
	var isSuccess = localdb.executeSync(_sql_insert);
	if(isSuccess){
		if(null != _changedData.properties && _changedData.properties.length > 0){
			//新增联系人（或名片）属性记录表
			dbcontactproperties.insertContactPropData(_changedData.id,
					_changedData.properties);
		}
	}
	return isSuccess;
}

/**
 * 插入联系人数据（修改表结构）
 * @returns
 */
function insertContactsTmpData(_changedData){
	var _nowTime = new Date();
	if (_changedData.id == null){
		_changedData.id = objectId.getObjectId();
	}
	if (_changedData.infoid == null){
		_changedData.infoid = "";
	}
	if (_changedData.type == null){
		_changedData.type = typeconstants.typeConstants["contactType_common"];
	}
	if(_changedData.headurl == null){
		_changedData.headurl = "";
	}
	if(_changedData.name == null){
		_changedData.name  = "";
	}
	if(_changedData.gender == null){
		_changedData.gender  = "1";
	}
	if(_changedData.company == null){
		_changedData.company  = "";
	}
	if(_changedData.department == null){
		_changedData.department  = "";
	}
	if(_changedData.interests == null){
		_changedData.interests  = "";
	}
	if(_changedData.meetoccasion == null){
		_changedData.meetoccasion  = "";
	}
//	if(_changedData.groups == null){
//		_changedData.groups  = "";
//	}
	if(_changedData.remarks == null){
		_changedData.remarks  = "";
	}
	if(_changedData.createtime == null){
		_changedData.createtime  = _nowTime.getTime();
	}
	if(_changedData.updatetime == null){
		_changedData.updatetime  = _nowTime.getTime();
	}
	var _sql_insert = "";
	var _birthday = null;
	if(typeconstants.typeConstants["contactType_children"] == _changedData.type){
		_sql_insert = "insert into contacts_contact_tmp(id, infoid, type, " +
			"headurl, name, gender, ";
		if(_changedData.birthday != null && _changedData.birthday != ""){
			_sql_insert += "birthday, ";
			_birthday = _changedData.birthday;
		}
		_sql_insert += "company, department, interests, meetoccasion, remarks," +
				" createtime, updatetime)values("
			+ tools.formatSqlValue(_changedData.id) + ","
			+ tools.formatSqlValue(_changedData.infoid) + ","
			+ tools.formatSqlValue(_changedData.type) + ","
			+ tools.formatSqlValue(_changedData.headurl) + ","
			+ tools.formatSqlValue(_changedData.name) + ","
			+ tools.formatSqlValue(_changedData.gender) + ",";
		if(_changedData.birthday != null && _changedData.birthday != ""){
			_sql_insert += _changedData.birthday + ",";
		}
	} else if(typeconstants.typeConstants["contactType_goods"] == _changedData.type){
		if(_changedData.goodsname == null){
			_changedData.goodsname = "";
		}
		if(_changedData.position == null){
			_changedData.position  = "";
		}
		if(_changedData.comwebsite == null){
			_changedData.comwebsite  = "";
		}
		_sql_insert = "insert into contacts_contact_tmp(id, infoid, type, " +
				"headurl, goodsname, name, gender, position, comwebsite, " +
				"company, department, interests, meetoccasion, " +
				"remarks, createtime, updatetime)values("
			+ tools.formatSqlValue(_changedData.id) + ","
			+ tools.formatSqlValue(_changedData.infoid) + ","
			+ tools.formatSqlValue(_changedData.type) + ","
			+ tools.formatSqlValue(_changedData.headurl) + ","
			+ tools.formatSqlValue(_changedData.goodsname) + ","
			+ tools.formatSqlValue(_changedData.name) + ","
			+ tools.formatSqlValue(_changedData.gender) + ","
			+ tools.formatSqlValue(_changedData.position) + ","
			+ tools.formatSqlValue(_changedData.comwebsite) + "," 
	} else {
		if(_changedData.position == null){
			_changedData.position  = "";
		}
		if(_changedData.comwebsite == null){
			_changedData.comwebsite  = "";
		}
		if(_changedData.nativeplace == null){
			_changedData.nativeplace  = "";
		}
		if(_changedData.edubackground == null){
			_changedData.edubackground  = "";
		}
		if(_changedData.degree == null){
			_changedData.degree  = "";
		}
		_sql_insert = "insert into contacts_contact_tmp(id, infoid, type, " +
			"headurl, name, gender, ";
		if(_changedData.birthday != null && _changedData.birthday != ""){
			_sql_insert += "birthday, ";
			_birthday = _changedData.birthday;
		}
		_sql_insert += "position, comwebsite, nativeplace, edubackground, " +
				"degree, company, department, interests, " +
				"meetoccasion, remarks, createtime, updatetime)values("
			+ tools.formatSqlValue(_changedData.id) + ","
			+ tools.formatSqlValue(_changedData.infoid) + ","
			+ tools.formatSqlValue(_changedData.type) + ","
			+ tools.formatSqlValue(_changedData.headurl) + ","
			+ tools.formatSqlValue(_changedData.name) + ","
			+ tools.formatSqlValue(_changedData.gender) + ","
		if(_changedData.birthday != null && _changedData.birthday != ""){
			_sql_insert += _changedData.birthday + ",";
		}
		_sql_insert += tools.formatSqlValue(_changedData.position) + ","
			+ tools.formatSqlValue(_changedData.comwebsite) + "," 
			+ tools.formatSqlValue(_changedData.nativeplace) + ","
			+ tools.formatSqlValue(_changedData.edubackground) + ","
			+ tools.formatSqlValue(_changedData.degree) + ","
	}
	_sql_insert	+= tools.formatSqlValue(_changedData.company) + ","
		+ tools.formatSqlValue(_changedData.department) + ","
		+ tools.formatSqlValue(_changedData.interests) + ","
		+ tools.formatSqlValue(_changedData.meetoccasion) + ","
		+ tools.formatSqlValue(_changedData.remarks) + ","
		+ _changedData.createtime + ","
		+ _changedData.updatetime + ");";
	var isSuccess = localdb.executeSync(_sql_insert);
	if(isSuccess){
		//设置联系人属性
		if(null != _changedData.properties && _changedData.properties.length > 0){
			//新增联系人（或名片）属性记录表
			dbcontactproperties.insertContactPropData(_changedData.id, 
					_changedData.properties);
		}
		//生成生日卡片
		if(null != _birthday && "" != _birthday){
			dbbirthday.insert_birthdayData({
				id: _changedData.id,
				commname: _changedData.name,
				commtime: _birthday
			});
		}
	}
	return isSuccess;
}

/**
 * 处理联系人数据库表升级（19）
 * @returns
 */
function handleUpgradeDbContactTable19(){
	// “大慧小影”头像信息
	var _cydowSerStr = do_initData.readFileSync("initdata://cydow_service");
	var _nowTime = (new Date()).getTime();
	var _sql = "insert into contacts_contact(id, infoid, type, headurl, " +
			"name, gender, position, comwebsite, nativeplace, " +
			"edubackground, degree, company, department, interests, meetoccasion, " +
			"remarks, createtime, updatetime)values(?, '', ?, ?, '大慧小影', " +
			"'0', '慧影客服', 'www.cydow.com', '', '', '', " +
			"'北京慧影智虹科技有限公司', '', '', '', '', ?, ?);";
	// 添加“大慧小影”联系人信息
	localdb.executeSync(_sql,  [cydowServiceId,
		typeconstants.typeConstants["contactType_common"], 
		_cydowSerStr, _nowTime, _nowTime]);
	// 添加“大慧小影”联系人属性信息
	_sql = "insert into contacts_properties(id, type, value) " +
			"values('59c3481043a10343a100c3eb', 'phone.mobile', '13720028991')," +
			"('59c3481043a10343a100c3eb', 'phone.work', '010-62669205')," +
			"('59c3481043a10343a100c3eb', 'phone.work', '13720028991')," +
			"('59c3481043a10343a100c3eb', 'cydowid.default', '100000010')," +
			"('59c3481043a10343a100c3eb', 'email.work', 'cydowsupport@cydow.com')," +
			"('59c3481043a10343a100c3eb', 'email.personal', 'cydowsupport@cydow.com')," +
			"('59c3481043a10343a100c3eb', 'address.work', '北京市海淀区上地十街辉煌国际4号楼2206');";
	localdb.executeSync(_sql);
	
	// 设置更新计数器表和更新记录表
	dbsyncdata.setUpdRecord({
		id: cydowServiceId,
		moduleid: constants.getConstants("moduleType_contact"),
		updtime: _nowTime, 
		recordtype: constants.getConstants("recordType_create"), 
		datatype: constants.getConstants("datatype_contact")
	});
}

/**
 * 获取联系人属性
 * @param _data
 * @param _dataType
 * @returns
 */
function getProperties(_data, _dataType){
	var _properties = [];
	if(null != _data && _data.length > 0){
		for(var i=0; i<_data.length; i++){
			if("" == _data[i]) continue;
			_properties.push({
				type: _dataType,
				value: _data[i]
			});
		}
	}
	return _properties;
}

/**
 * 处理数据库升级（19）
 * @returns
 */
function handleUpgradeDb19(){
	//联系人属性表（contacts_properties）
	if (!existTable("contacts_properties")){
		var _sql_contacts_properties_create = "create table contacts_properties (sno integer primary key autoincrement, id varchar(45), type text, value text);";
		localdb.executeSync(_sql_contacts_properties_create);
	}
	//慧影号对应表（contacts_cydowid_relation）
	if (!existTable("contacts_cydowid_relation")){
		var _sql_contacts_cydowid_relation_create = "create table contacts_cydowid_relation (sno integer primary key autoincrement, cydowid varchar(16), phone varchar(24));";
		localdb.executeSync(_sql_contacts_cydowid_relation_create);
	}
	
	//名片信息表（contacts_vcard_tmp）
	if (existTable("contacts_vcard_tmp")){
		var _sql_contacts_vcard_tmp_drop = "drop table contacts_vcard_tmp;";
		localdb.executeSync(_sql_contacts_vcard_tmp_drop);
	}
	var _sql_contacts_vcard_tmp = "create table contacts_vcard_tmp(id varchar(45) primary key," +
			" infoid varchar(45), headurl text, name text," +
			" gender varchar(2) default 0, company text, department text, " +
			" position text, website text, defaultflag varchar(2) default 0," +
			" starttime integer, endtime integer, deleted integer default 0," +
			" notifyid integer, createtime integer, updatetime integer, extensions text);";
	localdb.executeSync(_sql_contacts_vcard_tmp);
	var _sql_contacts_vcard_select = "select * from contacts_vcard;";
	var _data = localdb.querySync(_sql_contacts_vcard_select);
	if(null != _data && _data.length > 0){
		for(var i=0; i<_data.length; i++){
			var _rowData = _data[i];
			if(null == _rowData) continue;
			var _properties = [];
			//手机号
			if("" != _rowData.mobilephone){
				var _phone = jsonTools.strToJsonObj(_rowData.mobilephone);
				_properties = _properties.concat(getProperties(_phone, "phone.mobile"));
			}
			//固话
			if("" != _rowData.fixphone){
				var _phone = jsonTools.strToJsonObj(_rowData.fixphone);
				_properties = _properties.concat(getProperties(_phone, "phone.work"));
			}
			//慧影号
			if("" != _rowData.cydowid){
				_properties.push({
					type: "cydowid.default",
					value: _rowData.cydowid
				});
			}
			//邮箱
			if("" != _rowData.emailaddr){
				var _email = jsonTools.strToJsonObj(_rowData.emailaddr);
				_properties = _properties.concat(getProperties(_email, "email.work"));
			}
			//地址
			if("" != _rowData.address){
				_properties.push({
					type: "address.work",
					value: _rowData.address
				});
			}
			_rowData.properties = _properties;
			insertVCardTmpData(_rowData);
		}
	}
	var _sql_contacts_vcard_drop = "drop table contacts_vcard;";
	localdb.executeSync(_sql_contacts_vcard_drop);
	var _sql_contacts_vcard_tmp_rename = "alter table contacts_vcard_tmp rename to contacts_vcard;";
	localdb.executeSync(_sql_contacts_vcard_tmp_rename);
	
	
	//联系人信息表（contacts_contact_tmp）
	if (existTable("contacts_contact_tmp")){
		var _sql_contacts_contact_tmp_drop = "drop table contacts_contact_tmp;";
		localdb.executeSync(_sql_contacts_contact_tmp_drop);
	}
	var _sql_contacts_contact_tmp = "create table contacts_contact_tmp(id varchar(45) primary key, " +
			"infoid varchar(45), type text not null, headurl text, goodsname text, " +
			"name text, gender varchar(2) default 0, birthday integer, " +
			"company text, department text, position text, comwebsite text, " +
			"nativeplace text, edubackground text, degree text, interests text, " +
			"meetoccasion text, groups text, remarks text, deleted integer default 0, " +
			"createtime integer, updatetime integer, extensions text);";
	localdb.executeSync(_sql_contacts_contact_tmp);
	var _hasCydowService = false;
	var _sql_contacts_contact_select = "select * from contacts_contact;";
	_data = localdb.querySync(_sql_contacts_contact_select);
	if(null != _data && _data.length > 0){
		_hasCydowService = true;
		for(var i=0; i<_data.length; i++){
			var _rowData = _data[i];
			if(null == _rowData) continue;
			var _properties = [];
			//手机号
			if(null != _rowData.mobilephone && "" != _rowData.mobilephone){
				var _phone = jsonTools.strToJsonObj(_rowData.mobilephone);
				_properties = _properties.concat(getProperties(_phone, "phone.mobile"));
			}
			//固话
			if(null != _rowData.fixphone && "" != _rowData.fixphone){
				var _fixPhone = jsonTools.strToJsonObj(_rowData.fixphone);
				_properties = _properties.concat(getProperties(_fixPhone, "phone.work"));
			}
			//家庭电话
			if(null != _rowData.homephone && "" != _rowData.homephone){
				var _homePhone = jsonTools.strToJsonObj(_rowData.homephone);
				_properties = _properties.concat(getProperties(_homePhone, "phone.home"));
			}
			//工作电话
			if(null != _rowData.jobphone && "" != _rowData.jobphone){
				var _jobPhone = jsonTools.strToJsonObj(_rowData.jobphone);
				_properties = _properties.concat(getProperties(_jobPhone, "phone.work"));
			}
			//慧影号
			if(null != _rowData.cydowid && "" != _rowData.cydowid){
				_properties.push({
					type: "cydowid.default",
					value: _rowData.cydowid
				});
			}
			//工作邮箱
			if(null != _rowData.jobemailaddr && "" != _rowData.jobemailaddr){
				var _jobEmail = jsonTools.strToJsonObj(_rowData.jobemailaddr);
				_properties = _properties.concat(getProperties(_jobEmail, "email.work"));
			}
			//个人邮箱
			if(null != _rowData.ownemailaddr && "" != _rowData.ownemailaddr){
				var _ownEmail = jsonTools.strToJsonObj(_rowData.ownemailaddr);
				_properties = _properties.concat(getProperties(_ownEmail, "email.personal"));
			}
			//工作地址
			if(null != _rowData.comaddr && "" != _rowData.comaddr){
				_properties.push({
					type: "address.work",
					value: _rowData.comaddr
				});
			}
			//家庭地址
			if(null != _rowData.homeaddr && "" != _rowData.homeaddr){
				_properties.push({
					type: "address.home",
					value: _rowData.homeaddr
				});
			}
			if(null != _rowData.grade){
				_rowData.company = _rowData.grade;
			}
			_rowData.properties = _properties;
			insertContactsTmpData(_rowData);
		}
	}
	//存储慧影客服（大慧小影）慧影号
	dbcydowidrelation.insertCydowIdRelData([{
		cydowid: "100000010",
		phone: "13720028991"
	}]);
	//若没有大慧小影信息，则添加其信息
	if(!_hasCydowService){
		handleUpgradeDbContactTable19();
	}
	
	var _sql_contacts_contact_drop = "drop table contacts_contact;";
	localdb.executeSync(_sql_contacts_contact_drop);
	var _sql_contacts_contact_tmp_rename = "alter table contacts_contact_tmp rename to contacts_contact;";
	localdb.executeSync(_sql_contacts_contact_tmp_rename);
}

/**
 * 处理数据库升级（20）
 * @returns
 */
function handleUpgradeDb20(){
	//卡片表（mytask）增加一个数据来源的字段（datasource）
	var _sql = "alter table mytask add column source text default '0';";
	localdb.executeSync(_sql);
	
	//卡片表（mytask）增加一个标记删除的字段（deleted）
	_sql = "alter table mytask add column deleted integer default 0;";
	localdb.executeSync(_sql);
	
	//创建系统日历关系表（syscalendar）
	if(!existTable("syscalendar")){
		_sql = "create table syscalendar(sno integer primary key autoincrement," +
				" id varchar(128), taskid varchar(45)," +
				" createtime integer);";
		localdb.executeSync(_sql);
	}
}

/**
 * 处理数据库升级（21）
 * @returns
 */
function handleUpgradeDb21(){
	var _sql = "";
	//创建联系人群组表（contacts_groups）
	if(!existTable("contacts_group")){
		_sql = "create table contacts_group (sno integer primary key autoincrement, " +
				"id varchar(45), name text, createtime integer, updatetime integer);";
		localdb.executeSync(_sql);
	}
	
	//创建联系人群组关系表（contacts_groups_relation）
	if(!existTable("contacts_group_relation")){
		_sql = "create table contacts_group_relation(sno integer primary key autoincrement, " +
				"id varchar(45), groupid varchar(45), contactid varchar(45), " +
				"removed integer default 0, updatetime integer);";
		localdb.executeSync(_sql);
	}
}

/**
 * 处理数据库升级（22）
 * @returns
 */
function handleUpgradeDb22(){
	// 时间卡片表（mytask）增加历法类型及标记完成字段（completed）
	localdb.executeSync1({sqls: [
		"alter table mytask add column calendartype varchar(2) default '0';",
		"alter table mytask add column completed varchar(2) default '0';"
	]});
	
	// 联系人表（contacts_contact）增加历法类型字段（calendartype）
	var _sql = "alter table contacts_contact add column calendartype varchar(2) default '0';";
	localdb.executeSync(_sql);
	
	// 周期（重复）记录表（cyclerecord）增加三个字段（endtime、week及weekday）
	localdb.executeSync1({sqls:[
		"alter table cyclerecord add column endtime integer default 0;",
		"alter table cyclerecord add column week text;",
		"alter table cyclerecord add column weekday varchar(2);"
	]});
	
	// 向周期（重复）类型表（cycletype）中插入两条数据
	_sql = "insert into cycletype (id, name, timelength, type) values(9, '工作日', 432000000, 1),(10, '每周几', 604800000, 2);"
	localdb.executeSync(_sql);
}

///**
// * 设置安卓桌面小部件数据
// * @param _startTime
// * @param _endTime
// * @param _func
// * @returns
// */
//function setWidgetDatas(_startTime, _endTime, _func){
//	var _widgetTools = require("widgetTools.ui");
//	var _fields = " id, title, start, end, source, completed, infocategory ";
//	var _conditions = " start<=" + _endTime + " and end>=" + _startTime;
//	// 获取指定时间段内的待办卡片信息，并处理这些信息
//	dbtask.query_taskFieldsByCondition(_fields, _conditions, function(_taskDatas){
//		print(JSON.stringify(_taskDatas), "---------task");
//		// 添加待办卡片信息到桌面小部件
//		_widgetTools.addInfoList(_taskDatas, function(){
//			_fields = " id, commname, start, calendartype, source, infocategory ";
//			_conditions = " start<=" + _endTime + " and start>=" + _startTime;
//			// 获取指定时间段内的纪念日卡片信息，并处理这些信息
//			dbcomm.query_commFieldsByCondition(_fields, _conditions, function(_commDatas){
//				print(JSON.stringify(_commDatas), "---------comm");
//				// 添加纪念日卡片信息到桌面小部件
//				_widgetTools.addInfoList(_commDatas, function(){
//					// 获取指定时间段内的生日卡片信息，并处理这些信息
//					dbbirthday.query_birthFieldsByCondition(_fields, _conditions, function(_birthDatas){
//						print(JSON.stringify(_birthDatas), "---------birth");
//						// 添加纪念日卡片信息到桌面小部件
//						_widgetTools.addInfoList(_birthDatas, function(){
//							// 刷新桌面小部件显示内容
//							_widgetTools.refresh();
//							// 回调函数
//							_func.call(this);
//						});
//					});
//				});
//			});
//		});
//	});
//}

//// 设置安卓桌面小部件数据
//module.exports.setWidgetDatas = function(_startTime, _endTime, _func){
//	setWidgetDatas(_startTime, _endTime, _func);
//};

/**
 * 处理数据库升级（23）-主要给安卓桌面小部件添加数据
 * @param _func
 * @returns
 */
function handleUpgradeDb23(_func){
//	var do_device = sm("do_Device");
//	//获取操作系统信息
//	var _osInfo = do_device.getInfo().OS;
//	// 若为安卓系统，则给桌面小部件设置数据；否则直接返回
//	if(_osInfo.indexOf("android") >= 0){
//		var _nowTime = new Date();
//		_nowTime.setHours(0, 0, 0, 0);
//		// 开始时间为当天起始时间
//		var _startTime = _nowTime.getTime();
//		// 结束时间为从当天起始时间向后推30天
//		var _endTime = _nowTime.getTime() + (30 * 24 * 3600 * 1000);
//		// 设置安卓桌面小部件数据
//		setWidgetDatas(_startTime, _endTime, _func);
//	} else {
		// 回调函数
		_func.call(this);
//	}
}

/**
 * 处理数据库升级（24）-主要给周期性待办添加更新记录
 * @param _func
 * @returns
 */
function handleUpgradeDb24(_func){
	var _condition = "infocategory=" + constants.getConstants("infoCategory_task");
	var _cycleRecordList = dbcycle.query_cycleRecordByCondition(_condition);
	var _sqlList = [];
	if(null != _cycleRecordList){
		var _sql = "";
		// 更新计数器
		var _updCountData = dbsyncdata.query_updCount(constants.getConstants("moduleType_timeflow"));
		var _count = _updCountData.updatecount;
		// 更新时间
		var _updTime = (new Date()).getTime();
		// 遍历周期记录列表
		for(var i=0; i<_cycleRecordList.length; i++){
			var _cycleRecord = _cycleRecordList[i];
			if(null == _cycleRecord || 
					null == _cycleRecord.taskid ||
					"" == _cycleRecord.taskid) continue;
			// 查询周期待办主卡片信息
			var _taskCardData = dbtask.get_mytaskOneData(_cycleRecord.taskid);
			// 若周期待办主卡片信息不为空，则进行相应的处理操作
			if(null != _taskCardData){
				_count++;
				// 添加更新记录语句
				_sql = dbsyncdata.getUpdRecordDataSql({
					id: _taskCardData.id,
					moduleid: constants.getConstants("moduleType_timeflow"),
					updtime: _updTime,
					recordtype: constants.getConstants("recordType_update"),
					datatype: constants.getConstants("datatype_timecard"),
					count: _count
				});
				_sqlList.push(_sql);
			} else {
				// 删除周期性记录表指定标识（id）的记录
				_sql = dbcycle.getDelCycleRecordDataSql(_cycleRecord.id);
				_sqlList.push(_sql);
			}
		}
		// 若需要添加更新记录的sql语句列表不为空，则添加更新计数器及执行sql语句
		if(_sqlList.length > 0){
			// 添加更新计数器语句
			_sql = dbsyncdata.getUpdUpdCountDataSql({
				updtime: _updTime,
				updcount: _count,
				moduleid: constants.getConstants("moduleType_timeflow")
			});
			_sqlList.push(_sql);
			// 执行sql语句
			localdb.execute1({sqls: _sqlList}, function(){
				// 回调函数
				_func.call(this);
			});
		} else {
			// 回调函数
			_func.call(this);
		}
	} else {
		// 回调函数
		_func.call(this);
	}
}

/**
 * 处理数据库升级（25）
 *        主要删除已经清理的待办（标记删除）和增加清理数据记录表
 * @param _func
 * @returns
 */
function handleUpgradeDb25(_func){
	var _widgetTools = require("widgetTools.ui");
	// 清空安卓桌面小部件缓存数据
	_widgetTools.removeInfo([]);
	_widgetTools.refresh();
	
	var _sql = "";
	//创建清理数据记录表（dataclear_record）
	if(!existTable("dataclear_record")){
		_sql = "create table dataclear_record (sno integer primary key autoincrement, id varchar(45), moduleid text, infocategory integer, createtime integer);";
		localdb.executeSync(_sql);
	}
	
	// 模块标识（时间流）
	var _moduleId = constants.getConstants("moduleType_timeflow");
	// 信息类别（待办事宜）
	var _infoCategoryTask = constants.getConstants("infoCategory_task");
	_sql = "select id, notifyid from mytask where deleted=1 and infocategory="+ _infoCategoryTask + ";";
	// 查询所有清理过的待办
	localdb.query({
		sql: _sql
	}, function(_taskList){
		// 若待办列表不为空，则遍历待办列表，并做相应处理；
		// 否则直接返回
		if(null != _taskList &&
				_taskList.length > 0){
			// sql语句列表
			var _sqlList = [];
			// 提醒标识id列表
			var _notifyIdList = [];
			// 所有指定id标识
			var _taskIdStr = "";
			// 遍历待办列表
			for(var i=0; i<_taskList.length; i++){
				var _taskData = _taskList[i];
				if(null == _taskData || "" == _taskData) continue;
				var _taskId = _taskData.id;
				if(null == _taskId || "" == _taskId) continue;
				// 添加提醒标识id到列表中
				_notifyIdList.push(parseInt(_taskData.notifyid));
				// 追加待办标识id
				_taskIdStr += "'" + _taskId + "'";
				_taskIdStr += ",";
				// 需要将周期待办副卡去除掉，
				// 所以数据标识id长度为1到24位数据才可以
				if(_taskId.length > 0 && _taskId.length <= 24){
					// 获取插入一条数据清理的sql语句
					_sql = dbcleardata.getInsertDataClearRecordSql({
						id: _taskId,
						moduleid: _moduleId,
						infocategory: _infoCategoryTask
					});
				}
				// 添加sql语句到sql语句列表中
				_sqlList.push(_sql);
			}
			// 若提醒标识id列表不为空，则清除指定的本地提醒
			if(_notifyIdList.length > 0){
				// 清除指定的本地提醒
				notificationTools.removeLocalNotification(_notifyIdList, []);
			}
			// 若待办标识字符串不为空，则生成sql语句
			if(_taskIdStr.length > 0){
				_taskIdStr = _taskIdStr.substr(0, _taskIdStr.length - 1);
				_sql = "delete from mytask where id in(" + _taskIdStr + ");";
				// 添加sql语句到sql语句列表中
				_sqlList.push(_sql);
			}
			// 若sql语句列表不为空，则执行所有sql语句
			if(_sqlList.length > 0){
				// 执行sql语句
				localdb.execute1({sqls: _sqlList}, function(){
					// 回调函数
					_func.call(this);
				});
			} else {
				// 回调函数
				_func.call(this);
			}
		} else {
			// 回调函数
			_func.call(this);
		}
	});
}

/**
 * 检测通讯录联系人
 * @param _phoneBook
 * @param _contactList
 * @returns
 */
function checkPhoneBookContact(_phoneBook, _contactList){
	if(tools.isNullOrEmpty(_phoneBook.name)) return "";
	var _phoneBookInfo = "";
	if(!tools.isNullOrEmpty(_phoneBook.phone)){
		_phoneBookInfo = _phoneBook.phone.join();
	}
	var _contactId = "";
	for(var i=0; i<_contactList.length; i++){
		var _contact = _contactList[i];
		if(null == _contact || 
				tools.isNullOrEmpty(_contact.name)) 
			continue;
		if(_phoneBook.name == _contact.name){
			if(null != _contact.phone){
				if("" != _phoneBookInfo){
					var _phoneList = [];
					// 手机号
					var _phone = _contact.phone.phone;
					if(!tools.isNullOrEmpty(_phone)){
						_phoneList.push(_phone);
					}
					// 工作电话
					_phone = _contact.phone.work;
					if(!tools.isNullOrEmpty(_phone)){
						_phoneList.push(_phone);
					}
					// 其他电话
					_phone = _contact.phone.other;
					if(!tools.isNullOrEmpty(_phone)){
						_phoneList.push(_phone);
					}
					// 工作传真
					_phone = _contact.phone.faxWork;
					if(!tools.isNullOrEmpty(_phone)){
						_phoneList.push(_phone);
					}
					// 家庭传真
					_phone = _contact.phone.faxHome;
					if(!tools.isNullOrEmpty(_phone)){
						_phoneList.push(_phone);
					}
					// 家庭电话
					_phone = _contact.phone.home;
					if(!tools.isNullOrEmpty(_phone)){
						for(var j=0; j<_phone.length; j++){
							if(tools.isNullOrEmpty(_phone[j])) continue;
							_phoneList.push(_phone[j]);
						}
					}
					if(_phoneList.length > 0){
						var _isExist = true;
						for(var k=0; k<_phoneList.length; k++){
							if(_phoneBookInfo.indexOf(_phoneList[k]) == -1){
								_isExist = false;
								break;
							}
						}
						if(_isExist){
							_contactId = _contact.id;
							_contactList[i] = null;
							break;
						}
					}
				}
			} else {
				if("" == _phoneBookInfo){
					_contactId = _contact.id;
					_contactList[i] = null;
					break;
				}
			}
		}
	}
	return _contactId;
}

/**
 * 处理手机通讯录联系人
 * @param _callFunc
 * @returns
 */
function handleContactData(_callFunc){
	var do_device = sm("do_Device");
	//获取操作系统信息
	var _osInfo = do_device.getInfo().OS;
	// 若为ios系统，则处理导入导出记录数据
	if(_osInfo.indexOf("android") == -1){
		print("ios ");
		var dbcontactimexport = require("dbcontactimexport");
		// 通过id获取联系人导入导出记录
		var _imExRecordList = dbcontactimexport.query_contactAllImExportData();
		print("_imExRecordList " + JSON.stringify(_imExRecordList));
		if(null != _imExRecordList && _imExRecordList.length > 0){
			// 同步do_Contact获取手机通讯录联系人
			sm("do_Contact").getData(function(_phoneBookList){
				print("_phoneBookList " + JSON.stringify(_phoneBookList));
				if(undefined != _phoneBookList &&
						null != _phoneBookList &&
						_phoneBookList.length > 0){
					// 同步M0017_Contact获取手机通讯录联系人
					sm("M0017_Contact").getData(function(_data){
						print("_data " + JSON.stringify(_data));
						if(undefined != _data &&
								null != _data &&
								null != _data.results && 
								_data.results.length > 0){
							var _contactList = _data.results;
							var _sqlList = [];
							// 遍历导入导出记录
							for(var i=0; i<_imExRecordList.length; i++){
								var _imExRecord = _imExRecordList[i];
								if(null == _imExRecord) continue;
								// 若通讯录id位数小于15，则说明该记录为旧组件获取的联系人id标识，
								// 需要处理该联系人的导入导出记录；否则，说明已经处理过了，直接跳过
								if(_imExRecord.phonebookid.length < 15){
									var _isExist = false;
									var _sql = "";
									// 遍历通讯录联系人
									for(var j=0; j<_phoneBookList.length; j++){
										var _phoneBook = _phoneBookList[j];
										if(null == _phoneBook) continue;
										if(_phoneBook.id == _imExRecord.phonebookid){
											var _phoneBookId = checkPhoneBookContact(_phoneBook, _contactList);
											if("" != _phoneBookId) {
												_imExRecord.phonebookid = _phoneBookId;
												_sql = dbcontactimexport.getUpdPhoneBookIdSql(_imExRecord);
												_sqlList.push(_sql);
												_phoneBookList[j] = null;
												_isExist = true;
												break;
											}
										}
									}
									if(!_isExist){
										_sql = dbcontactimexport.getDelContactImExportDataSql(_imExRecord.contactid);
										_sqlList.push(_sql);
									}
								}
							}
							if(_sqlList.length > 0){
								// 执行sql语句
								localdb.execute1({sqls: _sqlList}, function(){
									// 回调函数
									_callFunc.call(this);
								});
							} else {
								// 回调函数
								_callFunc.call(this);
							}
						} else {
							// 回调函数
							_callFunc.call(this);
						}
					});
				} else {
					// 回调函数
					_callFunc.call(this);
				}
			});
		} else {
			// 回调函数
			_callFunc.call(this);
		}
	} else {
		// 回调函数
		_callFunc.call(this);
	}
}

/**
 * 处理数据库升级（26）
 *     处理联系人组件升级唯一标识（id）改变的问题
 * @param _callFunc
 * @returns
 */
function handleUpgradeDb26(_callFunc){
	// 处理联系人数据
	handleContactData(_callFunc);
}

/**
 * 处理数据库升级（27）
 *     增加联系人姓名首字母字段，并存入联系人姓名首字母
 * @param _callFunc
 * @returns
 */
function handleUpgradeDb27(_callFunc){
	//联系人表（contacts_contact）增加一个姓名拼音的字段（pinyin）
	var _sql = "alter table contacts_contact add column pinyin text;";
	localdb.executeSync(_sql);
	
	// 查询并遍历所有联系人，之后获取所有联系人姓名拼音，
	// 并更新到联系人表中
	var _sqlList = [];
	var _sql = "select id, name, goodsname from contacts_contact";
	localdb.query({sql: _sql}, function(_contactList){
		if(null != _contactList && _contactList.length > 0){
			for(var i=0; i<_contactList.length; i++){
				if(null == _contactList[i]) continue;
				var _contact = _contactList[i];
				var _pinyin = "";
				if(null != _contact.name && 
						"" != _contact.name){
					_pinyin = chinesePinYin.GetQP(_contact.name);
				} else {
					if(null != _contact.goodsname){
						_pinyin = chinesePinYin.GetQP(_contact.goodsname);
					}
				}
				_sql = "update contacts_contact set pinyin=" 
					+ tools.formatSqlValue(_pinyin) + " where id="
					+ tools.formatSqlValue(_contact.id) + ";";
				_sqlList.push(_sql);
			}
		}
		if(_sqlList.length > 0){
			localdb.execute1({sqls: _sqlList}, function(){
				// 回调函数
				_callFunc.call(this);
			});
		} else {
			// 回调函数
			_callFunc.call(this);
		}
	});
}

/**
 * 获取指定使用或共享记录在列表中的索引
 * @param _recordList
 * @param _id
 * @returns
 */
function getUseOrShareRecordListIndex(_recordList, _id){
	var _index = -1;
	if(null != _recordList &&
			_recordList.length > 0){
		for(var i=0; i<_recordList.length; i++){
			if(_recordList[i].taskid == _id){
				_index = i;
				break;
			}
		}
	}
	return _index;
}

/**
 * 删除符合条件的使用记录或共享记录
 * @param _allRecords
 * @param _callFunc
 * @returns
 */
function delUseOrShareRecords(_allRecords, _tableName, _callFunc){
	// 需要删除的所有记录标识
	var _delRecordIds = [];
	// 信息的使用记录列表（每个信息为一条记录，记录下每次最新的）
	var _recordList = [];
	// 若使用记录列表不为空，则遍历所有使用记录
	if(null != _allRecords && _allRecords.length > 0){
		// 遍历所有使用记录
		for(var i=0; i<_allRecords.length; i++){
			var _oneRecord = _allRecords[i];
			if(null == _oneRecord) continue;
			// 获取指定使用或共享记录在列表中的索引
			var _index = getUseOrShareRecordListIndex(_recordList, _oneRecord.taskid);
			// 若找到对应记录，则进行相应的处理
			if(_index > -1){
				var _labelTime = parseInt(_recordList[_index].labeltime);
				var _curLabelTime = parseInt(_oneRecord.labeltime);
				// 若之前记录的时间大于当前记录的时间，并且之前记录的时间
				// 与当前记录的时间相差两秒，则需要删除当前的记录
				if(_labelTime > _curLabelTime && 
						(_labelTime - _curLabelTime) < 2000){
					// 将记录标识添加到删除记录标识列表
					_delRecordIds.push(tools.formatSqlValue(_oneRecord.id));
				}
				// 更新指定记录的标识及记录时间
				_recordList[_index].id = _oneRecord.id;
				_recordList[_index].labeltime = _oneRecord.labeltime;
			} else {
				// 添加使用记录到列表中
				_recordList.push(_oneRecord);
			}
			_allRecords[i] = null;
		}
	}
	_allRecords = null;
	_recordList = null;
	// 若删除记录标识列表不为空，则执行删除程序
	if(_delRecordIds.length > 0){
		var _ids = _delRecordIds.join(",");
		var _sql = "delete from " + _tableName + 
			" where id in (" + _ids + ");";
		localdb.execute({sql: _sql}, function(){
			// 回调函数
			_callFunc.call(this);
		});
	} else {
		// 回调函数
		_callFunc.call(this);
	}
}

/**
 * 处理所有使用记录和共享记录
 * @param _callFunc
 * @returns
 */
function handleUseAndShareRecord(_callFunc){
	var _sql = "select id, taskid, labeltime from userecord order by labeltime DESC;";
	// 查询所有使用记录
	localdb.query({sql: _sql}, function(_useRecords){
		// 删除所有满足条件的使用记录
		delUseOrShareRecords(_useRecords, "userecord", function(){
			_useRecords = null;
			
			_sql = "select id, taskid, labeltime from sharerecord order by labeltime DESC;";
			// 查询所有共享记录
			localdb.query({sql: _sql}, function(_shareRecords){
				// 删除所有满足条件的共享记录
				delUseOrShareRecords(_shareRecords, "sharerecord", function(){
					_shareRecords = null;
					
					
					// 回调函数
					_callFunc.call(this);
				});
			});
		});
	});
}

/**
 * 处理数据库升级（28）
 *     增加待办或纪念日颜色字段
 * @param _callFunc
 * @returns
 */
function handleUpgradeDb28(_callFunc){
	print("handleUpgradeDb28 ");
	// 时间流卡片信息表（mytask）增加一个颜色的字段（colors）
	var _sql = "alter table mytask add column colors text;";
	localdb.executeSync(_sql);
	
	// 周期（重复）记录表（cyclerecord）增加三个字段（type、frequency及selection）
	localdb.executeSync1({sqls:[
		"alter table cyclerecord add column type integer;",
		"alter table cyclerecord add column frequency integer;",
		"alter table cyclerecord add column selection text;"
	]});
	
	// 向周期（重复）类型表（cycletype）中插入数据
	_sql = "insert into cycletype (id, name, timelength, type) values(11, '自定义', 0, 2);"
	localdb.executeSync(_sql);
	
	// 缓存引导页版本标识（代表老用户，值为1）
	do_dataCache.saveData("guidePageVer", 1);
	
	/**
	 * 处理使用记录和共享记录旧数据
	 */
	handleUseAndShareRecord(function (){
		// 回调函数
		_callFunc.call(this);
	});
}

/**
 * 处理数据库升级（29）
 *     名片表增加生日、历法类型及备注字段
 * @param _callFunc
 * @returns
 */
function handleUpgradeDb29(_callFunc){
	print("handleUpgradeDb29 ");
	// 名片记录表（contacts_vcard）增加三个字段（birthday、calendartype及remarks）
	localdb.executeSync1({sqls:[
		"alter table contacts_vcard add column birthday integer;",
		"alter table contacts_vcard add column calendartype varchar(2) default '0';",
		"alter table contacts_vcard add column remarks text;"
	]});
	
	// 查询已有的默认名片信息
	var _vcardData = dbcontactcard.query_contactCardDataByDefaultFlag("1");
	// 若存在默认名片，则给默认名片增加一条同步更新记录
	if(null != _vcardData){
		var _nowTime = new Date();
		//设置更新计数器表和更新记录表
		dbsyncdata.setUpdRecord({
			id: _vcardData.id,
			moduleid: constants.getConstants("moduleType_contact"),
			updtime: _nowTime.getTime(), 
			recordtype: constants.getConstants("recordType_update"), 
			datatype: constants.getConstants("datatype_contactcard")
		});
	}
	
	// 生日提前提醒时长改为“正点提醒”
	var _sql = "update mytask set remindtime=17 where infocategory=4;";
	localdb.execute({sql: _sql}, function(){
		// 回调函数
		_callFunc.call(this);
	});
}

/**
 * 处理数据库升级（30）
 *     系统日历表增加数据来源字段
 * @param _callFunc
 * @returns
 */
function handleUpgradeDb30(_callFunc){
	print("handleUpgradeDb30 ");
	// 系统日历表（syscalendar）增加数据来源字段（source）
	localdb.executeSync1({sqls:[
		"alter table syscalendar add column source varchar(2) default '0';",
	]});
	
	//创建本地消息表（local_message）
	if(!existTable("local_message")){
		var _sql = "create table local_message (sno integer primary key autoincrement, " +
				"id varchar(45), type integer, remindtime integer, " +
				"againtime integer, notifyid integer, flag integer default 0, " +
				"createtime integer, updatetime integer);";
		localdb.executeSync(_sql);
	}
	
	// 回调函数
	_callFunc.call(this);
}

/**
 * 处理数据库升级（31）
 *     数据同步增加几张新表
 * @param _callFunc
 * @returns
 */
function handleUpgradeDb31(_callFunc){
	print("handleUpgradeDb31 ");
	var _sql = "";
	var _sqlList = [];
	// 时间流卡片表增加更多字段（morefields）
	_sql = "alter table mytask add column morefields text;";
	_sqlList.push(_sql);
	// 联系人表增加更多字段（morefields）
	_sql = "alter table contacts_contact add column morefields text;";
	_sqlList.push(_sql);
	// 名片表增加更多字段（morefields）
	_sql = "alter table contacts_vcard add column morefields text;";
	_sqlList.push(_sql);
	// 群组表增加更多字段（morefields）
	_sql = "alter table contacts_group add column morefields text;";
	_sqlList.push(_sql);
	
	// 创建更新记录表（datasync_cl_updrecord）
	if(!existTable("datasync_cl_updrecord")){
		_sql = "create table datasync_cl_updrecord (" +
				"moduleid varchar(128), dataid varchar(128) primary key, " +
				"datatype varchar(128), recordtime integer, recordtype integer, " +
				"handlestate integer);";
		_sqlList.push(_sql);
	}
	// 创建失败记录表（datasync_cl_failrecord）
	if(!existTable("datasync_cl_failrecord")){
		_sql = "create table datasync_cl_failrecord (" +
				"moduleid varchar(128), dataid varchar(128) primary key, " +
				"datatype varchar(128), recordtime integer, recordtype integer);";
		_sqlList.push(_sql);
	}
	// 创建同步状态信息表（datasync_cl_syncinfo）
	if(!existTable("datasync_cl_syncinfo")){
		_sql = "create table datasync_cl_syncinfo (" +
				"synccount integer, synctime integer, syncstate integer, " +
				"moduleid varchar(128) primary key, clearcount integer, " +
				"cleartime integer, synctype integer);";
		_sqlList.push(_sql);
	}
	if(_sqlList.length > 0){
		localdb.executeSync1(_sqlList);
	}
	
	// 初始化清零和同步计数器的信息
	_sql = "insert into datasync_cl_syncinfo(moduleid, synccount, clearcount, " +
			"synctype) values(" +
			"'a3447940-3682-1350-c354-47e751052', 0, 0, 0)," +
			"('d5a7e559-9e1c-4337-8ce7-00cac629cb2c'," +
			" 0, 0, 0);";
	localdb.executeSync(_sql);
	
	_sqlList = [];
	// 清理使用记录、共享记录和群组关系的数据
	_sql = "delete from datasync_updrecord where (datatype='6' " +
			"and id not in (select id from userecord)) or " +
			"(datatype='7' and id not in (select id from " +
			"sharerecord)) or (datatype='5' and id not in " +
			"(select id from contacts_group_relation));"
	_sqlList.push(_sql);
	
	// 更新记录由旧表导入到新表里面
	_sql = "insert into datasync_cl_updrecord (dataid, moduleid, " +
			"datatype, recordtime, recordtype, handlestate) " +
			"select id, moduleid, datatype, recordtime, " +
			"recordtype, 0 from datasync_updrecord;";
	_sqlList.push(_sql);
	// 异步执行sql语句
	localdb.execute1({sqls: _sqlList}, function(){
		// 回调函数
		_callFunc.call(this);
	});
}

/**
 * 处理分享消息
 * @param _sqlList
 * @param _callFunc
 * @returns
 */
function handleShareMessage(_sqlList, _callFunc){
	// 查询分享消息表
	var _sql = "select * from channel_cydow_message where " +
			"transtype=1 and handlestate=0;";
	localdb.query({sql: _sql}, function(_data){
		if(null != _data && _data.length > 0){
			var _tmpSql = "";
			for(var i=0; i<_data.length; i++){
				if(null == _data[i]) continue;
				if(_tmpSql.length > 0){
					_tmpSql += ",";
				}
				var _source = 1;
				if("contact" == _data[i].channel){
					_source = 2;
				}
				_tmpSql += "(";
				_tmpSql += tools.formatSqlValue(_data[i].id) + ",";
				_tmpSql += tools.formatSqlValue(_data[i].id) + ",";
				_tmpSql += _source + ",";
				_tmpSql += "1,";
				_tmpSql += tools.formatSqlValue(_data[i].subject) + ",";
				_tmpSql += "1,0,";
				_tmpSql += _data[i].receivetime + ",";
				_tmpSql += _data[i].createtime + ",";
				_tmpSql += _data[i].updatetime + ")";
			}
			if(_tmpSql.length > 0){
				_sql = "insert into fw_message_center(id, msgid, source, msgtype, " +
				"title, msgcount, status, receivetime, createtime, " +
				"updatetime)values";
				_sql += _tmpSql;
				_sql += ";";
				_sqlList.push(_sql);
			}
		}
		_callFunc.call(this);
	});
}

/**
 * 处理本地消息
 * @param _sqlList
 * @param _callFunc
 * @returns
 */
function handleLocalMessage(_sqlList, _callFunc){
	var _nowTime = (new Date()).getTime();
	// 查询本地消息表
	var _sql = "select * from local_message;";
	localdb.query({sql: _sql}, function(_data){
		if(null != _data && _data.length > 0){
			var _tmpSql = "";
			for(var i=0; i<_data.length; i++){
				if(null == _data[i]) continue;
				// 提醒时间已经过去的本地提醒任务，在消息中心添加一条消息
				if(parseInt(_data[i].remindtime) < _nowTime){
					if(_tmpSql.length > 0){
						_tmpSql += ",";
					}
					_tmpSql += "(";
					_tmpSql += tools.formatSqlValue(_data[i].id) + ",";
					_tmpSql += tools.formatSqlValue(_data[i].id) + ",";
					_tmpSql += "3,";
					_tmpSql += _data[i].type;
					_tmpSql += "1,";
					_tmpSql += _data[i].flag;
					_tmpSql += _data[i].remindtime + ",";
					_tmpSql += _data[i].createtime + ",";
					_tmpSql += _data[i].updatetime + ")";
				}
			}
			if(_tmpSql.length > 0){
				_sql = "insert into fw_message_center(id, msgid, source, msgtype, " +
				"msgcount, status, remindtime, createtime, " +
				"updatetime)values";
				_sql += _tmpSql;
				_sql += ";";
				_sqlList.push(_sql);
			}
		}
		_callFunc.call(this);
	});
}

/**
 * 判断对象是否为空（没有任何属性）
 * @param _object
 * @returns
 */
function isEmptyObject(_object){
	var _isNull = true;
	if(null != _object){
		for(var _key in _object){
			_isNull = false;
		}
	}
	return _isNull;
}

/**
 * 获取更新字段的sql语句
 * @param _moreFeilds
 * @returns
 */
function getUpdFeildSql(_moreFeilds){
	var _origin = new Object();
	var _preSrc = new Object();
	var _feildData = new Object();
	for(var _field in _moreFeilds){
		var _fieldData = _moreFeilds[_field];
		if("origin" == _field){
			_origin = _fieldData;
		} else if("presrc" == _field){
			_preSrc = _fieldData;
		} else {
			_feildData[_field] = _fieldData;
		}
	}
	if(isEmptyObject(_origin)){
		_origin = "";
	} else {
		_origin = JSON.stringify(_origin);
	}
	if(isEmptyObject(_preSrc)){
		_preSrc = "";
	} else {
		_preSrc = JSON.stringify(_preSrc);
	}
	if(isEmptyObject(_feildData)){
		_feildData = "";
	} else {
		_feildData = JSON.stringify(_feildData);
	}
	var _feildStr = "";
	if("" == _origin && 
			"" == _preSrc && 
			"" == _feildData){
		_feildStr = "";
	} else {
		_feildStr = "origin=" + tools.formatSqlValue(_origin) 
			+ ",presrc=" + tools.formatSqlValue(_preSrc) 
			+ ",morefields=" + tools.formatSqlValue(_feildData);
	}
	return _feildStr;
}

/**
 * 处理联系人更多字段
 * @param _callFunc
 * @returns
 */
function handleContactMoreFeild(_callFunc){
	// 查询所有联系人指定字段
	var _sql = "select id,morefields from contacts_contact";
	localdb.query({sql: _sql}, function(_taskList){
		print("handleContactMoreFeild _taskList " + JSON.stringify(_taskList));
		if(null != _taskList && 
				_taskList.length > 0){
			var _sqlList = [];
			// 遍历所有联系人数据
			for(var i=0; i<_taskList.length; i++){
				var _taskData = _taskList[i];
				if(null == _taskData) continue;
				var _type = _taskData.infocategory;
				var _id = _taskData.id;
				var _moreFeilds = jsonTools.strToJsonObj(_taskData.morefields);
				if(null != _moreFeilds){
					var _sql = getUpdFeildSql(_moreFeilds);
					if(_sql.length > 0){
						_sql = "update contacts_contact set " + _sql + " where id="
							+ tools.formatSqlValue(_id) + ";";
						_sqlList.push(_sql);
					}
				}
			}
			if(_sqlList.length > 0){
				// 异步执行sql语句
				localdb.execute1({sqls: _sqlList}, function(){
					_sqlList = [];
					// 回调函数
					_callFunc.call(this);
				});
			} else {
				// 回调函数
				_callFunc.call(this);
			}
		} else {
			// 回调函数
			_callFunc.call(this);
		}
	});
}

/**
 * 处理名片更多字段
 * @param _callFunc
 * @returns
 */
function handleVCardMoreFeild(_callFunc){
	// 查询所有名片指定字段
	var _sql = "select id,morefields from contacts_vcard";
	localdb.query({sql: _sql}, function(_taskList){
		print("handleVCardMoreFeild _taskList " + JSON.stringify(_taskList));
		if(null != _taskList && 
				_taskList.length > 0){
			var _sqlList = [];
			// 遍历名片数据
			for(var i=0; i<_taskList.length; i++){
				var _taskData = _taskList[i];
				if(null == _taskData) continue;
				var _id = _taskData.id;
				var _moreFeilds = jsonTools.strToJsonObj(_taskData.morefields);
				if(null != _moreFeilds){
					var _sql = getUpdFeildSql(_moreFeilds);
					if(_sql.length > 0){
						_sql = "update contacts_vcard set " + _sql + " where id="
							+ tools.formatSqlValue(_id) + ";";
						_sqlList.push(_sql);
					}
				}
			}
			if(_sqlList.length > 0){
				// 异步执行sql语句
				localdb.execute1({sqls: _sqlList}, function(){
					_sqlList = [];
					// 回调函数
					_callFunc.call(this);
				});
			} else {
				// 回调函数
				_callFunc.call(this);
			}
		} else {
			// 回调函数
			_callFunc.call(this);
		}
	});
}

/**
 * 处理时间流卡片更多字段
 * @param _callFunc
 * @returns
 */
function handleTfMoreFeild(_callFunc){
	// 查询所有待办（或纪念日）指定字段
	var _sql = "select id,cycleid,infocategory,morefields from mytask";
	localdb.query({sql: _sql}, function(_taskList){
		print("handleTfMoreFeild _taskList " + JSON.stringify(_taskList));
		if(null != _taskList && 
				_taskList.length > 0){
			var _sqlList = [];
			// 遍历所有待办（或纪念日）数据
			for(var i=0; i<_taskList.length; i++){
				var _taskData = _taskList[i];
				if(null == _taskData) continue;
				var _type = _taskData.infocategory;
				var _id = _taskData.id;
				var _moreFeilds = jsonTools.strToJsonObj(_taskData.morefields);
				if(null != _moreFeilds){
					if(constants.getConstants("infoCategory_task") == _type){
						if(1 != _taskData.cycleid){
							_id = _id.substr(0, 24);
						}
					} else if(constants.getConstants("infoCategory_comm") == _type){
						_id = _id.substr(0, 24);
					} else {
						continue;
					}
					var _sql = getUpdFeildSql(_moreFeilds);
					if(_sql.length > 0){
						_sql = "update mytask set " + _sql + " where id="
							+ tools.formatSqlValue(_id) + ";";
						_sqlList.push(_sql);
					}
				}
			}
			if(_sqlList.length > 0){
				// 异步执行sql语句
				localdb.execute1({sqls: _sqlList}, function(){
					_sqlList = [];
					// 回调函数
					_callFunc.call(this);
				});
			} else {
				// 回调函数
				_callFunc.call(this);
			}
		} else {
			// 回调函数
			_callFunc.call(this);
		}
	});
}

/**
 * 处理更多字段
 * @param _callFunc
 * @returns
 */
function handleMoreFeild(_callFunc){
	// 处理时间流卡片更多字段
	handleTfMoreFeild(function(){
		// 处理名片更多字段
		handleVCardMoreFeild(function(){
			// 处理联系人更多字段
			handleContactMoreFeild(function(){
				// 回调函数
				_callFunc.call(this);
			});
		});
	});
}

/**
 * 处理数据库升级（32）
 *     信息沟通增加几张新表，以及相关的几张表增加字段
 * @param _callFunc
 * @returns
 */
function handleUpgradeDb32(_callFunc){
	print("handleUpgradeDb32 ");
	var _sql = "";
	var _sqlList = [];
	// 时间流卡片表增加数据源字段（origin）
	_sql = "alter table mytask add column origin text;";
	_sqlList.push(_sql);
	// 时间流卡片表增加之前来源字段（presrc）
	_sql = "alter table mytask add column presrc text;";
	_sqlList.push(_sql);
	// 联系人表增加数据源字段（origin）
	_sql = "alter table contacts_contact add column origin text;";
	_sqlList.push(_sql);
	// 联系人表增加之前来源字段（presrc）
	_sql = "alter table contacts_contact add column presrc text;";
	_sqlList.push(_sql);
	// 名片表增加数据源字段（origin）
	_sql = "alter table contacts_vcard add column origin text;";
	_sqlList.push(_sql);
	// 名片表增加之前来源字段（presrc）
	_sql = "alter table contacts_vcard add column presrc text;";
	_sqlList.push(_sql);
	
	// 创建消息中心表（fw_message_center）
	if(!existTable("fw_message_center")){
		_sql = "create table fw_message_center (id varchar(45) primary key, " +
				"msgid varchar(128), source integer, msgtype integer, " +
				"title text, content text, msgcount integer, " +
				"status integer, remindtime integer, receivetime integer, " +
				"createtime integer, updatetime integer);";
		_sqlList.push(_sql);
	}
	// 创建沟通室表（fw_commu_room）
	if(!existTable("fw_commu_room")){
		_sql = "create table fw_commu_room (roomid integer, " +
				"subjectid varchar(128) primary key, subject text, " +
				"organizer varchar(45), creator varchar(45), " +
				"memcount integer, memupdtime integer, " +
				"msgcount integer, lastmsgid integer, " +
				"othermsgid integer, alreadmsgid integer, " +
				"status integer, joinway text, " +
				"existoncloud integer, pushstate integer, " +
				"moduleid varchar(45), createtime integer, " +
				"updatetime integer);";
		_sqlList.push(_sql);
	}
	// 创建沟通参与人表（fw_commu_member）
	if(!existTable("fw_commu_member")){
		_sql = "create table fw_commu_member (memid integer primary key, " +
				"userid varchar(45), nickname text, " +
				"subjectid varchar(128), role integer, " +
				"jointime integer, joinway text, " +
				"updatetime integer, status integer);";
		_sqlList.push(_sql);
	}
	// 创建沟通消息表（fw_commu_msg）
	if(!existTable("fw_commu_msg")){
		_sql = "create table fw_commu_msg (msgid integer primary key, " +
				"subjectid varchar(128), sender varchar(45), " +
				"receivers text, visittype integer, subject text, " +
				"content text, btype integer, dtype varchar(128), " +
				"sendtime integer, receivetime integer, " +
				"updatetime integer, status integer, handlestate integer);";
		_sqlList.push(_sql);
	}
	// 创建沟通草稿消息表（fw_commu_draftmsg）
	if(!existTable("fw_commu_draftmsg")){
		_sql = "create table fw_commu_draftmsg (msgid varchar(45) primary key, " +
				"subjectid varchar(128), " +
				"subject text, content text, updatetime integer);";
		_sqlList.push(_sql);
	}
	// 创建慧影用户表（fw_cydowuser）
	if(!existTable("fw_cydowuser")){
		_sql = "create table fw_cydowuser (userid varchar(45) primary key, " +
				"username varchar(45), mobile varchar(128), " +
				"email varchar(128), fullname varchar(128), " +
				"avatar text, filename varchar(128), " +
				"createtime integer, updatetime integer);";
		_sqlList.push(_sql);
	}
	if(_sqlList.length > 0){
		localdb.executeSync1(_sqlList);
	}
	
	_sqlList = [];
	// 处理分享消息
	handleShareMessage(_sqlList, function(){
		// 处理本地消息
		handleLocalMessage(_sqlList, function(){
			// 异步执行sql语句
			localdb.execute1({sqls: _sqlList}, function(){
				_sqlList = [];
				// 处理更多字段
				handleMoreFeild(function(){
					// 回调函数
					_callFunc.call(this);
				});
			});
		});
	});
}

/**
 * 处理数据库升级（33）
 *     删除数据同步几张旧表
 * @param _callFunc
 * @returns
 */
function handleUpgradeDb33(_callFunc){
	print("handleUpgradeDb33 ");
	var _sql = "";
	var _sqlList = [];
	// 更新计数器表（datasync_updcount）
	if(existTable("datasync_updcount")){
		_sql = "drop table datasync_updcount;";
		_sqlList.push(_sql);
	}
	//  更新记录表（datasync_updrecord）
	if(existTable("datasync_updrecord")){
		_sql = "drop table datasync_updrecord;";
		_sqlList.push(_sql);
	}
	// 同步计数器表（datasync_synccount）
	if(existTable("datasync_synccount")){
		_sql = "drop table datasync_synccount;";
		_sqlList.push(_sql);
	}
	// 同步记录表（datasync_syncrecord）
	if(existTable("datasync_syncrecord")){
		_sql = "drop table datasync_syncrecord;";
		_sqlList.push(_sql);
	}
	if(_sqlList.length > 0){
		// 异步执行sql语句
		localdb.execute1({sqls: _sqlList}, function(){
			_sqlList = null;
			// 回调函数
			_callFunc.call(this);
		});
	} else {
		_sqlList = null;
		// 回调函数
		_callFunc.call(this);
	}
}

/**
 * 升级数据库（23）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb23(_dbVersion, _func){
	//处理数据库升级（23）
	if(_dbVersion < 23){
		handleUpgradeDb23(function(){
			// 升级数据库（24）
			upgradeDb24(_dbVersion, _func);
		});
	} else {
		// 升级数据库（24）
		upgradeDb24(_dbVersion, _func);
	}
}

/**
 * 升级数据库（24）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb24(_dbVersion, _func){
	//处理数据库升级（24）
	if(_dbVersion < 24){
		handleUpgradeDb24(function(){
			// 升级数据库（25）
			upgradeDb25(_dbVersion, _func);
		});
	} else {
		// 升级数据库（25）
		upgradeDb25(_dbVersion, _func);
	}
}

/**
 * 升级数据库（25）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb25(_dbVersion, _func){
	//处理数据库升级（25）
	if(_dbVersion < 25){
		handleUpgradeDb25(function(){
			// 升级数据库（26）
			upgradeDb26(_dbVersion, _func);
		});
	} else {
		// 升级数据库（26）
		upgradeDb26(_dbVersion, _func);
	}
}

/**
 * 升级数据库（26）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb26(_dbVersion, _func){
	//处理数据库升级（26）
	if(_dbVersion < 26){
		handleUpgradeDb26(function(){
			// 升级数据库（27）
			upgradeDb27(_dbVersion, _func);
		});
	} else {
		// 升级数据库（27）
		upgradeDb27(_dbVersion, _func);
	}
}

/**
 * 升级数据库（27）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb27(_dbVersion, _func){
	//处理数据库升级（27）
	if(_dbVersion < 27){
		handleUpgradeDb27(function(){
			// 升级数据库（28）
			upgradeDb28(_dbVersion, _func);
		});
	} else {
		// 升级数据库（28）
		upgradeDb28(_dbVersion, _func);
	}
}

/**
 * 升级数据库（28）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb28(_dbVersion, _func){
	//处理数据库升级（28）
	if(_dbVersion < 28){
		handleUpgradeDb28(function(){
			// 升级数据库（29）
			upgradeDb29(_dbVersion, _func);
		});
	} else {
		// 升级数据库（29）
		upgradeDb29(_dbVersion, _func);
	}
}

/**
 * 升级数据库（29）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb29(_dbVersion, _func){
	//处理数据库升级（29）
	if(_dbVersion < 29){
		handleUpgradeDb29(function(){
			// 升级数据库（30）
			upgradeDb30(_dbVersion, _func);
		});
	} else {
		// 升级数据库（30）
		upgradeDb30(_dbVersion, _func);
	}
}

/**
 * 升级数据库（30）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb30(_dbVersion, _func){
	//处理数据库升级（30）
	if(_dbVersion < 30){
		handleUpgradeDb30(function(){
			// 升级数据库（31）
			upgradeDb31(_dbVersion, _func);
		});
	} else {
		// 升级数据库（31）
		upgradeDb31(_dbVersion, _func);
	}
}

/**
 * 升级数据库（31）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb31(_dbVersion, _func){
	//处理数据库升级（31）
	if(_dbVersion < 31){
		handleUpgradeDb31(function(){
			// 升级数据库（32）
			upgradeDb32(_dbVersion, _func);
		});
	} else {
		// 升级数据库（32）
		upgradeDb32(_dbVersion, _func);
	}
}

/**
 * 升级数据库（32）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb32(_dbVersion, _func){
	print("upgradeDb32 " + _dbVersion);
	//处理数据库升级（32）
	if(_dbVersion < 32){
		handleUpgradeDb32(function(){
			// 升级数据库（33）
			upgradeDb33(_dbVersion, _func);
		});
	} else {
		// 升级数据库（33）
		upgradeDb33(_dbVersion, _func);
	}
}

/**
 * 升级数据库（33）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb33(_dbVersion, _func){
	print("upgradeDb33 " + _dbVersion);
	//处理数据库升级（33）
	if(_dbVersion < 33){
		handleUpgradeDb33(function(){
			// 升级数据库（34）
			upgradeDb34(_dbVersion, _func);
		});
	} else {
		// 升级数据库（34）
		upgradeDb34(_dbVersion, _func);
	}
}

/**
 * 加载节点缓存
 * @param _callFunc
 * @returns
 */
function loadNodeCache(_callFunc){
	dataService.loadPercnodeCache(_callFunc);
}

//图片文件根路径
var imageFileRootPath = "data://image/tf/task/";
// 非结构化文件所在目录
var unstructFileRootPath = "data://unstruct/";
// 临时文件目录
var tempFileDir = "data://temp/file/";
// 图片文件扩展名
var imgFileExName = ".image";
// 压缩（.zip）文件扩展名
var zipFileExName = ".zip";
//一次保存纪念日到信息库的数量
var saveCommNum = 100;
//一次保存待办到信息库的数量
var saveTaskNum = 100;
//一次保存联系人到信息库的数量
var saveContactNum = 50;

/**
 * 根据节点id获取节点数据
 * @param _nodeId
 * @returns
 */
function getNodeData(_nodeId){
	var _nodeDataList = dbinitsqls.nodeDataList;
	var _nodeData = null;
	for(var i=0; i<_nodeDataList.length; i++){
		if(_nodeId == _nodeDataList[i][0]){
			_nodeData = _nodeDataList[i];
			break;
		}
	}
	return _nodeData;
}

/**
 * 从列表中获取info
 * @param _infoList
 * @param _nodeId
 * @returns
 */
function getInfoByList(_infoList, _nodeId){
	var _info = null;
	for(var i=0; i<_infoList.length; i++){
		if(_nodeId == _infoList[i].nodeid){
			_info = _infoList[i];
			break;
		}
	}
	if(tools.isNull(_info)){
		_info = expService.initInfo(_nodeId);
		_infoList.push(_info);
	}
	_info.groupid = "";
	_info.serialgroupid = "";
	_info.versiongroupid = "";
	return _info;
}

/**
 * 更新时间流数据类型
 * 将类型文字改为对应二级节点，并将没有启用的类型改为个人待办或个人纪念日
 * @returns
 */
function updateTfDataType(){
	var _sqlList = [];
	var _sql = "update mytask set type='";
	var _tfTypeList = dbinitsqls.tfTypeList;
	for(var i=0; i<_tfTypeList.length; i++){
		var _tmpSql = _sql + _tfTypeList[i][0] + 
			"' where type='" + _tfTypeList[i][1] + "';"
		_sqlList.push(_tmpSql);
	}
	if(_sqlList.length > 0){
		localdb.executeSync1(_sqlList, true);
	}
}

/**
 * 转换时间流地址数据（到信息库）
 * @param _mainStuct
 * @param _address
 * @returns
 */
function transferTfAddrToExp(_mainStuct, _address){
	var _jsonLocation = jsonTools.strToJsonObj(_address);
	var _location = _address;
	if(null != _jsonLocation && null != _jsonLocation.name){
		_location = tools.formatLoc(_jsonLocation);
	}
	_mainStuct.labeladdress = _location;
}

/**
 * 转换待办重复数据（到信息库）
 * @param _mainStuct
 * @param _cycleData
 * @returns
 */
function transferCycleTypeTaskToExp(_mainStuct, _cycleData){
	if(!tools.isNull(_cycleData)){
		var _cycleTypeId = parseInt(_cycleData.cycleid);
		_mainStuct.cycle_type = _cycleTypeId + "";
		_mainStuct.cycle_unit = parseInt(_cycleData.type);
		_mainStuct.cycle_frequency = parseInt(_cycleData.frequency);
		if(!tools.isNull(_cycleData.endtime) &&
				0 != parseInt(_cycleData.endtime)){
			var _date = new Date();
			_date.setTime(parseInt(_cycleData.endtime));
			_mainStuct.cycle_endtime = _date.format(expConst.dataStore.dateformat);
		} else {
			_mainStuct.cycle_endtime = null;
		}
		// 每周几
		if(_cycleTypeId == cycleTypeTools.cycleIdConstants.weekday){
			_mainStuct.cycle_type = _cycleTypeId + "-" + _cycleData.week;
		} else {
			// 自定义
			if(_cycleTypeId == cycleTypeTools.cycleIdConstants.custom){
				_mainStuct.cycle_type = _cycleTypeId + "-"
					+ _cycleData.selection;
			}
		}
	} else {
		_mainStuct.cycle_type = "1";
		_mainStuct.cycle_unit = 0;
		_mainStuct.cycle_frequency = 0;
		_mainStuct.cycle_endtime = null;
	}
}

/**
 * 转换时间流待办数据（到信息库）
 * @param _info
 * @param _appData
 * @param _cycleRecord
 * @returns
 */
function transferDataTaskToExpInfo(_info, _appData, _cycleRecord){
	if(tools.isNull(_info.persons)){
		_info.persons = [];
	}
	var _date = new Date();
	var _mainStuct = _info.mainstruct;
	_mainStuct.localtitle = _appData.title;
	_date.setTime(parseInt(_appData.start));
	_mainStuct.procstarttime = _date.format(expConst.dataStore.dateformat);
	_date.setTime(parseInt(_appData.end));
	_mainStuct.procendtime = _date.format(expConst.dataStore.dateformat);
	_mainStuct.affipersonal = _appData.createby;
	_mainStuct.destpersonname = _appData.destpersonname;
	_mainStuct.labelpersonname = _appData.connectby;
	_mainStuct.phoneno = _appData.connectphone;
	_mainStuct.beforetimelen = tools.getExpRemindTime(_appData.remindtime);
	_mainStuct.note = _appData.comment;
	_date.setTime(parseInt(_appData.create_time));
	_mainStuct.createdtime = _date.format(expConst.dataStore.dateformat);
	_date.setTime(parseInt(_appData.update_time));
	_mainStuct.updatedtime = _date.format(expConst.dataStore.dateformat);
	_info.archivedtime = _appData.create_time;
	_info.createdtime = _appData.create_time;
	_info.updatedtime = _appData.update_time;
	// 转换时间流地址数据（到信息库）
	transferTfAddrToExp(_mainStuct, _appData.location);
	// 转换待办重复数据（到信息库）
	transferCycleTypeTaskToExp(_mainStuct, _cycleRecord);
}

/**
 * 转换时间流待办数据（到信息库）
 * @param _info
 * @param _appData
 * @returns
 */
function transferDataCommToExpInfo(_info, _appData){
	if(tools.isNull(_info.persons)){
		_info.persons = [];
	}
	var _date = new Date();
	var _mainStuct = _info.mainstruct;
	_mainStuct.localtitle = _appData.commname;
	_date.setTime(parseInt(_appData.commtime));
	_mainStuct.commemortime = _date.format(expConst.dataStore.dateformat);
	_mainStuct.calendartype = _appData.calendartype;
	_mainStuct.beforetimelen = tools.getExpRemindTime(_appData.remindtime);
	_mainStuct.affipersonal = _appData.commcreateby;
	_mainStuct.destpersonname = _appData.commservice;
	_mainStuct.eventname = _appData.commevent;
	_mainStuct.procname = _appData.commproc;
	_date.setTime(parseInt(_appData.commcretime));
	_mainStuct.labeltime = _date.format(expConst.dataStore.dateformat);
	_date.setTime(parseInt(_appData.create_time));
	_mainStuct.createdtime = _date.format(expConst.dataStore.dateformat);
	_date.setTime(parseInt(_appData.update_time));
	_mainStuct.updatedtime = _date.format(expConst.dataStore.dateformat);
	_info.archivedtime = _appData.create_time;
	_info.createdtime = _appData.create_time;
	_info.updatedtime = _appData.update_time;
}

/**
 * 检查待办是否重名
 * @param _taskDatas
 * @param _task
 * @returns
 */
function checkDupNameTask(_taskDatas, _task){
	var _isExist = false;
	if(!tools.isNullOrEmpty(_taskDatas)){
		for(var i=0; i<_taskDatas.length; i++){
			if(tools.isNull(_taskDatas[i]))
				continue;
			if(_taskDatas[i].id != _task.id &&
					_taskDatas[i].type == _task.type &&
					_taskDatas[i].title == _task.title){
				_isExist = true;
				break;
			}
		}
	}
	return _isExist;
}

/**
 * 获取周期性记录
 * @param _cycelRecordList
 * @param _taskId
 * @returns
 */
function getCycleReocrd(_cycelRecordList, _taskId){
	var _cycleRecord = null;
	if(!tools.isNullOrEmpty(_cycelRecordList)){
		for(var i=0; i<_cycelRecordList.length; i++){
			if(tools.isNull(_cycelRecordList[i]))
				continue;
			if(_cycelRecordList[i].taskid == _taskId){
				_cycleRecord = _cycelRecordList[i];
				break;
			}
		}
	}
	return _cycleRecord;
}

/**
 * 获取单个待办
 * @param _taskData
 * @param _cycleRecord
 * @param _expInfoList
 * @param _infoList
 * @param _infoNodeRelList
 * @returns
 */
function getSingleTask(_taskData, _cycleRecord, _expInfoList, 
		_infoList, _infoNodeRelList){
	// 获取节点信息
	var _nodeData = getNodeData(_taskData.type);
	// 初始化信息片段
	var _info = getInfoByList(_infoList, _nodeData[1]);
	_info.infoid = _taskData.id;
	// 将信息和节点的对应关系先缓存起来，供后面将使用记录保存到信息使用
	_infoNodeRelList.push({
		infoid: _info.infoid,
		nodedata: _nodeData
	});
	// 若信息主标题重名，则默认保存到序号组
	_info.autosave_serialgroup = true;
	// 转换待办信息到信息片段
	transferDataTaskToExpInfo(_info, _taskData, _cycleRecord);
	// 非结构化数据
	_info.unstructdata = {
			datasize: 0,
			dataformat: globalConst.fileFormat.zip
	};
	// 获取保存待办信息到信息库的sql语句
	expService.getCreateInfoSql(_expInfoList, _info);
}

/**
 * 获取多个待办数据
 * @param _taskDatas
 * @param _index
 * @param _expInfoList
 * @param _dupNameCommList
 * @param _infoList
 * @param _infoNodeRelList
 * @returns
 */
function getMultipleTask(_taskDatas, _index, _expInfoList, 
		_dupNameTaskList, _infoList, _infoNodeRelList){
	var _idList = [];
	// 每次处理多个待办信息
	for(var i=0; i<saveTaskNum; i++){
		if(_index < _taskDatas.length){
			var _task = _taskDatas[_index];
			if(!tools.isNull(_task)){
				// 检查待办是否重名
				var _isExist = checkDupNameTask(_taskDatas, _task);
				if(!_isExist){
					// 判断待办图片是否存在
					var _dirPath = imageFileRootPath + _task.id + "/";
					// 若待办图片不存在，则批量保存；
					// 否则，添加到重名列表，最后单个保存
					if(!do_storage.dirExist(_dirPath)){
						_idList.push(_task.id);
					} else {
						_dupNameTaskList.push(_task);
					}
				} else {
					_dupNameTaskList.push(_task);
				}
			}
		}
		_index++;
	}
	if(_idList.length > 0){
		// 批量查询待办信息
		var _sql = "select * from mytask where id in ('" + 
			_idList.join("','") + "');";
		var _taskList = localdb.querySync(_sql);
		if(!tools.isNullOrEmpty(_taskList)){
			// 批量查询待办周期信息
			_sql = "select * from cyclerecord where taskid in ('" + 
				_idList.join("','") + "');";
			var _cycleRecordList = localdb.querySync(_sql);
			// 遍历所有纪念日数据
			for(var i=0; i<_taskList.length; i++){
				if(tools.isNull(_taskList[i])) continue;
				// 获取重复记录数据
				var _cycleRecord = getCycleReocrd(_cycleRecordList, _taskList[i].id);
				// 获取单个待办信息保存到信息库sql语句
				getSingleTask(_taskList[i], _cycleRecord, _expInfoList, 
						_infoList, _infoNodeRelList);
			}
		}
	}
}

/**
 * 保存多个纪念日信息到信息库
 * @param _taskDatas
 * @param _index
 * @param _infoList
 * @param _infoNodeRelList
 * @param _dupNameTaskList
 * @param _func
 * @returns
 */
function saveMultipleTaskToExp(_taskDatas, _index, _infoList, 
		_infoNodeRelList, _dupNameTaskList, _func){
	if(_index < _taskDatas.length){
		var _expInfoList = [];
		// 获取创建多个待办信息的sql语句
		getMultipleTask(_taskDatas, _index, 
				_expInfoList, _dupNameTaskList, _infoList, 
				_infoNodeRelList);
		
		_index += saveTaskNum;
		
		if(_expInfoList.length > 0){
			expService.execute(_expInfoList, true, function(_result){
				saveMultipleTaskToExp(_taskDatas, _index, _infoList, 
						_infoNodeRelList, _dupNameTaskList, _func);
			});
		} else {
			saveMultipleTaskToExp(_taskDatas, _index, _infoList, 
					_infoNodeRelList, _dupNameTaskList, _func);
		}
	} else {
		_func.call(this);
	}
}

/**
 * 获取目录名
 * @returns
 */
function getDirName(){
	var _random = Math.random();
	var _number = Math.round(_random * 255);
	var _dirName = _number.toString(16);
	if(_dirName.length == 1){
		_dirName = "0" + _dirName;
	}
	return _dirName;
}

/**
 * 获取新文件名
 * @returns
 */
function getNewFileName(){
	var _nowTime = new Date();
	var _random = Math.round(Math.random() * 10000);
	var _fileName = "" + _nowTime.getTime() + _random;
	return _fileName;
}

/**
 * 拷贝多个图片文件
 * @param _sourceFiles
 * @param _dirPath
 * @param _fileList
 * @param _func
 * @returns
 */
function copyFiles(_sourceFiles, _dirPath, _fileList, _func){
	if(_sourceFiles.length > 0){
		var _fileData = _sourceFiles.shift();
		var _filePath = _fileData.filePath;
		var _targetPath = _dirPath + _fileData.fileName;
		do_storage.copyFile({
			source: _filePath,
			target: _targetPath
		}, function(_result){
			if(_result){
				_fileList.push(_targetPath);
			}
			// 拷贝下一个文件
			copyFiles(_sourceFiles, _dirPath, _fileList, _func);
		});
	} else {
		_func.call(this);
	}
}

/**
 * 保存非结构数据
 * @param _infoId
 * @param _unstructData
 * @param _func
 * @returns
 */
function saveUnstructData(_infoId, _unstructData, _func){
	var _newFileName = getNewFileName();
	var _unstructFilePath = unstructFileRootPath + getDirName() +  "/" + _newFileName;
	var _filePath = _unstructData.filepath;
	if(!tools.isNullOrEmpty(_filePath)){
		do_storage.copyFile({
			source: _filePath,
			target: _unstructFilePath
		}, function(_result){
			if(_result){
				// 本地新建，默认是未上传的，upload=0
				var _sql = "insert into pips_unstructeddata(infoid,datano,dataformat,datasize," +
						"srcfilepath,filepath,filename,updatedtime,upload,download)" +
						" values(?,0,?,?,?,?,?,?,0,1);";
				var _now = new Date();
				pipsdb.executeSync(_sql, [_infoId, _unstructData.dataformat, 
					_unstructData.datasize, _filePath, _unstructFilePath, 
					_unstructData.filename, _now.getTime()]);
			}
			_func.call(this);
		});
	} else {
		_func.call(this);
	}
}

/**
 * 处理待办图片文件到信息库
 * @param _infoId
 * @param _func
 * @returns
 */
function handleTaskImgFileToExp(_infoId, _func){
	var _dirPath = imageFileRootPath + _infoId + "/";
	if(do_storage.dirExist(_dirPath)){
		// 获取文件列表
		do_storage.getFiles(_dirPath, function(_fileList){
			var _sourceFiles = [];
			if(!tools.isNullOrEmpty(_fileList)){
				for(var i=0; i<_fileList.length; i++){
					var _file = _fileList[i];
					if(tools.isNullOrEmpty(_file))
						continue;
					var _filePath = _dirPath + _file;
					if(do_storage.fileExist(_filePath)){
						var _index = _file.lastIndexOf(imgFileExName);
						if(_index > -1){
							_file = _file.substring(0, _index);
						}
						_sourceFiles.push({
							filePath: _filePath,
							fileName: _file
						});
					}
				}
			}
			if(_sourceFiles.length > 0){
				var _newFileName = getNewFileName(); 
				var _tempDirPath = tempFileDir + _newFileName + "/";
				var _tempFileList = [];
				// 拷贝多个图片文件
				copyFiles(_sourceFiles, _tempDirPath, 
						_tempFileList, function(){
					if(_tempFileList.length > 0){
						_newFileName = getNewFileName();
						var _tempFilePath = tempFileDir + _newFileName + zipFileExName;
						// 压缩图片文件
						do_storage.zipFiles({
							source: _tempFileList,
							target: _tempFilePath
						}, function(_result){
							// 获取文件大小
							var _fileSize = do_storage.getFileSize(_tempFilePath);
							
							_func.call(this, {
								filepath: _tempFilePath,
								filename: _newFileName,
								datasize: _fileSize,
								dataformat: globalConst.fileFormat.zip
							});
						});
					} else {
						_func.call(this, null);
					}
				});
			} else {
				_func.call(this, null);
			}
		});
	} else {
		_func.call(this, null);
	}
}

/**
 * 保存多个待办信息到信息库
 * @param _dupNameTaskList
 * @param _infoList
 * @param _infoNodeRelList
 * @param _func
 * @returns
 */
function saveDupNameTaskToExp(_dupNameTaskList, _infoList,
		_infoNodeRelList, _func){
	if(_dupNameTaskList.length > 0){
		var _id = _dupNameTaskList.shift().id;
		var _taskData = dbtask.get_mytaskOneData(_id);
		if(null != _taskData){
			// 获取节点信息
			var _nodeData = getNodeData(_taskData.type);
			// 初始化信息片段
			var _info = getInfoByList(_infoList, _nodeData[1]);
			_info.infoid = _id;
			// 若信息主标题重名，则默认保存到序号组
			_info.autosave_serialgroup = true;
			// 获取待办重复记录的数据
			var _cycleRecord = dbcycle.query_cycleRecordOneDataByTaskId(_id);
			// 转换待办到信息片段
			transferDataTaskToExpInfo(_info, _taskData, _cycleRecord);
			// 处理待办图片文件到信息库
			handleTaskImgFileToExp(_id, function(_unstructData){
				if(tools.isNull(_unstructData)){
					_unstructData = {
							filepath: "",
							filename: "",
							datasize: 0,
							dataformat: globalConst.fileFormat.zip
					};
				}
				// 非结构化数据
				_info.unstructdata = _unstructData;
				// 创建名片对应的信息片段
				expService.createInfo(_info, function(_result){
					// 将信息和节点的对应关系先缓存起来，供后面将使用记录保存到信息使用
					_infoNodeRelList.push({
						infoid: _info.infoid,
						nodedata: _nodeData
					});
					// 保存非结构化数据
					saveUnstructData(_id, _unstructData, function(){
						// 保存多个待办信息到信息库
						saveDupNameTaskToExp(_dupNameTaskList, _infoList,
								_infoNodeRelList, _func);
					});
				});
			});
		} else {
			// 保存多个待办信息到信息库
			saveDupNameTaskToExp(_dupNameTaskList, _infoList,
					_infoNodeRelList, _func);
		}
	} else {
		_func.call(this);
	}
}

/**
 * 处理待办信息到信息库
 * @param _infoNodeRelList
 * @param _infoIdList
 * @param _func
 * @returns
 */
function handleTfTaskToExp(_infoNodeRelList, _infoIdList, _func){
	var _sql = "select id,type,title from mytask where infocategory=" + 
		constants.getConstants("infoCategory_task");
	if(_infoIdList.length > 0){
		_sql += " and id not in ('" + _infoIdList.join("','") + "')";
	}
	_sql += ";";
	localdb.query(_sql, function(_taskList){
		if(!tools.isNullOrEmpty(_taskList)){
			var _taskDatas = [];
			for(var i=0; i<_taskList.length; i++){
				if(tools.isNullOrEmpty(_taskList[i].id))
					continue;
				// 保证周期性卡片用的是主卡片
				if(_taskList[i].id.length == 24){
					_taskDatas.push(_taskList[i]);
				}
			}
			if(_taskDatas.length > 0){
				// 初始化信息片段
				var _infoList = [];
				// 重名和有非结构化的待办
				var _dupNameTaskList = [];
				// 保存多个待办信息到信息库
				saveMultipleTaskToExp(_taskDatas, 0, _infoList, 
						_infoNodeRelList, _dupNameTaskList, function(){
					// 若重名待办不为空，则保存重名待办
					// 重名待办需要加入到信息组，需要调用创建单个信息片段的接口
					if(_dupNameTaskList.length > 0){
						saveDupNameTaskToExp(_dupNameTaskList, _infoList, 
								_infoNodeRelList, function(){
							_infoList.length = 0;
							_infoList = null;
							_func.call(this);
						})
					} else {
						_func.call(this);
					}
				});
			} else {
				_func.call(this);
			}
		} else {
			_func.call(this);
		}
	});
}

/**
 * 检查纪念日是否重名
 * @param _commDatas
 * @param _comm
 * @returns
 */
function checkDupNameComm(_commDatas, _comm){
	var _isExist = false;
	if(!tools.isNullOrEmpty(_commDatas)){
		for(var i=0; i<_commDatas.length; i++){
			if(tools.isNull(_commDatas[i]))
				continue;
			if(_commDatas[i].id != _comm.id &&
					_commDatas[i].type == _comm.type &&
					_commDatas[i].commname == _comm.commname){
				_isExist = true;
			}
		}
	}
	return _isExist;
}

/**
 * 获取单个纪念日
 * @param _commData
 * @param _expInfoList
 * @param _infoList
 * @param _infoNodeRelList
 * @returns
 */
function getSingleComm(_commData, _expInfoList, 
		_infoList, _infoNodeRelList){
	// 获取节点信息
	var _nodeData = getNodeData(_commData.type);
	// 初始化信息片段
	var _info = getInfoByList(_infoList, _nodeData[1]);
	_info.infoid = _commData.id;
	// 将信息和节点的对应关系先缓存起来，供后面将使用记录保存到信息使用
	_infoNodeRelList.push({
		infoid: _info.infoid,
		nodedata: _nodeData
	});
	// 若信息主标题重名，则默认保存到序号组
	_info.autosave_serialgroup = true;
	// 转换纪念日信息到信息片段
	transferDataCommToExpInfo(_info, _commData);
	// 非结构化数据
	_info.unstructdata = {
			datasize: 0,
			dataformat: globalConst.fileFormat.htmlx
	};
	// 获取保存纪念日信息到信息库的sql语句
	expService.getCreateInfoSql(_expInfoList, _info);
}

/**
 * 获取多个纪念日数据
 * @param _commDatas
 * @param _index
 * @param _expInfoList
 * @param _dupNameCommList
 * @param _infoList
 * @param _infoNodeRelList
 * @returns
 */
function getMultipleComm(_commDatas, _index, _expInfoList, 
		_dupNameCommList, _infoList, _infoNodeRelList){
	var _idList = [];
	// 每次处理多个纪念日信息
	for(var i=0; i<saveCommNum; i++){
		if(_index < _commDatas.length){
			var _comm = _commDatas[_index];
			if(!tools.isNull(_comm)){
				// 检查纪念日是否重名
				var _isExist = checkDupNameComm(_commDatas, _comm);
				if(!_isExist){
					_idList.push(_comm.id);
				} else {
					_dupNameCommList.push(_comm);
				}
			}
		}
		_index++;
	}
	if(_idList.length > 0){
		// 批量查询纪念日信息
		var _sql = "select * from mytask where id in ('" + 
			_idList.join("','") + "');";
		var _commList = localdb.querySync(_sql);
		if(!tools.isNullOrEmpty(_commList)){
			// 遍历所有纪念日数据
			for(var i=0; i<_commList.length; i++){
				if(tools.isNull(_commList[i])) continue;
				// 获取单个纪念日信息
				getSingleComm(_commList[i], _expInfoList, 
						_infoList, _infoNodeRelList);
			}
		}
	}
}

/**
 * 保存多个纪念日信息到信息库
 * @param _commDatas
 * @param _index
 * @param _infoList
 * @param _infoNodeRelList
 * @param _dupNameCommList
 * @param _func
 * @returns
 */
function saveMultipleCommToExp(_commDatas, _index, _infoList, 
		_infoNodeRelList, _dupNameCommList, _func){
	if(_index < _commDatas.length){
		var _expInfoList = [];
		// 获取创建多个纪念日信息的sql语句
		getMultipleComm(_commDatas, _index, 
				_expInfoList, _dupNameCommList, _infoList, 
				_infoNodeRelList);
		
		_index += saveCommNum;
		if(_expInfoList.length > 0){
			expService.execute(_expInfoList, true, function(_result){
				saveMultipleCommToExp(_commDatas, _index, _infoList, 
						_infoNodeRelList, _dupNameCommList, _func);
			});
		} else {
			saveMultipleCommToExp(_commDatas, _index, _infoList, 
					_infoNodeRelList, _dupNameCommList, _func);
		}
	} else {
		_func.call(this);
	}
}

/**
 * 保存重名纪念日信息到信息库
 * @param _dupNameCommList
 * @param _infoList
 * @param _infoNodeRelList
 * @param _func
 * @returns
 */
function saveDupNameCommToExp(_dupNameCommList, 
		_infoList, _infoNodeRelList, _func){
	if(_dupNameCommList.length > 0){
		var _id = _dupNameCommList.shift().id;
		var _commData = dbcomm.get_mytaskOneData(_id);
		if(null != _commData){
			// 获取节点信息
			var _nodeData = getNodeData(_commData.type);
			// 初始化信息片段
			var _info = getInfoByList(_infoList, _nodeData[1]);
			_info.infoid = _id;
			// 若信息主标题重名，则默认保存到序号组
			_info.autosave_serialgroup = true;
			// 转换纪念日信息到信息片段
			transferDataCommToExpInfo(_info, _commData);
			// 非结构化数据
			_info.unstructdata = {
					datasize: 0,
					dataformat: globalConst.fileFormat.htmlx
			};
			// 创建纪念日对应的信息片段
			expService.createInfo(_info, function(_result){
				// 将信息和节点的对应关系先缓存起来，供后面将使用记录保存到信息使用
				_infoNodeRelList.push({
					infoid: _info.infoid,
					nodedata: _nodeData
				});
				// 保存重名纪念日信息到信息库
				saveDupNameCommToExp(_dupNameCommList, _infoList,
						_infoNodeRelList, _func);
			});
		} else {
			// 保存重名纪念日信息到信息库
			saveDupNameCommToExp(_dupNameCommList, _infoList,
					_infoNodeRelList, _func);
		}
	} else {
		_func.call(this);
	}
}

/**
 * 处理纪念日信息到信息库
 * @param _infoNodeRelList
 * @param _infoIdList
 * @param _func
 * @returns
 */
function handleTfCommToExp(_infoNodeRelList, _infoIdList, _func){
	var _sql = "select id,type,commname from mytask where infocategory=" + 
		constants.getConstants("infoCategory_comm");
	if(_infoIdList.length > 0){
		_sql += " and id not in ('" + _infoIdList.join("','") + "')";
	}
	_sql += ";";
	localdb.query(_sql, function(_commList){
		if(!tools.isNullOrEmpty(_commList)){
			var _commDatas = [];
			for(var i=0; i<_commList.length; i++){
				if(tools.isNull(_commList[i]) ||
						tools.isNullOrEmpty(_commList[i].id))
					continue;
				// 保证纪念日卡片用的是主卡片
				if(_commList[i].id.length == 24){
					_commDatas.push(_commList[i]);
				}
			}
			if(_commDatas.length > 0){
				// 信息片段列表
				var _infoList = [];
				// 重名纪念日
				var _dupNameCommList = [];
				// 保存多个纪念日信息到信息库
				saveMultipleCommToExp(_commDatas, 0, _infoList, 
						_infoNodeRelList, _dupNameCommList, function(){
					// 若重名纪念日不为空，则保存重名纪念日
					// 重名纪念日需要保存到组，需要单个调用创建信息片段接口
					if(_dupNameCommList.length > 0){
						// 保存多个重名纪念日信息到信息库
						saveDupNameCommToExp(_dupNameCommList, _infoList, 
								_infoNodeRelList, function(){
							_infoList.length = 0;
							_infoList = null;
							_func.call(this);
						});
					} else {
						_func.call(this);
					}
				});
			} else {
				_func.call(this);
			}
		} else {
			_func.call(this);
		}
	});
}

/**
 * 处理所有时间流应用数据到信息库
 * @param _infoNodeRelList
 * @param _infoIdList
 * @param _func
 * @returns
 */
function handleAllTfDataAppToExp(_infoNodeRelList, _infoIdList, _func){
	// 更新待办和纪念日类型
	updateTfDataType();
	// 处理待办信息到信息库
	handleTfTaskToExp(_infoNodeRelList, _infoIdList, function(){
		// 处理纪念日信息到信息库
		handleTfCommToExp(_infoNodeRelList, _infoIdList, function(){
			_func.call(this);
		});
	});
}

/**
 * 更新联系人数据类型
 * 将没有启用的类型改为一般联系人
 * @returns
 */
function updateContactDataType(){
	var _sqlList = [];
	var _sql = "update contacts_contact set type='";
	var _contactTypeList = dbinitsqls.contactTypeList;
	for(var i=0; i<_contactTypeList.length; i++){
		var _tmpSql = _sql + _contactTypeList[i][0] + 
			"' where type='" + _contactTypeList[i][1] + "';"
		_sqlList.push(_tmpSql);
	}
	if(_sqlList.length > 0){
		localdb.executeSync1(_sqlList, true);
	}
}

/**
 * 转换联系人性别数据（到信息库）
 * @param _mainStuct
 * @param _gender
 * @returns
 */
function transferContactGenderToExp(_mainStuct, _gender){
	if(!tools.isNullOrEmpty(_gender)){
		if(globalConst.gender.woman == _gender){
			_mainStuct.gender = string.contact.gender_woman;
		} else {
			_mainStuct.gender = string.contact.gender_man;
		}
	}
}

/**
 * 转换联系人地址数据（到信息库）
 * @param _propData
 * @returns
 */
function transferContactAddrToExp(_propData){
	var _value = _propData.value;
	var _jsonLocation = jsonTools.strToJsonObj(_value);
	var _location = _value;
	if(null != _jsonLocation && null != _jsonLocation.name){
		_location = tools.formatLoc(_jsonLocation);
	}
	_propData.value = _location;
}

/**
 * 转换联系人属性数据（到信息库）
 * @param _nodeId
 * @param _mainStuct
 * @param _properties
 * @returns
 */
function transferContactPropToExp(_nodeId, _mainStuct, _properties){
	_mainStuct.mobilephoneno = "";
	// 小朋友信息
	if(_nodeId == infoTypeConst.typeConstants.contactType_children){
		_mainStuct.telephoneno = "";
		_mainStuct.physiaddress = "";
	} else if(_nodeId == infoTypeConst.typeConstants.contactType_goods){ // 物品维护联系
		_mainStuct.telephoneno = "";
		_mainStuct.emailbox = "";
		_mainStuct.physiaddress = "";
	} else { // 其他联系人信息（包括朋友信息）
		_mainStuct.telephoneno = {
				work: "",
				family: ""
		};
		_mainStuct.emailbox = {
				work: "",
				personal: ""
		};
		_mainStuct.physiaddress = {
				work: "",
				family: ""
		};
	}
	// 属性信息不为空
	if(!tools.isNullOrEmpty(_properties)){
		var _mobilePhone = [];
		var _workPhone = [];
		var _familyPhone = [];
		var _workEmail = [];
		var _personalEmail = [];
		var _workAddr = [];
		var _familyAddr = [];
		// 遍历联系人属性列表
		for(var i=0; i<_properties.length; i++){
			var _propData = _properties[i];
			if(tools.isNull(_propData) && 
					tools.isNullOrEmpty(_propData.value)) continue;
			if(_propData.type == contactPropConst.typeConstants.phoneDefault ||
					_propData.type == contactPropConst.typeConstants.phoneMobile){
				_mobilePhone.push(_propData.value);
			} else if(_propData.type == contactPropConst.typeConstants.phoneWork){
				_workPhone.push(_propData.value);
			} else if(_propData.type == contactPropConst.typeConstants.phoneHome){
				_familyPhone.push(_propData.value);
			} else if(_propData.type == contactPropConst.typeConstants.emailDefault ||
					_propData.type == contactPropConst.typeConstants.emailWork){
				_workEmail.push(_propData.value);
			} else if(_propData.type == contactPropConst.typeConstants.emailPersonal){
				_personalEmail.push(_propData.value);
			} else if(_propData.type == contactPropConst.typeConstants.addressDefault ||
					_propData.type == contactPropConst.typeConstants.addressWork){
				transferContactAddrToExp(_propData);
				_workAddr.push(_propData.value);
			} else if(_propData.type == contactPropConst.typeConstants.addressHome){
				transferContactAddrToExp(_propData);
				_familyAddr.push(_propData.value);
			}
		}
		// 手机
		if(_mobilePhone.length > 0){
			_mainStuct.mobilephoneno = _mobilePhone.join(",");
		}
		// 工作电话
		if(_workPhone.length > 0){
			// 小朋友信息
			if(_nodeId == infoTypeConst.typeConstants.contactType_children){
			} else if(_nodeId == infoTypeConst.typeConstants.contactType_goods){ // 物品维护联系
				_mainStuct.telephoneno = _workPhone.join(",");
			} else { // 其他联系人信息（包括朋友信息）
				_mainStuct.telephoneno.work = _workPhone.join(",");
			}
		}
		// 家庭电话
		if(_familyPhone.length > 0){
			// 小朋友信息
			if(_nodeId == infoTypeConst.typeConstants.contactType_children){
				_mainStuct.telephoneno = _familyPhone.join(",");
			} else if(_nodeId== infoTypeConst.typeConstants.contactType_goods){ // 物品维护联系
			} else { // 其他联系人信息（包括朋友信息）
				_mainStuct.telephoneno.family = _familyPhone.join(",");
			}
		}
		// 工作邮箱
		if(_workEmail.length > 0){
			// 小朋友信息
			if(_nodeId == infoTypeConst.typeConstants.contactType_children){
			} else if(_nodeId == infoTypeConst.typeConstants.contactType_goods){ // 物品维护联系
				_mainStuct.emailbox = _workEmail.join(",");
			} else { // 其他联系人信息（包括朋友信息）
				_mainStuct.emailbox.work = _workEmail.join(",");
			}
		}
		// 个人邮箱
		if(_personalEmail.length > 0){
			_mainStuct.emailbox.personal = _personalEmail.join(",");
		}
		// 工作地址
		if(_workAddr.length > 0){
			// 小朋友信息
			if(_nodeId == infoTypeConst.typeConstants.contactType_children){
			} else if(_nodeId == infoTypeConst.typeConstants.contactType_goods){ // 物品维护联系
				_mainStuct.physiaddress = _workAddr.join(",");
			} else { // 其他联系人信息（包括朋友信息）
				_mainStuct.physiaddress.work = _workAddr.join(",");
			}
		}
		// 家庭地址
		if(_familyAddr.length > 0){
			// 小朋友信息
			if(_nodeId == infoTypeConst.typeConstants.contactType_children){
				_mainStuct.physiaddress = _familyAddr.join(",");
			} else if(_nodeId == infoTypeConst.typeConstants.contactType_goods){ // 物品维护联系
			} else { // 其他联系人信息（包括朋友信息）
				_mainStuct.physiaddress.family = _familyAddr.join(",");
			}
		}
	}
}

/**
 * 转换名片数据（到信息库）
 * @param _info
 * @param _appData
 * @param _properties
 * @returns
 */
function transferDataVCardToExpInfo(_info, _appData, _properties){
	var _date = new Date();
	// 主结构化
	var _mainStuct = _info.mainstruct;
	_mainStuct.protagonist = _appData.name;
	_mainStuct.personphoto = _appData.headurl;
	_mainStuct.affiorganization = _appData.company;
	_mainStuct.department = _appData.department;
	_mainStuct.position = _appData.position;
	_date.setTime(parseInt(_appData.createtime));
	_mainStuct.createdtime = _date.format(expConst.dataStore.dateformat);
	_date.setTime(parseInt(_appData.updatetime));
	_mainStuct.updatedtime = _date.format(expConst.dataStore.dateformat);
	_info.archivedtime = _appData.createtime;
	_info.createdtime = _appData.createtime;
	_info.updatedtime = _appData.updatetime;
	// 生日
	if(!tools.isNullOrEmpty(_appData.birthday)){
		_date.setTime(parseInt(_appData.birthday));
		_mainStuct.birthday = _date.format(expConst.dataStore.dateformat);
	} else {
		_mainStuct.birthday = null;
	}
	_mainStuct.calendartype = _appData.calendartype;
	_mainStuct.url = _appData.website;
	_mainStuct.note = _appData.remarks;
	// 启用时间
	if(!tools.isNull(_appData.starttime)){
		_date.setTime(parseInt(_appData.starttime));
		_mainStuct.effecttime = _date.format(expConst.dataStore.dateformat);
	} else {
		_mainStuct.effecttime = null;
	}
	// 失效时间
	if(!tools.isNull(_appData.endtime)){
		_date.setTime(parseInt(_appData.endtime));
		_mainStuct.expiretime = _date.format(expConst.dataStore.dateformat);
	} else {
		_mainStuct.expiretime = null;
	}
	// 转换联系人性别数据（到信息库）
	transferContactGenderToExp(_mainStuct, _appData.gender);
	// 转换联系人属性数据（到信息库）
	transferContactPropToExp(_info.nodeid, _mainStuct, _properties);
}

/**
 * 转换联系人数据（到信息库）
 * @param _info
 * @param _appData
 * @param _properties
 * @returns
 */
function transferDataContactToExpInfo(_info, _appData, _properties){
	var _date = new Date();
	// 结构化
	var _mainStuct = _info.mainstruct;
	_mainStuct.protagonist = _appData.name;
	_mainStuct.affiorganization = _appData.company;
	_mainStuct.note = _appData.remarks;
	_date.setTime(parseInt(_appData.createtime));
	_mainStuct.createdtime = _date.format(expConst.dataStore.dateformat);
	_date.setTime(parseInt(_appData.updatetime));
	_mainStuct.updatedtime = _date.format(expConst.dataStore.dateformat);
	_info.archivedtime = _appData.createtime;
	_info.createdtime = _appData.createtime;
	_info.updatedtime = _appData.updatetime;
	// 转换联系人性别数据（到信息库）
	transferContactGenderToExp(_mainStuct, _appData.gender);
	// 获取信息所在的二级节点
	var _nodeId = _appData.type;
	// 小朋友信息
	if(_nodeId == infoTypeConst.typeConstants.contactType_children){
		_mainStuct.personphoto = _appData.headurl;
		_mainStuct["class"] = _appData.department;
		// 生日
		if(!tools.isNullOrEmpty(_appData.birthday)){
			_date.setTime(parseInt(_appData.birthday));
			_mainStuct.birthday = _date.format(expConst.dataStore.dateformat);
		} else {
			_mainStuct.birthday = null;
		}
		_mainStuct.calendartype = _appData.calendartype;
	} else if(_nodeId == infoTypeConst.typeConstants.contactType_goods){ // 物品维护联系
		_mainStuct.localtitle = _appData.goodsname;
		_mainStuct.department = _appData.department;
		_mainStuct.position = _appData.position;
		_mainStuct.url = _appData.comwebsite;
	} else { // 其他联系人信息（包括朋友信息）
		_mainStuct.personphoto = _appData.headurl;
		_mainStuct.department = _appData.department;
		_mainStuct.position = _appData.position;
		// 生日
		if(!tools.isNullOrEmpty(_appData.birthday)){
			_date.setTime(parseInt(_appData.birthday));
			_mainStuct.birthday = _date.format(expConst.dataStore.dateformat);
		} else {
			_mainStuct.birthday = null;
		}
		_mainStuct.calendartype = _appData.calendartype;
		_mainStuct.url = _appData.comwebsite;
	}
	// 转换联系人属性数据（到信息库）
	transferContactPropToExp(_nodeId, 
			_mainStuct, _properties);
}

/**
 * 获取联系人属性数据
 * @param _id
 * @returns
 */
function getContactProp(_id){
	// 获取名片属性信息
	var _sql = "select * from contacts_properties where id='" + _id + "';"
	var _properties = localdb.querySync(_sql);
	return _properties;
}

/**
 * 保存名片到信息库
 * @param _vcardList
 * @param _info
 * @param _nodeData
 * @param _infoNodeRelList
 * @param _func
 * @returns
 */
function saveMultipleVCardToExp(_vcardList, _info, _nodeData, _infoNodeRelList, _func){
	if(_vcardList.length > 0){
		var _vcardData = _vcardList.shift();
		if(!tools.isNull(_vcardData)){
			_info.infoid = _vcardData.id;
			// 若信息主标题重名，则默认保存到版本组
			_info.autosave_versiongroup = true;
			// 获取名片属性数据
			var _properties = getContactProp(_vcardData.id);
			// 转换名片到信息片段
			transferDataVCardToExpInfo(_info, _vcardData, _properties);
			// 创建名片对应的信息片段
			expService.createInfo(_info, function(_result){
				// 将信息和节点的对应关系先缓存起来，供后面将使用记录保存到信息使用
				_infoNodeRelList.push({
					infoid: _info.infoid,
					nodedata: _nodeData
				});
				saveMultipleVCardToExp(_vcardList, _info, _nodeData,
						_infoNodeRelList, _func);
			});
		} else {
			saveMultipleVCardToExp(_vcardList, _info, _nodeData,
					_infoNodeRelList, _func);
		}
	} else {
		_func.call(this);
	}
}

/**
 * 处理名片到信息库
 * @param _infoNodeRelList
 * @param _infoIdList
 * @param _func
 * @returns
 */
function handleVCardToExp(_infoNodeRelList, _infoIdList, _func){
	var _sql = "select * from contacts_vcard ";
	if(_infoIdList.length > 0){
		_sql += " and id not in ('" + _infoIdList.join("','") + "')";
	}
	_sql += ";";
	var _vcardList = localdb.querySync(_sql);
	if(!tools.isNullOrEmpty(_vcardList)){
		// 获取节点数据
		var _nodeData = getNodeData("1580");
		// 初始化信息片段
		var _info = dataService.initInfo("1580");
		// 保存所有名片的到信息库
		saveMultipleVCardToExp(_vcardList, 
				_info, _nodeData, _infoNodeRelList, _func);
	} else {
		_func.call(this);
	}
}

/**
 * 检查联系人是否重名
 * @param _contactDatas
 * @param _contact
 * @returns
 */
function checkDupNameContact(_contactDatas, _contact){
	var _isExist = false;
	if(!tools.isNullOrEmpty(_contactDatas)){
		for(var i=0; i<_contactDatas.length; i++){
			if(_contactDatas[i].id != _contact.id &&
					_contactDatas[i].type == _contact.type &&
					_contactDatas[i].name == _contact.name){
				_isExist = true;
			}
		}
	}
	return _isExist;
}

/**
 * 获取单个联系人信息
 * @param _contactData
 * @param _properties
 * @param _expInfoList
 * @param _infoList
 * @param _infoNodeRelList
 * @returns
 */
function getSingleContact(_contactData, _properties, 
		_expInfoList, _infoList, _infoNodeRelList){
	// 获取节点信息
	var _nodeData = getNodeData(_contactData.type);
	// 初始化信息片段
	var _info = getInfoByList(_infoList, _nodeData[1]);
	_info.infoid = _contactData.id;
	// 将信息和节点的对应关系先缓存起来，供后面将使用记录保存到信息使用
	_infoNodeRelList.push({
		infoid: _info.infoid,
		nodedata: _nodeData
	});
	// 若信息主标题重名，则默认保存到序号组
	_info.autosave_serialgroup = true;
	// 转换联系人到信息片段
	transferDataContactToExpInfo(_info, _contactData, _properties);
	// 获取创建信息片段的sql语句
	expService.getCreateInfoSql(_expInfoList, _info);
}

/**
 * 获取联系人属性信息
 * @param _propList
 * @param _id
 * @returns
 */
function getContactPropByList(_propList, _id){
	var _properties = [];
	if(!tools.isNullOrEmpty(_propList)){
		for(var i=0; i<_propList.length; i++){
			if(tools.isNull(_propList[i])) continue;
			if(_propList[i].id == _id){
				_properties.push(_propList[i]);
				_propList[i] = null;
				break;
			}
		}
	}
	return _properties;
}

/**
 * 获取多个联系人数据
 * @param _contactDatas
 * @param _index
 * @param _expInfoList
 * @param _dupNameContactList
 * @param _infoList
 * @param _infoNodeRelList
 * @returns
 */
function getMultipleContact(_contactDatas, _index, _expInfoList, 
		_dupNameContactList, _infoList, _infoNodeRelList){
	var _idList = [];
	// 每次处理50个联系人
	for(var i=0; i<saveContactNum; i++){
		if(_index < _contactDatas.length){
			var _contact = _contactDatas[_index];
			// 检查联系人是否重名
			var _isExist = checkDupNameContact(_contactDatas, _contact);
			if(!_isExist){
				_idList.push(_contact.id);
			} else {
				_dupNameContactList.push(_contact);
			}
		}
		_index++;
	}
	if(_idList.length > 0){
		// 批量查询联系人信息
		var _sql = "select * from contacts_contact where id in ('" + 
			_idList.join("','") + "');";
		var _contactList = localdb.querySync(_sql);
		if(!tools.isNullOrEmpty(_contactList)){
			// 批量查询联系人属性信息
			_sql = "select * from contacts_properties where id in ('" + 
				_idList.join("','") +"');";
			var _propList = localdb.querySync(_sql);
			// 遍历所有联系人
			for(var i=0; i<_contactList.length; i++){
				if(tools.isNull(_contactList[i])) continue;
				// 获取联系人属性信息
				var _properties = getContactPropByList(_propList, _contactList[i].id);
				// 获取单个联系人信息
				getSingleContact(_contactList[i], _properties, 
						_expInfoList, _infoList, _infoNodeRelList);
			}
		}
	}
}

/**
 * 保存多个联系人到信息库
 * @param _contactDatas
 * @param _index
 * @param _infoList
 * @param _infoNodeRelList
 * @param _dupNameContactList
 * @param _func
 * @returns
 */
function saveMultipleContactToExp(_contactDatas, _index, 
		_infoList, _infoNodeRelList, _dupNameContactList, _func){
	if(_index < _contactDatas.length){
		var _expInfoList = [];
		// 获取创建多个联系人信息的sql语句
		getMultipleContact(_contactDatas, _index, 
				_expInfoList, _dupNameContactList, _infoList, 
				_infoNodeRelList);
		
		_index += saveContactNum;
		if(_expInfoList.length > 0){
			expService.execute(_expInfoList, true, function(_result){
				saveMultipleContactToExp(_contactDatas, _index, _infoList, 
						_infoNodeRelList, _dupNameContactList, _func);
			});
		} else {
			saveMultipleContactToExp(_contactDatas, _index, _infoList, 
					_infoNodeRelList, _dupNameContactList, _func);
		}
	} else {
		_func.call(this);
	}
}

/**
 * 保存重名联系人到信息库
 * @param _dupNameContactList
 * @param _infoList
 * @param _infoNodeRelList
 * @param _func
 * @returns
 */
function saveDupNameContactToExp(_dupNameContactList, _infoList, 
		_infoNodeRelList, _func){
	if(_dupNameContactList.length > 0){
		var _id = _dupNameContactList.shift().id;
		var _contactData = dbcontacts.query_contactDataById(_id);
		if(null != _contactData){
			// 获取节点信息
			var _nodeData = getNodeData(_contactData.type);
			// 初始化信息片段
			var _info = getInfoByList(_infoList, _nodeData[1]);
			_info.infoid = _id;
			// 若信息主标题重名，则默认保存到序号组
			_info.autosave_serialgroup = true;
			// 获取联系人属性信息
			var _properties = getContactProp(_id);
			// 转换联系人到信息片段
			transferDataContactToExpInfo(_info, _contactData, _properties);
			// 创建联系人对应的信息片段
			expService.createInfo(_info, function(_result){
				// 将信息和节点的对应关系先缓存起来，供后面将使用记录保存到信息使用
				_infoNodeRelList.push({
					infoid: _info.infoid,
					nodedata: _nodeData
				});
				// 保存同名联系人信息到信息库
				saveDupNameContactToExp(_dupNameContactList, _infoList,
						_infoNodeRelList, _func);
			});
		} else {
			// 保存多个联系人信息到信息库
			saveDupNameContactToExp(_dupNameContactList, _infoList,
					_infoNodeRelList, _func);
		}
	} else {
		_func.call(this);
	}
}

/**
 * 处理名片到信息库
 * @param _infoNodeRelList
 * @param _infoIdList
 * @param _func
 * @returns
 */
function handleContactToExp(_infoNodeRelList, _infoIdList, _func){
	var _sql = "select id,type,name from contacts_contact";
	if(_infoIdList.length > 0){
		_sql += " and id not in ('" + _infoIdList.join("','") + "')";
	}
	_sql += ";";
	localdb.query(_sql, function(_contactDatas){
		if(!tools.isNullOrEmpty(_contactDatas)){
			// 初始化信息片段
			var _infoList = [];
			// 重名联系人
			var _dupNameContactList = [];
			// 保存所有联系人到信息库
			saveMultipleContactToExp(_contactDatas, 0, 
					_infoList, _infoNodeRelList, _dupNameContactList, 
					function(){
				// 若重名联系人不为空，则保存重名联系人；
				// 重名联系人需要生成信息组，所以调用信息库单个保存信息片段的接口
				if(_dupNameContactList.length > 0){
					saveDupNameContactToExp(_dupNameContactList, 
							_infoList, _infoNodeRelList, function(){
						_func.call(this);
					});
				} else {
					_func.call(this);
				}
			});
		} else {
			_func.call(this);
		}
	});
}

/**
 * 保存所有联系人应用数据到信息库
 * @param _infoNodeRelList
 * @param _infoIdList
 * @param _func
 * @returns
 */
function handleAllContactAppToExp(_infoNodeRelList, _infoIdList, _func){
	// 更新联系人类型
	updateContactDataType();
	// 处理名片保存到信息库
	handleVCardToExp(_infoNodeRelList, _infoIdList, function(){
		// 处理联系人保存到信息库
		handleContactToExp(_infoNodeRelList, _infoIdList, function(){
			_func.call(this);
		});
	});
}

/**
 * 添加使用记录的更新记录
 * @param infoid
 * @param id
 * @param fullpathlist
 * @returns
 */
function addUserecordSyncUpdRecord(infoid, id, recordtime, fullpathlist){
	var _updRecordId = syncTools.getUpdRecordId(syncGlobalConst.dataType.exp_userecord, infoid, id);
	// 添加同步更新记录
	dbExpSync.setUpdRecordUnHandle({
		dataid: _updRecordId,
		recordtime: recordtime,
		recordtype: syncGlobalConst.recordType.create,
		datatype: syncGlobalConst.dataType.exp_userecord,
		updcount: 0,
		fullpathlist: fullpathlist,
		needsync: 1
	});
}

/**
 * 添加信息使用记录（本地使用记录和库外共享记录）
 * 
 * @param infoid
 * @param userecord
 * @returns
 */
function addInfoUseRecord4Sync(_userecords, _index, _callFun){
	if(_index >= _userecords.length){
		_callFun.call(this);
		return;
	}
	var userecord = _userecords[_index];
	var sql = "insert into pips_userecordview (id,infoid,type,fromperson,fromorganization,syscall," +
			"toperson,toorganization,applyevent,applyproc,useformat,useapp,useid,usetype," +
			"shareformat,sharechannel,labeltime,createdtime) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?);";
	var fromperson = userecord.fromperson;
	if(tools.isNullOrEmpty(fromperson)){
		fromperson = "";
	}
	var fromorganization = userecord.fromorganization;
	if(tools.isNullOrEmpty(fromorganization)){
		fromorganization = "";
	}
	var syscall = userecord.syscall;
	if(tools.isNullOrEmpty(syscall)){
		syscall = "";
	}
	var personname = userecord.personname;
	if(tools.isNullOrEmpty(personname)){
		personname = "";
	}
	var organization = userecord.organization;
	if(tools.isNullOrEmpty(organization)){
		organization = "";
	}
	var applyevent = userecord.applyevent;
	if(tools.isNullOrEmpty(applyevent)){
		applyevent = "";
	}
	var applyproc = userecord.applyproc;
	if(tools.isNullOrEmpty(applyproc)){
		applyproc = "";
	}
	var useformat = userecord.useformat;
	if(tools.isNullOrEmpty(useformat)){
		useformat = "";
	}
	var useapp = userecord.useapp;
	if(tools.isNullOrEmpty(useapp)){
		useapp = "";
	}
	var useid = userecord.useid;
	if(tools.isNullOrEmpty(useid)){
		useid = "";
	}
	var usetype = userecord.usetype;
	if(tools.isNullOrEmpty(usetype)){
		usetype = "";
	}
	var shareformat = userecord.shareformat;
	if(tools.isNullOrEmpty(shareformat)){
		shareformat = "";
	}
	var sharechannel = userecord.sharechannel;
	if(tools.isNullOrEmpty(sharechannel)){
		sharechannel = "";
	}
	pipsdb.execute(sql, [userecord.id, userecord.infoid, userecord.type, fromperson,
		 fromorganization, syscall, personname, organization,
		 applyevent, applyproc, useformat, useapp, useid,
		 usetype, shareformat, sharechannel, userecord.labeltime, userecord.createdtime], function(ret){
		// 添加同步更新记录
		var fullpathlist = userecord.nodedata.nodedata[2];
		addUserecordSyncUpdRecord(userecord.infoid, userecord.id, userecord.labeltime, fullpathlist);
		
		// 保存下一个记录
		_index++;
		addInfoUseRecord4Sync(_userecords, _index, _callFun);
	});
}

/**
 * 获取信息库使用记录数据
 * @param _dataType
 * @param _useRecordData
 * @returns
 */
function getUseRecordData(_dataType, _useRecordData){
	var _newData = new Object();
	// 使用记录数据
	if(_dataType == constants.getConstants("datatype_userecord")){
		_newData = {
				id: _useRecordData.id,
				infoid: _useRecordData.taskid,
				type: 1,
				syscall: syncDataTools.syscallRemote2Local(_useRecordData.syscall),
				fromperson: null,
				fromorganization: null,
				toperson: _useRecordData.personname,
				toorganization: _useRecordData.destorganization,
				applyevent: _useRecordData.applyevent,
				applyproc: _useRecordData.applyproc,
				useformat: syncDataTools.useformatRemote2Local(_useRecordData.useformat),
				useapp: null,
				useid: null,
				usetype: null,
				sharechannel: _useRecordData.sharechannel,
				shareformat: null,
				labeltime: _useRecordData.labeltime,
				createdtime: _useRecordData.labeltime
		};
		// 共享记录数据
	} else if(_dataType == constants.getConstants("datatype_sharerecord")){
		_newData = {
				id: _useRecordData.id,
				infoid: _useRecordData.taskid,
				type: 2,
				fromperson: _useRecordData.personname,
				fromorganization: _useRecordData.destorganization,
				syscall: null,
				toperson: null,
				toorganization: null,
				applyevent: _useRecordData.applyevent,
				applyproc: _useRecordData.applyproc,
				useformat: null,
				useapp: null,
				useid: null,
				usetype: null,
				sharechannel: _useRecordData.sharechannel,
				shareformat: syncDataTools.useformatRemote2Local(_useRecordData.shareformat),
				labeltime: _useRecordData.labeltime,
				createdtime: _useRecordData.labeltime
		};
	}
	return _newData;
}

/**
 * ID是否还存在
 * @param _infoNodeRelList
 * @param _id
 * @returns
 */
function infoidExist(_infoNodeRelList, _id){
	var _ret = null;
	if(tools.isNullOrEmpty(_infoNodeRelList)){
		return _ret;
	}
	for (var i = 0; i < _infoNodeRelList.length; i++) {
		var _info = _infoNodeRelList[i];
		if(_info.infoid == _id){
			_ret = _infoNodeRelList[i];
			break;
		}
	}
	return _ret;
}

/**
 * 转移本地使用记录
 * @param _infoNodeRelList
 * @param _func
 * @returns
 */
function transferUserecord(_infoNodeRelList, _func){
	// 查询本地使用记录表（userecord）的数据
	var _sql = "select * from userecord;";
	localdb.query(_sql, function(_userecordsOld){
		if(!tools.isNullOrEmpty(_userecordsOld)){
			// 转换数据
			var _userecords = [];
			for (var i = 0; i < _userecordsOld.length; i++) {
				var _userecordOld = _userecordsOld[i];
				var _taskid = _userecordOld.taskid;
				// 判断卡片ID是否还存在
				var _nodeData = infoidExist(_infoNodeRelList, _taskid);
				if(tools.isNull(_nodeData)){
					continue;
				}
				var _newData = getUseRecordData(constants.getConstants("datatype_userecord"), _userecordOld);
				_newData.nodedata = _nodeData;
				_userecords.push(_newData);
			}
			// 保存
			addInfoUseRecord4Sync(_userecords, 0, function(){
				_func.call(this);
			});
		} else {
			_func.call(this);
		}
	});
}

/**
 * 转移库外共享记录
 * @param _infoNodeRelList
 * @param _func
 * @returns
 */
function transferSharerecord(_infoNodeRelList, _func){
	// 查询库外共享记录表（sharerecord）的数据
	var _sql = "select * from sharerecord;";
	localdb.query(_sql, function(_userecordsOld){
		if(!tools.isNullOrEmpty(_userecordsOld)){
			// 转换数据
			var _userecords = [];
			for (var i = 0; i < _userecordsOld.length; i++) {
				var _userecordOld = _userecordsOld[i];
				var _taskid = _userecordOld.taskid;
				// 判断卡片ID是否还存在
				var _nodeData = infoidExist(_infoNodeRelList, _taskid);
				if(tools.isNull(_nodeData)){
					continue;
				}
				var _newData = getUseRecordData(constants.getConstants("datatype_sharerecord"), _userecordOld);
				_newData.nodedata = _nodeData;
				_userecords.push(_newData);
			}
			// 保存
			addInfoUseRecord4Sync(_userecords, 0, function(){
				_func.call(this);
			});
		} else {
			_func.call(this);
		}
	});
}

/**
 * 删除使用记录表
 * 删除使用记录表并清除更新记录中使用记录的更新记录
 * @param _func
 * @returns
 */
function handleUseRecordTable(_func){
	var _sqlList = [
		"drop table userecord;",
		"drop table sharerecord;",
		"delete from datasync_cl_updrecord where datatype='6' or datatype='7'"
	];
	localdb.execute1(_sqlList, _func);
}

/**
 * 处理所有使用记录
 * @param _infoNodeRelList
 * @param _func
 * @returns
 */
function handleAllUseRecordToExp(_infoNodeRelList, _func){
	// 转移userecord
	transferUserecord(_infoNodeRelList, function(){
		// 转移sharerecord
		transferSharerecord(_infoNodeRelList, function(){
			// 处理使用记录（删除使用记录表并清除更新记录中使用记录的更新记录）
			handleUseRecordTable(_func);
		});
	});
}

/**
 * 获取信息库数据
 * @returns
 */
function getExpInfoData(){
	var _sql = "select infoid from pips_info;";
	var _infoIds = pipsdb.executeSync(_sql);
	var _infoList = [];
	if(!tools.isNullOrEmpty(_infoIds)){
		for(var i=0; i<_infoIds.length; i++){
			if(tools.isNullOrEmpty(_infoIds[i]))
				continue;
			_infoList.push(_infoIds[i].infoid);
		}
	}
	return _infoList;
}

/**
 * 处理数据库升级（34）
 * @param _func
 * @returns
 */
function handleUpgradeDb34(_func){
	// 先加载节点缓存，后面数据处理需要用
	loadNodeCache(function(){
		var _infoNodeRelList = [];
		var _infoIdList = getExpInfoData();
		// 处理所有时间流数据到信息库
		handleAllTfDataAppToExp(_infoNodeRelList, _infoIdList, function(){
			// 处理所有联系人数据到信息库
			handleAllContactAppToExp(_infoNodeRelList, _infoIdList, function(){
				// 处理所有使用记录数据到信息库
				handleAllUseRecordToExp(_infoNodeRelList, function(){
					_infoNodeRelList.length = 0;
					_infoNodeRelList = null;
					_func.call(this);
				});
			});
		});
	});
}

/**
 * 升级数据库（34）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb34(_dbVersion, _func){
	print("upgradeDb34 " + _dbVersion);
	//处理数据库升级（34）
	if(_dbVersion < 34){
		handleUpgradeDb34(function(){
			upgradeDb35(_dbVersion, _func);
		});
	} else {
		upgradeDb35(_dbVersion, _func);
	}
}

/**
 * 获取单个游历记录处理后的结果
 * @param _infoData
 * @returns
 */
function getSingleGenTravelRecord(_infoData){
	var _travelRecordStr = "";
	if(!tools.isNullOrEmpty(_infoData.travelrecord)){
		var _genTravelRecords = jsonTools.strToJsonObj(_infoData.travelrecord);
		if(!tools.isNullOrEmpty(_genTravelRecords)){
			var _date = new Date();
			for(var j=0; j<_genTravelRecords.length; j++){
				if(!tools.isNull(_genTravelRecords[j]) &&
						tools.isNullOrEmpty(_genTravelRecords[j].articlecode)){
					_genTravelRecords[j].articlecode = deviceInfo.deviceid;
					_genTravelRecords[j].archivedchannel = deviceInfo.devicemodel;
					_genTravelRecords[j].personname = userInfo.name;
					if(!tools.isNull(_infoData.createdtime)){
						_date.setTime(parseInt(_infoData.createdtime)); 
						_genTravelRecords[j].archivedtime = _date.format(expConst.dataStore.dateformat);
					}
				}
			}
			_travelRecordStr = jsonTools.jsonObjToStr(_genTravelRecords);
		}
	}
	return _travelRecordStr;
}

/**
 * 处理所有游历记录（设备唯一识别码的游历记录，每次处理500条数据）
 * @param _infoList
 * @param _func
 * @returns
 */
function handleAllGeneravteTravelRecord(_infoList, _func){
	if(_infoList.length > 0){
		var _sqlList = [];
		var _sql = "";
		for(var i=0; i<300; i++){
			if(_infoList.length > 0){
				var _infoData = _infoList.shift();
				if(!tools.isNull(_infoData) &&
						!tools.isNullOrEmpty(_infoData.infoid)){
					var _travelRecordStr = getSingleGenTravelRecord(_infoData);
					if(!tools.isNullOrEmpty(_travelRecordStr)){
						_sql = "update pips_info set travelrecord='" + _travelRecordStr
							+ "' where infoid='" + _infoData.infoid + "';";
						_sqlList.push(_sql);
					}
				}
			}
		}
		print("_sqlList " + JSON.stringify(_sqlList));
		// 若sql语句不为空，则执行这些sql语句
		if(_sqlList.length > 0){
			expService.execute(_sqlList, true, function(_result){
				print("execute " + _result);
				handleAllGeneravteTravelRecord(_infoList, _func);
			});
		} else {
			handleAllGeneravteTravelRecord(_infoList, _func);
		}
	} else {
		_func.call(this);
	}
}

/**
 * 处理信息片段游历记录数据
 * @param _func
 * @returns
 */
function handleGeneravteTravelRecord(_func){
	// 查询信息片段的游历记录（主要是articlecode的游历记录）
	var _sql = "select infoid,travelrecord,createdtime from pips_info where travelrecord not like '%articlecode%';";
	var _genTravelRecordList = pipsdb.querySync(_sql);
	if(!tools.isNullOrEmpty(_genTravelRecordList)){
		// 处理所有游历记录
		handleAllGeneravteTravelRecord(_genTravelRecordList, _func);
	} else {
		_func.call(this);
	}
}

/**
 * 处理数据库升级（35）
 * @param _func
 * @returns
 */
function handleUpgradeDb35(_func){
	// 处理信息片段游历记录数据
	handleGeneravteTravelRecord(function(){
		// 处理更新记录数据（recordtype=0和fullpathlist=''）
		wrongDataHandler.handleUpdRecordData(function(){
			_func.call(this);
		});
	});
}

/**
 * 升级数据库（35）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb35(_dbVersion, _func){
	logTools.printLog(Tag, "upgradeDb35 " + _dbVersion);
	//处理数据库升级（35）
	if(_dbVersion < 35){
		// 35主要处理3.0.0版本升级及升级后同步出现的数据问题，
		// 其他数据版本只需要升级到3.0.0版本，不需要再次处理
		if(34 == _dbVersion){
			handleUpgradeDb35(function(){
				upgradeDb36(_dbVersion, _func);
			});
		} else {
			upgradeDb36(_dbVersion, _func);
		}
	} else {
		upgradeDb36(_dbVersion, _func);
	}
}

/**
 * 处理数据库升级（36）
 * @param _func
 * @returns
 */
function handleUpgradeDb36(_func){
	logTools.printLog(Tag, "handleUpgradeDb36 ");
	// 先加载节点缓存，后面数据处理需要用
	loadNodeCache(function(){
		logTools.printLog(Tag, "loadNodeCache ");
		// 处理所有更新记录数据（fullpathlist重新计算）
		wrongDataHandler.handleAllUpdRecordFullPath(function(){
			_func.call(this);
		});
	});
}

/**
 * 升级数据库（36）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb36(_dbVersion, _func){
	logTools.printLog(Tag, "upgradeDb36 " + _dbVersion);
	//处理数据库升级（36）
	if(_dbVersion < 36){
		// 36主要处理3.0.1版本升级及升级后同步出现的数据问题，
		// 其他数据版本只需要升级到3.0.0版本，不需要再次处理
		if(35 == _dbVersion){
			handleUpgradeDb36(function(){
				upgradeDb37(_dbVersion, _func);
			});
		} else {
			upgradeDb37(_dbVersion, _func);
		}
	} else {
		upgradeDb37(_dbVersion, _func);
	}
}

/**
 * 判断是否存在默认字段
 * @param _moreFeilds
 * @param _field
 * @returns
 */
function isExistFeild(_moreFeilds, _field){
	var _isExist = false;
	if(null != _moreFeilds){
		for(var _key in _moreFeilds){
			if(_field == _key){
				_isExist = true;
				break;
			}
		}
	}
	return _isExist;
}

/**
 * 获取转换更多字段的sql语句
 * @param _fieldData
 * @param _moreFields
 * @returns
 */
function getTransMoreFeildSql(_fieldData, _moreFields){
	var _existField = false;
	var _newFields = new Object();
	var _value = null;
	var _fieldStr = "";
	for(var _field in _moreFields){
		var _value = _moreFields[_field];
		if(isExistFeild(_fieldData.useFields, _field)){
			if(_fieldData.useFields[_field] == "object"){
				if(!isEmptyObject(_value)){
					_value = JSON.stringify(_moreFields[_field]);
				} else {
					_value = "''";
				}
			}
			if("endremindtime" == _field){
				_value = tools.getLocalRemindTime(_moreFields[_field]);
			}
			if(_fieldStr.length > 0){
				_fieldStr += ",";
			}
			_fieldStr += _field+ "=" + _value;
			_existField = true;
		} else if(isExistFeild(_fieldData.noUseFields, _field)){
			_existField = true;
		} else {
			_newFields[_field] = _value;
		}
	}
	if(_existField){
		if(_fieldStr.length > 0){
			_fieldStr += ",";
		}
		_fieldStr += "morefields=";
		if(!isEmptyObject(_newFields)){
			_fieldStr += JSON.stringify(_newFields);
		} else {
			_fieldStr += "''";
		}
	}
	return _fieldStr;
}

/**
 * 处理时间流卡片更多字段（每次500条）
 * @param _index
 * @param _taskList
 * @param _fieldData
 * @param _callFunc
 * @returns
 */
function handleTfTaskMoreFeild(_index, _taskList, _fieldData, _callFunc){
	if(_index < _taskList.length){
		var _sqlList = [];
		// 遍历500条待办数据
		for(var i=0; i<300; i++){
			if(_index < _taskList.length){
				var _taskData = _taskList[_index];
				if(null != _taskData){
					var _moreFeilds = jsonTools.strToJsonObj(_taskData.morefields);
					if(null != _moreFeilds){
						var _sql = getTransMoreFeildSql(_fieldData, _moreFeilds);
						if(_sql.length > 0){
							var _cond = "";
							if(1 == _taskData.cycleid){
								_cond = " where id=" + tools.formatSqlValue(_taskData.id);
							} else {
								_cond = " where cyclerecordid=" + tools.formatSqlValue(_taskData.cyclerecordid);
							}
							_sqlList.push("update mytask set " + _sql + _cond + ";");
						}
					}
				}
				_index++;
			} else {
				break;
			}
		}
		if(_sqlList.length > 0){
			// 异步执行sql语句
			localdb.execute1(_sqlList, true, function(){
				//处理时间流卡片更多字段
				handleTfTaskMoreFeild(_index, _taskList, _fieldData, _callFunc);
			});
		} else {
			//处理时间流卡片更多字段
			handleTfTaskMoreFeild(_index, _taskList, _fieldData, _callFunc);
		}
	} else {
		//回调函数
		_callFunc.call(this);
	}
}

/**
 * 处理所有时间流卡片更多字段
 * @param _callFunc
 * @returns
 */
function handleAllTfTaskMoreFeild(_callFunc){
	// 查询morefeilds不为空待办的指定字段
	var _sql = "select id,cycleid,cyclerecordid,morefields from mytask where" +
			" infocategory=1 and length(id)=24 and morefields!=''";
	localdb.query({sql: _sql}, function(_taskList){
		if(null != _taskList && 
				_taskList.length > 0){
			var _fieldData = {
					useFields: {
						starttimetype: "int",
						endtimetype: "int",
						endremindtime: "int"
					},
					noUseFields: {
						createtime: "int",
						updatetime: "int"
					}
			};
			//处理时间流卡片更多字段
			handleTfTaskMoreFeild(0, _taskList, _fieldData, function(){
				// 回调函数
				_callFunc.call(this);
			});
		} else {
			// 回调函数
			_callFunc.call(this);
		}
	});
}

/**
 * 处理数据库升级（37）
 * @param _func
 * @returns
 */
function handleUpgradeDb37(_func){
	var _startTime = (new Date()).getTime();
	logTools.printLog(Tag, "handleUpgradeDb37 start " + _startTime);
	var _sql = "";
	var _sqlList = [];
	// 时间流卡片表增加开始时间类型字段（starttimetype）
	_sql = "alter table mytask add column starttimetype integer default 0;";
	_sqlList.push(_sql);
	// 时间流卡片表增加结束时间类型字段（endtimetype）
	_sql = "alter table mytask add column endtimetype integer default 0;";
	_sqlList.push(_sql);
	// 时间流卡片表增加结束时间提醒字段（endremindtime）
	_sql = "alter table mytask add column endremindtime integer default 9;";
	_sqlList.push(_sql);
	// 时间流卡片表增加结束时间提醒标识字段（endnotifyid）
	_sql = "alter table mytask add column endnotifyid integer;";
	_sqlList.push(_sql);
	localdb.execute1(_sqlList, true, function(){
		//处理所有时间流卡片更多字段
		handleAllTfTaskMoreFeild(function(){
			logTools.printLog(Tag, "handleUpgradeDb37 app end " + ((new Date()).getTime() - _startTime));
			//信息库旧数据处理
			wrongDataHandler.handleOldData(function(){
				logTools.printLog(Tag, "handleUpgradeDb37 exp end " + ((new Date()).getTime() - _startTime));
				_func.call(this);
			});
		});
	});
}

/**
 * 升级数据库（37）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb37(_dbVersion, _func){
	logTools.printLog(Tag, "upgradeDb37 " + _dbVersion);
	//处理数据库升级（37）
	if(_dbVersion < 37){
		handleUpgradeDb37(function(){
			upgradeDb38(_dbVersion, _func); 
		});
	} else {
		upgradeDb38(_dbVersion, _func);
	}
}

/**
 * 处理数据库升级（38）
 * @param _func
 * @returns
 */
function handleUpgradeDb38(_func){
	dataUpgrade.handleDataUpgrade38(_func);
}

/**
 * 升级数据库（38）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb38(_dbVersion, _func){
	logTools.printLog(Tag, "upgradeDb38 " + _dbVersion);
	//处理数据库升级（38）
	if(_dbVersion < 38){
		handleUpgradeDb38(function(){
			upgradeDb39(_dbVersion, _func);
		});
	} else {
		upgradeDb39(_dbVersion, _func);
	}
}

/**
 * 处理数据库升级（39）
 * @param _func
 * @returns
 */
function handleUpgradeDb39(_func){
	dataUpgrade.handleDataUpgrade39(_func);
}

/**
 * 升级数据库（39）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb39(_dbVersion, _func){
	logTools.printLog(Tag, "upgradeDb39 " + _dbVersion);
	//处理数据库升级（39）
	if(_dbVersion < 39){
		handleUpgradeDb39(function(){
			upgradeDb40(_dbVersion, _func);
		});
	} else {
		upgradeDb40(_dbVersion, _func);
	}
}

/**
 * 处理数据库升级（40）
 * @param _func
 * @returns
 */
function handleUpgradeDb40(_func){
	dataUpgrade.handleDataUpgrade40(_func);
}

/**
 * 升级数据库（40）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb40(_dbVersion, _func){
	logTools.printLog(Tag, "upgradeDb40 " + _dbVersion);
	//处理数据库升级（40）
	if(_dbVersion < 40){
		handleUpgradeDb40(function(){
			upgradeDb41(_dbVersion, _func);
		});
	} else {
		upgradeDb41(_dbVersion, _func);
	}
}

/**
 * 处理数据库升级（41）
 * @param _func
 * @returns
 */
function handleUpgradeDb41(_func){
	dataUpgrade.handleDataUpgrade41(_func);
}

/**
 * 升级数据库（41）
 * @param _dbVersion
 * @param _func
 * @returns
 */
function upgradeDb41(_dbVersion, _func){
	logTools.printLog(Tag, "upgradeDb41 " + _dbVersion);
	//处理数据库升级（41）
	if(_dbVersion < 41){
		handleUpgradeDb41(_func);
	} else {
		// 回调函数
		_func.call(this);
	}
}

/**
 * 处理大慧小影预置信息到信息库
 * @param _cydowSerStr
 * @param _callFunc
 * @returns
 */
function handleCydowServiceData(_cydowSerStr, _callFunc){
	// 获取一般联系人默认的三级节点
	var _nodeId = '1414';
	// 初始化大慧小影信息
	var _info = dataService.initInfo(_nodeId);
	_info.infoid = cydowServiceId;
	var _mainStruct = _info.mainstruct;
	_mainStruct.infocat = "{[2][2002][1136][1414]}";
	_mainStruct.protagonist = "大慧小影";
	_mainStruct.affiorganization = "北京慧影智虹科技有限公司";
	_mainStruct.gender = '女';
	_mainStruct.personphoto = _cydowSerStr;
	_mainStruct.department = "";
	_mainStruct.position = "慧影客服";
	_mainStruct.url = "www.cydow.com";
	_mainStruct.mobilephoneno = "13720028991";
	_mainStruct.telephoneno = {
			work: "010-62669205,13720028991",
			family: ""
	};
	_mainStruct.emailbox = {
			work: "cydowsupport@cydow.com",
			personal: "cydowsupport@cydow.com"
	};
	_mainStruct.physiaddress = {
			work: "北京市海淀区上地十街辉煌国际4号楼2206",
			family: ""
	};
	_mainStruct.node = "";
	
	var _sqlList = [];
	// 获取创建信息的sql语句
	dataService.getCreateInfoSql(_sqlList, _info);
	if(_sqlList.length > 0){
		dataService.execute(_sqlList, true, function(){
			_callFunc.call(this);
		});
	} else {
		_callFunc.call(this);
	}
}

/**
 * 加载用户的帐户信息
 * @returns
 */
function loadUserInfo(){
	var _userId = "";
	if(do_storage.fileExist("data://.config/userInfo")){
		_userId = do_storage.readFileSync("data://.config/userInfo");
	}
	// 用户信息
	var _userInfo = {
			userId: "",
			name: "",
			phone: "",
			email: "",
			pass: "",
			head: ""
		};
	if(null != _userId && "" != _userId){
		_userInfo.userId = _userId;
		var _userData = dbuser.query_userDataById(_userId);
		if(null != _userData){
			if(!tools.isNullOrEmpty(_userData.fullname)){
				_userInfo.name = _userData.fullname;
			}
			_userInfo.pass = _userData.userpass;
			_userInfo.phone = _userData.mobileno;
			if(!tools.isNullOrEmpty(_userData.mailadd)){
				_userInfo.email = _userData.mailadd;
			}
		}
	}
	// 缓存用户信息（初始化）
	do_global.setMemory("userInfo", _userInfo);
}

/**
 * 打开应用数据库
 * @returns
 */
function openAppDb(){
	var _appPath = "data://db/mydata.db";
	// 打开应用的数据库
	var _open = localdb.open(_appPath);
}

/**
 * 打开信息库数据库
 * @returns
 */
function openPipsDb(){
	var _pipsPath = "data://db/pips.db";
	// 打开信息库的数据库
	var _open = pipsdb.open(_pipsPath);
}

/**
 * 打开应用和信息库数据库
 * @returns
 */
function openAppAndPipsDb(){
	// 打开应用数据库
	openAppDb();
	// 打开信息库数据库
	openPipsDb();
}

// 打开应用和信息库数据库
module.exports.openAppAndPipsDb = function(){
	openAppAndPipsDb();
};

/**
 * 关闭应用和信息库数据库
 * @returns
 */
function closeAppAndPipsDb(){
	// 关闭应用库
	localdb.close();
	// 关闭信息库
	pipsdb.close();
}

// 关闭应用和信息库数据库
module.exports.closeAppAndPipsDb = function(){
	closeAppAndPipsDb();
};

/**
 * 加密并打开数据库
 * @param _database
 * @param _dbPath
 * @param _callFunc
 * @returns
 */
function encryptAndOpenDb(_database, _dbPath, _callFunc){
	_database.encrypt({
		path: _dbPath
	}, function(_result){
		// 数据库存在，打开对应数据库
		var _open = _database.open(_dbPath);
		_callFunc.call(this);
	});
}

/**
 * 迁移数据库
 * 初始化应用库及迁移应用库并加密
 * @param _func
 * @returns
 */
function migrateDb(_func){
	//生成用户id（主要利用uuid来模拟生成）
	var _uId = uuid.getUUID();
	if(!do_dataCache.hasData("uId")){
		do_dataCache.saveData("uId", _uId);
	}
	// 应用库数据库文件路径
	var _dbPath = "data://db/mydata.db";
	// 信息库数据库文件路径
	var _pipsPath = "data://db/pips.db";
	
	var _migrateDbState = -1;
	if(do_dataCache.hasData(migrateDbStateKey)){
		_migrateDbState = do_dataCache.loadData(migrateDbStateKey);
	}
	if(-1 == _migrateDbState){
		do_dataCache.saveData(migrateDbStateKey, 0);
		// 初始化信息库并加密
		handleInitExpDb(function(){
			do_dataCache.saveData(migrateDbStateKey, 1);
			// 拷贝数据库文件
			do_storage.copyFile(_dbPath, 
					_dbPath + ".old", function(){
				// 迁移应用库，也就是加密已有的应用数据库
				encryptAndOpenDb(localdb, _dbPath, function(){
					do_dataCache.saveData(migrateDbStateKey, 2);
					_func.call(this);
				});
			});
		});
	} else if(0 == _migrateDbState){
		// 信息库数据库加密失败，删除文件重新加密
		do_storage.deleteFile(_pipsPath, function(_result){
			// 初始化信息库并加密
			handleInitExpDb(function(){
				do_dataCache.saveData(migrateDbStateKey, 1);
				// 拷贝数据库文件
				do_storage.copyFile(_dbPath, 
						_dbPath + ".old", function(){
					// 迁移应用库，也就是加密已有的应用数据库
					encryptAndOpenDb(localdb, _dbPath, function(){
						do_dataCache.saveData(migrateDbStateKey, 2);
						_func.call(this);
					});
				});
			});
		});
	} else if(1 == _migrateDbState){
		// 拷贝数据库文件
		do_storage.copyFile(_dbPath + ".old", 
				_dbPath, function(){
			// 迁移应用库，也就是加密已有的应用数据库
			encryptAndOpenDb(localdb, _dbPath, function(){
				do_dataCache.saveData(migrateDbStateKey, 2);
				// 打开信息数据库
				openPipsDb();
				// 回调函数
				_func.call(this);
			});
		});
	} else {
		// 数据库存在，打开应用和信息数据库
		openAppAndPipsDb();
		// 回调函数
		_func.call(this);
	}
}

/**
 * 处理初始化应用库
 * @param _callFunc
 * @returns
 */
function handleInitAppDb(_callFunc){
	// 打开应用库
	openAppDb();
	
	//创建表
	localdb.executeSync1({sqls: dbinitsqls.createTableSqls});
	//添加初始化信息
	localdb.executeSync1({sqls: dbinitsqls.initTableSqls});
	
	// “大慧小影”头像信息
	var _cydowSerStr = do_initData.readFileSync("initdata://cydow_service");
	var _nowTime = (new Date()).getTime();
	// 添加“大慧小影”信息
	localdb.executeSync(dbinitsqls.cydowServiceSql, 
			[cydowServiceId, typeconstants.typeConstants["contactType_common"],
			 _cydowSerStr, _nowTime, _nowTime]);
	
	// 数据同步v2.0-新表
	// 添加“大慧小影”信息的更新记录
	localdb.executeSync(dbinitsqls.cydowSerSyncUpdRecordSql, 
			[cydowServiceId, constants.getConstants("moduleType_contact"), 
			 _nowTime]);
	// 回调函数
	_callFunc.call(this, _cydowSerStr);
}

/**
 * 处理初始化信息库
 * @param _callFunc
 * @returns
 */
function handleInitExpDb(_callFunc){
	// 检查数据库文件是否存在
	var _pipspath = "data://db/pips.db";
	// 拷贝数据库文件
	do_initData.copyFile("initdata://pips.db", 
			_pipspath, function(){
		// 加密并打开数据库
		encryptAndOpenDb(pipsdb, _pipspath, _callFunc);
	});
}

/**
 * 升级数据库（初始化）
 * @param _callFunc
 * @returns
 */
function initDb(_callFunc){
	// 初始化信息库
	handleInitExpDb(function(){
		// 初始化应用库
		handleInitAppDb(function(_cydowSerStr){
			var _nowTime = (new Date()).getTime();
			// 修改所有更新记录的记录时间为当前时间
			dbExpSync.setAllUpdRecordTime(_nowTime);
			// 先加载节点缓存，再处理数据
			loadNodeCache(function(){
				// 处理大慧小影预置信息到信息库
				handleCydowServiceData(_cydowSerStr, _callFunc);
			});
		});
	});
}

/**
 * 升级数据库
 * @param _dbVersion
 * @param _currentVer
 * @param _func
 * @returns
 */
function upgradeDb(_dbVersion, _currentVer, _func){
//	do_nf.toast("正在升级数据，请稍候...");
	
	if(_dbVersion == 0){
		initDb(_func);
	} else {
		if(_dbVersion < 34){
			//触发显示升级数据提示视图的事件
			do_page.fire("showUpgrateProgNotify", 0);
			// 迁移数据库
			migrateDb(function(){
				// 打开应用数据库之后加载用户信息
				loadUserInfo();
				//处理数据库升级（18）
				if(_dbVersion < 18){
					handleUpgradeDb18();
				}
				//处理数据库升级（19）
				if(_dbVersion < 19){
					handleUpgradeDb19();
				}
				//处理数据库升级（20）
				if(_dbVersion < 20){
					handleUpgradeDb20();
				}
				//处理数据库升级（21）
				if(_dbVersion < 21){
					handleUpgradeDb21();
				}
				//处理数据库升级（22）
				if(_dbVersion < 22){
					handleUpgradeDb22();
				} else {
					// 升级数据库（23）
					upgradeDb23(_dbVersion, _func);
					return;
				}
			});
		} else {
			logTools.printLog(Tag, "upgradeDb " + _dbVersion);
			if(_dbVersion < _currentVer){
				//触发显示升级数据提示视图的事件
				do_page.fire("showUpgrateProgNotify", 1);
				// 打开应用和信息库数据库
				openAppAndPipsDb();
				// 打开应用数据库之后加载用户信息
				loadUserInfo();
				
				upgradeDb35(_dbVersion, _func);
			} else {
				_func.call(this);
			}
		}
	}
}

/**
 * 检测机器码和用户标识
 * @returns
 */
function checkMachineAndUserId(_callFunc){
	var _isExist = true;
	// 若机器码id不存在，则生成机器码、进程及uid标识
	if(!do_dataCache.hasData("machineId")){
		_isExist = false;
		//生成机器码id（主要利用uuid来模拟生成）
		var _machineId = uuid.getUUID();
		do_dataCache.saveData("machineId", _machineId);
		//生成进程id（主要利用uuid来模拟生成）
		var _processId = uuid.getUUID();
		if(!do_dataCache.hasData("processId")){
			do_dataCache.saveData("processId", _processId);
		}
		//生成用户id（主要利用uuid来模拟生成）
		var _uId = uuid.getUUID();
		if(!do_dataCache.hasData("uId")){
			do_dataCache.saveData("uId", _uId);
		}
		//保存是否同步到手机通讯录标识
		do_dataCache.saveData("sys");
		do_dataCache.saveData("syscontact");
		//获取首次获取联系人权限标识
		do_dataCache.saveData("contactPermReq");
		//保存已选择的时间卡片类型
		do_dataCache.saveData(globalConst.dataCacheKey.curTfShowCardType, 
				"0,1,3,4,5");
	}
	logTools.printLog(Tag, "u " + do_dataCache.loadData("uId"));
	logTools.printLog(Tag, "m " + do_dataCache.loadData("machineId"));
	// 若不存在，则说明应用被卸载或在系统设置里面清除数据缓存，需要删除本地数据；
	// 否则，直接返回
	if(!_isExist){
		// 关闭应用和信息库
		closeAppAndPipsDb();
		// 删除整个数据（data）目录
		do_storage.deleteDir("data://", function(_result){
			_callFunc.call(this);
		});
	} else {
		_callFunc.call(this);
	}
}

/**
 * 检测数据库版本并升级数据库
 * @param _currentVer
 * @param _func
 * @returns
 */
function checkDbVersion(_currentVer, _func){
	logTools.printLog(Tag, "checkDbVersion " + _currentVer);
	// 检测机器码和用户标识
	checkMachineAndUserId(function(){
		// 数据库版本，默认值为0（数据库版本标识）
		var _dbVersion = 0;
		// 版本文件
		var dbVerPath = "data://db/dbVer";
		// 判断存放数据库文件路径的文件是否存在
		// 若存在，则读取文件内容（数据库版本标识），
		// 并执行数据库升级逻辑
		// 否则，直接执行数据库升级逻辑
		if (do_storage.fileExist(dbVerPath)){
			do_storage.readFile(dbVerPath, function(data, e) {
				_dbVersion = parseInt(data);
				logTools.printLog(Tag, "dbVersion " + _dbVersion);
				if (_dbVersion < _currentVer){
					upgradeDb(_dbVersion, _currentVer, function(){
						//记录版本号
						do_storage.writeFile(dbVerPath, _currentVer);
						do_dataCache.removeData(migrateDbStateKey);
						//触发隐藏升级数据进度提示视图的事件
						do_page.fire("hideUpgrateProgNotify");
						// 回调函数
						_func.call(this);
					});
				} else {
					// 打开应用和信息库数据库
					openAppAndPipsDb();
					// 打开应用数据库之后加载用户信息
					loadUserInfo();
					
					_func.call(this);
				}
			});
		} else {
			if (_dbVersion < _currentVer){
				upgradeDb(_dbVersion, _currentVer, function(){
					//记录版本号
					do_storage.writeFile(dbVerPath, _currentVer);
					// 回调函数
					_func.call(this);
				});
			} else {
				// 打开应用和信息库数据库
				openAppAndPipsDb();
				// 打开应用数据库之后加载用户信息
				loadUserInfo();
				
				_func.call(this);
			}
		}
	});
}

/**
 * 检测数据库版本
 */
module.exports.checkDbVersion = function(_currentVer, _func){
	checkDbVersion(_currentVer, _func)
};
