/**
 * 电子名片
 * 
 * @Author : Cydow
 * @Timestamp : 2017-08-21
 */
//引入组件库
var deviceone = require("deviceone");

var tools = require("tools");            //工具
var constants = require("constants");    //常量

//数据库
var localdb = deviceone.mm("M0026_sqlite", "localdb", "app");

/**
 * 向channel_cydow_rcvrecord表中插入一条数据
 * @param _changedData
 */
function insert_msgRcvRecordData(_changedData){
	var _nowTime = new Date();
	if (_changedData.channel == null){
		_changedData.channel = "";
	}
	if (_changedData.lastmsgid == null){
		_changedData.lastmsgid = "1";
	}
	if(_changedData.receivetime == null){
		_changedData.receivetime = _nowTime.getTime();
	}
	if(_changedData.createtime == null){
		_changedData.createtime  = _nowTime.getTime();
	}
	if(_changedData.updatetime == null){
		_changedData.updatetime  = _nowTime.getTime();
	}
	var _sql_insert = "insert into channel_cydow_rcvrecord(channel, lastmsgid," +
			" receivetime, createtime, updatetime)values("
		+ tools.formatSqlValue(_changedData.channel) + ","
		+ tools.formatSqlValue(_changedData.lastmsgid) + ","
		+ _changedData.receivetime + ","
		+ _changedData.createtime + ","
		+ _changedData.updatetime + ");";
	var isSuccess = localdb.executeSync(_sql_insert);
	if(isSuccess){
	}
	return isSuccess;
}

//向channel_cydow_rcvrecord表中插入一条数据
module.exports.insert_msgRcvRecordData = function(_changedData){
	return insert_msgRcvRecordData(_changedData);	
};

/**
 * 更新channel_cydow_rcvrecord表中的数据
 * @param _changedData
 */
function update_msgRcvStateData(_changedData){
	var _nowTime = new Date();
	_changedData.updatetime = _nowTime.getTime();
	_changedData.receivetime = _nowTime.getTime();
	var _setList="";
	if (_changedData.lastmsgid != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "lastmsgid=" + tools.formatSqlValue(_changedData.lastmsgid);
	}
	if (_changedData.receivetime!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "receivetime=" + _changedData.receivetime;
	}
	if (_changedData.updatetime!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "updatetime=" + _changedData.updatetime;
	}
	if (_setList.length <= 0) return;
	var _sql_update = "update channel_cydow_rcvrecord set " + _setList + " where channel="
		+ tools.formatSqlValue(_changedData.channel) + ";";
	var isSuccess = localdb.executeSync(_sql_update);
	if(isSuccess){
	}
	return isSuccess;
}

//更新消息接收状态数据
module.exports.update_msgRcvStateData = function(_changedData){
	return update_msgRcvStateData(_changedData);	
};

/**
 * 查询指定渠道（channel）下数据
 * @param _id
 * @returns
 */
function query_msgRcvStateDataByChannel(_channel){
	var sql = "select * from channel_cydow_rcvrecord where channel="
		+ tools.formatSqlValue(_channel) + ";";
	var _data = localdb.querySync(sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data[0];
}

//查询指定渠道（channel）下数据
module.exports.query_msgRcvStateDataByChannel = function(_channel){
	return query_msgRcvStateDataByChannel(_channel);
};
