/**
 * 待办事宜
 * 
 * @Author : Cydow
 * @Timestamp : 2017-02-22
 */
//引入组件库
var deviceone = require("deviceone");
var do_storage = sm("do_Storage");
var do_global = sm("do_Global");

var objectId = require("objectId");      //生成objectId
var calendar = require("calendar");      //日期
var tools = require("tools");            //工具
var constants = require("constants");    //常量
var dbcycle = require("dbcycle");        //周期
var dbclsyncdata = require("dbclsyncdata");  //数据同步-云端
var dbcleardata = require("dbcleardata"); // 数据清理
var dbcommumain = require("dbcommumain.ui"); // 数据库操作-沟通
var notificationTools = require("notificationTools"); //设置提醒
var widgetTools = require("widgetTools.ui"); // 小部件工具
var jsonTools = require("jsonTools");//json工具
// 标记颜色类型常量
var colorconstants = require("source://view/timeFlow/script/colorconstants.ui");
//标记颜色类型常量
var cycleTypeTools = require("source://view/timeFlow/script/cycleTypeTools.ui");

// js文件路径管理
var jsPathManager = require("jsPathManager.ui");
//全局常量
var globalConst = require(jsPathManager.getGlobalConstPath());
//信息库-数据同步
var dbexpsyncdata = require(jsPathManager.getExpSyncDBPath());

//数据库
var localdb = deviceone.mm("M0026_sqlite", "localdb", "app");

//信息类型
var infoCategoryTask = constants.getConstants("infoCategory_task");

//业务模块ID
var moduleId = constants.getConstants("moduleType_timeflow");

var colors = {
		colors_uncompleted: colorconstants.colorConstants["card_green"],
		colors_completed: colorconstants.colorConstants["card_grey"]
}

/**
 * 获取新建待办的sql语句
 * @param _changedData
 * @returns
 */
function getInsertTaskDataSql(_changedData){
	var _nowTime = new Date();
	// 默认为不重复（非周期）待办
	var _cycleId = cycleTypeTools.cycleIdConstants["nocycle"];
	if (_changedData.id == null){
		_changedData.id = objectId.getObjectId();
	}
	if (_changedData.tripname == null){
		_changedData.tripname = "";
	}
	if(_changedData.starttimetype == null){
		_changedData.starttimetype = globalConst.timeShowType.all;
	}
	if(_changedData.endtimetype == null){
		_changedData.endtimetype = globalConst.timeShowType.all;
	}
	if (_changedData.canged == null){
		_changedData.canged = "0";
	}
	if (_changedData.createby == null){
		_changedData.createby = "";
	}
	if(_changedData.cycle != null &&
			null != _changedData.cycle.cycleid){
		_cycleId = parseInt(_changedData.cycle.cycleid);
	}
	if(_changedData.cyclerecordid == null){
		_changedData.cyclerecordid = "";
	}
	if(_changedData.endremindtime == null){
		_changedData.endremindtime = -1; //默认结束不提醒
	}
	if(_changedData.source == null){
		_changedData.source = constants.getConstants("dataSource_create");
	}
	if(_changedData.completed == null){
		_changedData.completed = constants.getConstants("taskCard_uncompleted");
	}
	if(_changedData.deleted == null){
		_changedData.deleted = 0;
	}
	if(_changedData.origin == null){
		_changedData.origin = "";
	}
	if(_changedData.presrc == null){
		_changedData.presrc = "";
	}
	if(_changedData.colors == null){
		_changedData.colors = jsonTools.jsonObjToStr(colors);
	}
	if(_changedData.morefields == null){
		_changedData.morefields  = "";
	}
	if(_changedData.create_time == null){
		_changedData.create_time  = _nowTime.getTime();
	}
	if(_changedData.update_time == null){
		_changedData.update_time = _nowTime.getTime();
	}
	_changedData.sync_count = tools.getSyncSequence();
	_changedData.notifyid = tools.getNotifyId();
	_changedData.endnotifyid = tools.getNotifyId();
	var _sql_insert = "insert into mytask(id, infoid, title, tripname, type, " +
			"start, starttimetype, end, endtimetype, createby, destpersonname, " +
			"connectby, connectphone, remindtime, endremindtime, location, comment, canged, " +
			"cycleid, cyclerecordid, infocategory, create_time, " +
			"update_time, sync_count, notifyid, endnotifyid, source, completed, " +
			"colors, deleted, origin, presrc, morefields) values("
		+ tools.formatSqlValue(_changedData.id) + ","
		+ tools.formatSqlValue(_changedData.infoid) + ","
		+ tools.formatSqlValue(_changedData.title) + ","
		+ tools.formatSqlValue(_changedData.tripname) + ","
		+ tools.formatSqlValue(_changedData.type) + ","
		+ _changedData.start + ","
		+ _changedData.starttimetype + ","
		+ _changedData.end + ","
		+ _changedData.endtimetype + ","
		+ tools.formatSqlValue(_changedData.createby) + ","
		+ tools.formatSqlValue(_changedData.destpersonname) + ","
		+ tools.formatSqlValue(_changedData.connectby) + ","
		+ tools.formatSqlValue(_changedData.connectphone) + ","
		+ _changedData.remindtime + ","
		+ _changedData.endremindtime + ","
		+ tools.formatSqlValue(_changedData.location) + ","
		+ tools.formatSqlValue(_changedData.comment) + ","
		+ tools.formatSqlValue(_changedData.canged) + ","
		+ _cycleId + ","
		+ tools.formatSqlValue(_changedData.cyclerecordid) + ","
		+ infoCategoryTask + ","
		+ _changedData.create_time + ","
		+ _changedData.update_time + ","
		+ _changedData.sync_count + ","
		+ _changedData.notifyid + ","
		+ _changedData.endnotifyid + ","
		+ tools.formatSqlValue(_changedData.source) + ","
		+ tools.formatSqlValue(_changedData.completed) + ","
		+ tools.formatSqlValue(_changedData.colors) + ","
		+ _changedData.deleted + ","
		+ tools.formatSqlValue(_changedData.origin) + ","
		+ tools.formatSqlValue(_changedData.presrc) + ","
		+ tools.formatSqlValue(_changedData.morefields) + ");";
	return _sql_insert;
}

/**
 * 插入一条待办数据
 * @param _changedData
 * @param _isRecord
 * @returns
 */
function insert_mytaskData(_changedData, _isRecord){
	if(null == _changedData.infoid){
		_changedData.infoid = _changedData.id;
	}
	var _sql_insert = getInsertTaskDataSql(_changedData);
	var isSuccess = localdb.executeSync(_sql_insert);
	if(isSuccess){
		// 未完成的待办设置本地提醒
		if(_changedData.completed == constants.getConstants("taskCard_uncompleted")){
			//设置本地提醒
//			notificationTools.setTaskNotification(_changedData, true, "add");
			//设置待办结束时间提醒
			notificationTools.setTaskEndTimeNotif(_changedData);
			//触发设置待办开始时间提醒的时间
			do_global.fire("setSysCalendarNotify", {
				param: _changedData,
				type: "add"
			});
		}
		
		if(_isRecord){
			// 更新记录
			var _updRecord = {
					id: _changedData.id,
					moduleid: moduleId,
					recordtype: constants.getConstants("recordType_create"), 
					datatype: constants.getConstants("datatype_timecard")
				};
			// 设置更新记录-未同步
			dbclsyncdata.setUpdRecordUnHandle(_updRecord);
		}
	}
	return isSuccess;
}

/**
 * 插入周期性数据到mytask表中
 * （根据周期类型采用不同生成的规则，创建待办卡片）
 * @param _changedData
 * @param _cycleRecord
 */
function insert_mytaskOneCycleTypeData(_changedData, _cycleRecord){
	var _cycleid = parseInt(_cycleRecord.cycleid);
	var _count = parseInt(_cycleRecord.count);
	var _date = new Date();
	var _cycleEndTime = parseInt(_cycleRecord.endtime);
	var _customTypeId = parseInt(_cycleRecord.type);
	if(0 != _cycleEndTime){
		_date.setTime(_cycleEndTime);
		_date.setHours(23, 59, 59, 999);
		_cycleEndTime = _date.getTime();
		_date = new Date(); 
	}
	var _nowTime = _date.getTime();
	var _lengthTime = 0;
	var _startTime = parseInt(_changedData.start);
	var _endTime = parseInt(_changedData.end);
	var _timeValue = _endTime - _startTime;
	// 若开始时间大于当前时间，则计算截止时间从开始时间开始；否则从当前时间开始
	if(_startTime > _nowTime){
		_lengthTime = calendar.getLengthTimeValue(_startTime, _cycleid, _customTypeId);
	} else {
		_lengthTime = calendar.getLengthTimeValue(_nowTime, _cycleid, _customTypeId);
	}
	// 若计算截止时间为大于重复截止时间，则计算截止时间等于重复截止时间；否则不变
	if(0 != _cycleEndTime && _lengthTime > _cycleEndTime){
		_lengthTime = _cycleEndTime;
	}
	var _updTime = parseInt(_cycleRecord.updtime);
	if(_updTime < _cycleRecord.starttime){
		_updTime = parseInt(_cycleRecord.starttime);
	}
	var _oldUpTime = _updTime;
	var _week = _cycleRecord.week;
	var _weekDay = 0;
	var _weekDayTmp = _weekDay;
	// 根据周期（重复）类型执行对应的重复时间计算方法;
	// 工作日和每周几
	if(cycleTypeTools.cycleIdConstants["workday"] == _cycleid ||
			cycleTypeTools.cycleIdConstants["weekday"] == _cycleid){
		if(null == _cycleRecord.weekday || "" == _cycleRecord.weekday){
			_date.setTime(_startTime);
			_weekDay = _date.getDay();
			if(_weekDay == 0){
				_weekDay = 7;
			}
		} else {
			_weekDay = _cycleRecord.weekday;
		}
		_weekDayTmp = _weekDay;
		var _timeData = calendar.getCycleTimeOfWeek({
			updtime: _updTime,
			cycleid: _cycleid,
			week: _week,
			weekday: _weekDay
		});
		_weekDay = _timeData.weekday;
		_updTime = _timeData.updtime;
	} else {
		// 自定义
		if(cycleTypeTools.cycleIdConstants["custom"] == _cycleid){
			_cycleRecord.updtime = _updTime;
			_updTime = calendar.getCycleTimeOfCustom(_cycleRecord);
		} else { // 其他重复（周期）类型
			_updTime = calendar.getCycleTime(_startTime, _updTime, _cycleid);
		}
	}
	// 若计算出来下一张卡片的开始时间一样的话，则直接返回
	if(_oldUpTime == _updTime){
		return true;
	}
	while(_updTime <= _lengthTime){
		_endTime = _updTime + _timeValue;
		insert_mytaskData({
			id: tools.createTaskId(_cycleRecord.taskid, ++_count),
			infoid: _cycleRecord.taskid,
			title: _changedData.title,
			type: _changedData.type,
			start: _updTime,
			starttimetype: _changedData.starttimetype,
			end: _endTime,
			endtimetype: _changedData.endtimetype,
			createby: _changedData.createby,
			destpersonname: _changedData.destpersonname,
			connectby: _changedData.connectby,
			connectphone: _changedData.connectphone,
			remindtime: _changedData.remindtime,
			endremindtime: _changedData.endremindtime,
			location: _changedData.location,
			comment: _changedData.comment,
			canged: _changedData.canged,
			cycle: {
				cycleid: _cycleid,
			},
			cyclerecordid: _cycleRecord.id,
			source: _changedData.source,
			colors: _changedData.colors,
			morefields: _changedData.morefields,
			create_time: _changedData.create_time,
			update_time: _changedData.update_time
		}, false);
		_oldUpTime = _updTime;
		_weekDayTmp = _weekDay;
		// 根据周期（重复）类型执行对应的重复时间计算方法;
		// 工作日和每周几
		if(cycleTypeTools.cycleIdConstants["workday"] == _cycleid ||
				cycleTypeTools.cycleIdConstants["weekday"] == _cycleid){
			var _timeData = calendar.getCycleTimeOfWeek({
				updtime: _updTime,
				cycleid: _cycleid,
				week: _week,
				weekday: _weekDay
			});
			_weekDay = _timeData.weekday;
			_updTime = _timeData.updtime;
		} else {
			// 自定义
			if(cycleTypeTools.cycleIdConstants["custom"] == _cycleid){
				_cycleRecord.updtime = _updTime;
				_updTime = calendar.getCycleTimeOfCustom(_cycleRecord);
			} else { // 其他重复（周期）类型
				_updTime = calendar.getCycleTime(_startTime, _updTime, _cycleid);
			}
		}
	}
	
	var _cycleRecordData = {
			id: _cycleRecord.id,
			updtime: _oldUpTime,
			weekday: _weekDayTmp,
			count: _count
		};
	//更新周期记录表指定id的数据
	dbcycle.update_cycleRecordData(_cycleRecordData);
	return true;
}

//插入周期性数据到mytask表中（同一类型周期待办增量生成副本）
module.exports.insert_mytaskOneCycleType = function(_changedData, _cycleRecord){
	insert_mytaskOneCycleTypeData(_changedData, _cycleRecord);
	
	// 刷新视图（桌面小部件）
	widgetTools.refresh();
};

/**
 * 插入周期性源数据到mytask表中
 * （插入周期源数据并生成同一类型周期从当前时间到未来1年内的所有待办）
 * @param _changedData
 */
function insert_mytaskCycleSourceData(_changedData){
	if(null == _changedData.id || "" == _changedData.id){
		_changedData.id = objectId.getObjectId();
	}
	if(null == _changedData.source || "" == _changedData.source){
		_changedData.source = "0";
	}
	var _cycleRecordId = objectId.getObjectId();
	var _taskData = {
			id: _changedData.id,
			infoid: _changedData.id,
			title: _changedData.title,
			type: _changedData.type,
			start: _changedData.start,
			starttimetype: _changedData.starttimetype,
			end: _changedData.end,
			endtimetype: _changedData.endtimetype,
			createby: _changedData.createby,
			destpersonname: _changedData.destpersonname,
			connectby: _changedData.connectby,
			connectphone: _changedData.connectphone,
			remindtime: _changedData.remindtime,
			endremindtime: _changedData.endremindtime,
			location: _changedData.location,
			comment: _changedData.comment,
			canged: _changedData.canged,
			cycle: _changedData.cycle,
			cyclerecordid: _cycleRecordId,
			source: _changedData.source,
			completed: _changedData.completed,
			colors: _changedData.colors,
			origin: _changedData.origin,
			presrc: _changedData.presrc,
			morefields: _changedData.morefields,
			create_time: _changedData.create_time,
			update_time: _changedData.update_time
		};
	// 插入待办数据
	insert_mytaskData(_taskData, true);
	// 重复（周期）数据
	var _cycleData = _changedData.cycle;
	//周期性记录表增加一条记录
	var _cycleRecordData = {
			id: _cycleRecordId,
			taskid: _changedData.id,
			starttime: _changedData.start,
			updtime: _changedData.start,
			cycleid: _cycleData.cycleid,
			type: _cycleData.cycletype.type,
			frequency: _cycleData.cycletype.frequency,
			selection: _cycleData.cycletype.selection,
			week: _cycleData.week,
			endtime: _cycleData.cycleendtime,
			count: 0,
			infocategory: infoCategoryTask
		};
	dbcycle.insert_cycleRecordData(_cycleRecordData);
	
	//生成周期性待办数据
	return insert_mytaskOneCycleTypeData(_taskData, _cycleRecordData);
}

/**
 * 新建待办数据（包括非周期性 和 周期性待办）
 * 
 * @param _changedData
 * @returns
 */
function insert_mytaskCycleSource(_changedData){
	// 若重复（周期）数据不为空且重复（周期）标识也不为空，
	// 则根据重复（周期）类型创建待办；否则直接创建不重复（非周期）待办
	if(null != _changedData.cycle && 
			null != _changedData.cycle.cycleid){
		var _cycleId = parseInt(_changedData.cycle.cycleid);
		// 若重复（周期）标识为不重复（非周期），则新建不重复（非周期）待办
		if(cycleTypeTools.cycleIdConstants["nocycle"] == _cycleId){
			return insert_mytaskData(_changedData, true);
		} else {
			return insert_mytaskCycleSourceData(_changedData);
		}
	} else {
		return insert_mytaskData(_changedData, true);
	}
};

//插入一条待办数据
module.exports.insert_mytask = function(_changedData){
	var _isSuccess = insert_mytaskCycleSource(_changedData);
	// 刷新视图（桌面小部件）
	widgetTools.refresh();
	return _isSuccess;
};

/**
 * 获取更新待办数据的语句
 * @param _changedData
 * @returns
 */
function getUpdTaskDataSql(_changedData){
	var _nowTime = new Date();
	_changedData.sync_count = tools.getSyncSequence();
	var _setList="";
	if (_changedData.title != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "title=" + tools.formatSqlValue(_changedData.title);
	}
//	if (_changedData.tripname!=null){
//		if (_setList.length > 0) _setList+=",";
//		_setList += "tripname=" + tools.formatSqlValue(_changedData.tripname);
//	}
	if (_changedData.type != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "type=" + tools.formatSqlValue(_changedData.type);
	}
	if (_changedData.start != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "start=" + _changedData.start;
	}
	if (_changedData.starttimetype != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "starttimetype=" + _changedData.starttimetype;
	}
	if (_changedData.end != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "end=" + _changedData.end;
	}
	if (_changedData.endtimetype != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "endtimetype=" + _changedData.endtimetype;
	}
	if (_changedData.createby != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "createby=" + tools.formatSqlValue(_changedData.createby);
	}
	if (_changedData.destpersonname != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "destpersonname=" + tools.formatSqlValue(_changedData.destpersonname);
	}
	if (_changedData.connectby != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "connectby=" + tools.formatSqlValue(_changedData.connectby);
	}
	if (_changedData.connectphone != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "connectphone=" + tools.formatSqlValue(_changedData.connectphone);
	}
	if (_changedData.remindtime != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "remindtime=" + _changedData.remindtime;
	}
	if(_changedData.endremindtime != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "endremindtime=" + _changedData.endremindtime;
	}
	if (_changedData.location != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "location=" + tools.formatSqlValue(_changedData.location);
	}
	if (_changedData.comment != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "comment=" + tools.formatSqlValue(_changedData.comment);
	}
	if (_changedData.canged != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "canged=" + tools.formatSqlValue(_changedData.canged);
	}
	if (_changedData.cycle != null &&
			_changedData.cycle.cycleid != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "cycleid=" + _changedData.cycle.cycleid;
	}
	if (_changedData.cyclerecordid != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "cyclerecordid=" + tools.formatSqlValue(_changedData.cyclerecordid);
	}
	if (_changedData.source != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "source=" + tools.formatSqlValue(_changedData.source);
	}
	if (_changedData.completed != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "completed=" + tools.formatSqlValue(_changedData.completed);
	}
	if (_changedData.colors != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "colors=" + tools.formatSqlValue(_changedData.colors);
	}
	if (_changedData.origin != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "origin=" + tools.formatSqlValue(_changedData.origin);
	}
	if (_changedData.presrc != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "presrc=" + tools.formatSqlValue(_changedData.presrc);
	}
	if (_changedData.update_time != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "update_time=" + _changedData.update_time;
	}
	if (_changedData.sync_count != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "sync_count=" + _changedData.sync_count;
	}
	if (_changedData.deleted != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "deleted=" + _changedData.deleted;
	}
	if (_changedData.morefields != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "morefields=" + tools.formatSqlValue(_changedData.morefields);
	}
	if(null == _changedData.endnotifyid){
		_changedData.endnotifyid = tools.getNotifyId();
		if (_setList.length > 0) _setList+=",";
		_setList += "endnotifyid=" + _changedData.endnotifyid;
	}
	return _setList;
}

/**
 * 更新待办数据数据
 * @param _changedData
 * @param _isRecord
 * @param _isSync
 * @returns
 */
function update_mytaskData(_changedData, _isRecord, _isSync){
	var _setList = getUpdTaskDataSql(_changedData);
	if (_setList.length <= 0) return;
	var _sql_update = "update mytask set " + _setList + " where id="
		+ tools.formatSqlValue(_changedData.id) + ";";
	var isSuccess = localdb.executeSync(_sql_update);
	if(isSuccess){
		// 若待办未完成，则设置本地提醒；否则，移除本地提醒
		if(_changedData.completed == constants.getConstants("taskCard_uncompleted")){
			//设置本地提醒
//			notificationTools.setTaskNotification(_changedData, true, "update");
			//设置待办结束时间提醒
			notificationTools.setTaskEndTimeNotif(_changedData);
			//触发设置开始时间提醒的时间
			do_global.fire("setSysCalendarNotify", {
				param: _changedData,
				isUpd: true,
				type: "update"
			});
		} else {
			//删除待办结束时间提醒
			notificationTools.delTimeFlowNotify([parseInt(_changedData.endnotifyid)]);
			// 移除本地提醒
			notificationTools.removeLocalNotification([_changedData.notifyid], 
					[_changedData.id]);
		}

		if(_isRecord){
			// 更新记录
			var _updRecord = {
					id: _changedData.id,
					moduleid: moduleId,
					recordtype: constants.getConstants("recordType_update"), 
					datatype: constants.getConstants("datatype_timecard")
				};
			// 设置更新记录
			if(_isSync){
				dbclsyncdata.setUpdRecordUnHandle(_updRecord);
			} else {
				dbclsyncdata.setUpdRecord(_updRecord);
			}
		}
	}
	return isSuccess;
}

/**
 * 比较开始时间
 *     若相等，返回true；否则，返回false
 * @param _time1
 * @param _time2
 * @returns
 */
function compareStartTime(_time1, _time2){
	var _nowTime = new Date();
	_nowTime.setTime(_time1);
	_nowTime.setSeconds(0, 0);
	var _timeTmp1 = _nowTime.getTime();
	_nowTime.setTime(_time2);
	_nowTime.setSeconds(0, 0);
	var _timeTmp2 = _nowTime.getTime();
	if(_timeTmp1 == _timeTmp2){
		return true;
	}
	return false;
}

/**
 * 根据id获取计数值
 * @param _id
 * @returns
 */
function getUpdCountById(_id){
	var _updCount = 0;
	if(null != _id && 
			"" != _id &&
			_id.length > 24){
		var _updCountTmp = _id.substring(24, _id.length);
		if("" != _updCountTmp){
			_updCount = parseInt(_updCountTmp);
		}
	}
	return _updCount;
}

/**
 * 更新周期性待办数据（同一类型周期的所有待办都更新）
 * @param _changedData
 * @param _cycleRecord
 * @param _isCycle
 * @param _isSync
 * @param _isRecord
 * @returns
 */
function update_mytaskCycleTypeData(_changedData, _cycleRecord, _isCycle, _isSync, _isRecord){
	// 待办完成状态（默认为“未完成”）
	var _completed = constants.getConstants("taskCard_uncompleted");
	//获取更新前的数据
	var _oldData = get_mytaskOneData(_changedData.id);
	// 判断之前是否为周期待办
	if(_isCycle){
		//获取周期性待办的主卡源数据
		var _oldSourceData = get_mytaskOneData(_cycleRecord.taskid);
		// 修改后开始时间与结束时间之间的差值
		var _timeLengthValue = parseInt(_changedData.end) - parseInt(_changedData.start);
		// 周期的起始时间，默认是待办主卡的开始时间
		var _startTimeValue = parseInt(_oldSourceData.start);
		// 重复类型标识
		var _cycleid = parseInt(_changedData.cycle.cycleid);
		// 每周几
		var _week = _changedData.cycle.week;
		// 截止日期
		var _cycleEndTime = parseInt(_changedData.cycle.cycleendtime);
		// 自定义类型
		var _customTypeId = parseInt(_changedData.cycle.cycletype.type);
		// 自定义类型
		var _frequency = parseInt(_changedData.cycle.cycletype.frequency);
		// 自定义类型
		var _selection = _changedData.cycle.cycletype.selection;
		
		var _isChanged = false;
		// 判断待办重复类型是否改变
		if(_cycleid != _oldData.cycleid){
			_isChanged = true;
		} else {
			// 每周几
			if(cycleTypeTools.cycleIdConstants["weekday"] == _cycleid){
				if(_week != _cycleRecord.week){
					_isChanged = true;
				}
			} else {
				 // 自定义
				if(cycleTypeTools.cycleIdConstants["custom"] == _cycleid){
					if(_customTypeId != parseInt(_cycleRecord.type) ||
							_frequency != parseInt(_cycleRecord.frequency) ||
							_selection != _cycleRecord.selection){
						_isChanged = true;
					}
				}
			}
		}
		// 判断开始时间是否改变，若改变的话，主卡的开始时间需要调整为新的；
		// 否则默认为之前的
		if(!compareStartTime(_changedData.start, _oldData.start)){
			_isChanged = true;
			// 修改后的开始时间
			_startTimeValue = parseInt(_changedData.start);
		}
		// 若为待办改为不重复，则删除周期性待办副卡信息；
		// 否则修改所有周期性待办卡片的信息
		if(1 == _cycleid){
			// 删除周期性待办副卡片数据（除过源数据）
			delCycleTaskUnMainCardData(_cycleRecord.taskid,
					_cycleRecord.id);
			
			//删除周期记录
			dbcycle.delete_cyclerecordDataById(_cycleRecord.id);
			
			_changedData.id = _cycleRecord.taskid;
			_changedData.start = _startTimeValue;
			_changedData.end = _startTimeValue + _timeLengthValue;
			_changedData.cyclerecordid = "";
			_changedData.notifyid = _oldSourceData.notifyid;
			_changedData.endnotifyid = _oldSourceData.endnotifyid;
			_changedData.completed = _completed;
			// 更新周期性待办主卡信息
			return update_mytaskData(_changedData, _isRecord, _isSync);
		} else {
			// 若待办的开始时间或重复类型或开始时间显示类型改变，
			// 则修改完成状态
			if(_isChanged ||
					_changedData.starttimetype != _oldData.starttimetype){
				if(_oldData.completed == _changedData.completed){
					_oldData.completed = _completed;
				} else {
					// 设置待办完成状态
					_oldData.completed = _changedData.completed;
				}
			} else {
				// 设置待办完成状态
				_oldData.completed = _changedData.completed;
			}
			// 若待办的开始时间或重复类型改变，
			// 则周期的起始时间为修改后待办的开始时间；否则，不做处理
			// 获取指定周期性待办的所有信息
			var _taskList = query_mytaskDataByCycleRecordId(_cycleRecord.id);
			var _date = new Date();
			if(null != _taskList && _taskList.length > 0){
				var _updTime = _startTimeValue;
				if(0 != _cycleEndTime){
					_date.setTime(_cycleEndTime);
					_date.setHours(23, 59, 59, 999);
					_cycleEndTime = _date.getTime();
				}
				var _isDelCycleTaskData = false;
				// 自定义周几（至周几）
				var _weekDay = _cycleRecord.weekday;
				if(_isChanged){
					_date.setTime(_startTimeValue);
					_weekDay = _date.getDay();
					if(_weekDay == 0){
						_weekDay = 7;
					}
				}
				// 周期卡片计数
				var _count = 0;
				// 遍历并更新所有周期性待办副卡信息（除过主卡），
				// 若某个待办副卡开始时间大于截止日期，则删除该副卡及之后的副卡信息
				for(var i=1; i<_taskList.length; i++){
					var _taskData = _taskList[i];
					if(null == _taskData) continue;
					if(_isDelCycleTaskData) {
						delOneTaskData(_taskData.id, false, false);
						continue;
					}
					_changedData.id = _taskData.id;
					_changedData.notifyid = _taskData.notifyid;
					_changedData.endnotifyid = _taskData.endnotifyid;
					if(_isChanged){
						var _updTimeTmp = 0;
						// 根据周期（重复）类型执行对应的重复时间计算方法;
						// 工作日和每周几
						if(cycleTypeTools.cycleIdConstants["workday"] == _cycleid ||
								cycleTypeTools.cycleIdConstants["weekday"] == _cycleid){
							var _timeData = calendar.getCycleTimeOfWeek({
								updtime: _updTime,
								cycleid: _cycleid,
								week: _week,
								weekday: _weekDay
							});
							_weekDay = _timeData.weekday;
							_updTimeTmp = _timeData.updtime;
						} else {
							// 自定义
							if(cycleTypeTools.cycleIdConstants["custom"] == _cycleid){
								_updTimeTmp = calendar.getCycleTimeOfCustom({
									type: _customTypeId,
									frequency: _frequency,
									selection: _selection,
									starttime: _startTimeValue,
									updtime: _updTime
								});
							} else { // 其他重复（周期）类型
								_updTimeTmp = calendar.getCycleTime(_startTimeValue, _updTime, _cycleid);
							}
						}
						_changedData.start = parseInt(_updTimeTmp);
						_changedData.end = parseInt(_updTimeTmp) + _timeLengthValue;
						_changedData.completed = _completed;
					} else {
						_changedData.start = parseInt(_taskData.start);
						_changedData.end = parseInt(_taskData.start) + _timeLengthValue;
						// 若为编辑的副卡，则完成状态为修改后的待办完成状态；
						// 否则，保持之前的完成状态不变
						if(_oldData.id == _taskData.id){
							_changedData.completed = _oldData.completed;
						} else {
							_changedData.completed = _taskData.completed;
						}
					}
					if(0 != _cycleEndTime && _changedData.start > _cycleEndTime){
						delOneTaskData(_changedData.id, false, false);
						_isDelCycleTaskData = true;
					} else {
						_count = getUpdCountById(_taskData.id);
						_updTime = parseInt(_changedData.start);
						update_mytaskData(_changedData, false, _isSync);
					}
				}
				_cycleRecord.starttime = _startTimeValue;
				_cycleRecord.updtime = _updTime;
				_cycleRecord.cycleid = _cycleid;
				_cycleRecord.type = _customTypeId;
				_cycleRecord.frequency = _frequency;
				_cycleRecord.selection = _selection;
				_cycleRecord.endtime = _cycleEndTime;
				_cycleRecord.count = _count;
				// 若周期（重复）类型是工作日、自定义周几，则更新week和weekday字段的值;
				// 否则week和weekday字段的值置空
				if(cycleTypeTools.cycleIdConstants["workday"] == _cycleid ||
						cycleTypeTools.cycleIdConstants["weekday"] == _cycleid){
					_date.setTime(_updTime);
					_weekDay = _date.getDay();
					if(0 == _weekDay){
						_weekDay = 7;
					}
					_cycleRecord.weekday = _weekDay;
					// 每周几
					if(cycleTypeTools.cycleIdConstants["weekday"] == _cycleid){
						_cycleRecord.week = _week;
					}
				} else {
					_cycleRecord.weekday = 0;
					_cycleRecord.week = "";
				}
				// 更新周期性记录表的指定的记录
				dbcycle.update_cycleRecordData(_cycleRecord);
			}
			// 设置待办主卡信息
			_changedData.id = _cycleRecord.taskid;
			_changedData.start = _startTimeValue;
			_changedData.end = _startTimeValue + _timeLengthValue;
			_changedData.notifyid = _oldSourceData.notifyid;
			_changedData.endnotifyid = _oldSourceData.endnotifyid;
			// 若待办开始时间或重复类型改变，则待办的完成状态改为“未完成”；
			// 否则，其他字段改变，若修改的是主卡信息，
			// 则修改主卡完成状态；否则，保持不变
			if(_isChanged){
				_changedData.completed = _oldData.completed;
			} else {
				if(_oldSourceData.id == _oldData.id){
					_changedData.completed = _oldData.completed;
				} else {
					_changedData.completed = _oldSourceData.completed;
				}
			}
			// 待办主卡片创建时间
			_changedData.create_time = _oldSourceData.create_time;
			// 检查并生成周期性待办的副卡
			insert_mytaskOneCycleTypeData(_changedData, _cycleRecord);
			// 更新周期性待办主卡信息，并添加更新记录
			return update_mytaskData(_changedData, _isRecord, _isSync);
		}
	} else {
		var _id = objectId.getObjectId();
		//插入一条数据到周期记录表中
		_cycleRecord = {
				id: _id,
				taskid: _changedData.id,
				starttime: _changedData.start,
				updtime: _changedData.start,
				endtime: _changedData.cycle.cycleendtime,
				cycleid: _changedData.cycle.cycleid,
				week: _changedData.cycle.week,
				type: _changedData.cycle.cycletype.type,
				frequency: _changedData.cycle.cycletype.frequency,
				selection: _changedData.cycle.cycletype.selection,
				count : 0,
				infocategory : infoCategoryTask
		};
		dbcycle.insert_cycleRecordData(_cycleRecord);
		_changedData.cyclerecordid = _id;
		// 待办主卡片的外来状态（保证副卡片外来状态和主卡片一致）
		_changedData.source = _oldData.source;
		// 待办主卡片创建时间
		_changedData.create_time = _oldData.create_time;
		//生成周期性待办
		insert_mytaskOneCycleTypeData(_changedData, _cycleRecord);
		// 待办完成状态改为“未完成”
		_changedData.completed = _completed;
		//待办结束时间提醒标识有可能为空，需要重新生成一个
		_changedData.endnotifyid = _oldData.endnotifyid;
		return update_mytaskData(_changedData, _isRecord, _isSync);
	}
}

/**
 * 更新待办数据（包括非周期性 和 周期性待办）
 * 
 * @param _changedData
 * @param _isSync
 * @param _isRecord
 * @returns
 */
function update_mytaskAllData(_changedData, _isSync, _isRecord){
	var _isSuccess = false;
	var _operType = 1;
	if(null != _changedData.cycle &&
			null != _changedData.cycle.cycleid){
		var _cycleId = _changedData.cycle.cycleid;
		// 若重复标识为不重复，则有可能原来就是不重复的待办，
		// 也有可能原来为重复待办改为不重复待办了，根据不同情况进行处理
		// 否则，认为是重复待办，进行相应的处理
		if(cycleTypeTools.cycleIdConstants["nocycle"] == _cycleId){
			// 若重复记录标识不为空，则认为原来就是一个重复待办
			if(_changedData.cyclerecordid != null 
					&& _changedData.cyclerecordid != ""){
				_operType = 3;
			}
		} else {
			// 若重复记录标识为空，则认为原来就是不重复待办改为重复待办；
			// 否则，认为原来就是重复待办
			if(_changedData.cyclerecordid == null 
					|| _changedData.cyclerecordid == ""){
				_operType = 2;
			} else {
				_operType = 3;
			}
		}
	}
	//若结束时间类型不全，则结束前提醒为“不提醒”
	if(_changedData.endtimetype != globalConst.timeShowType.all){
		_changedData["endremindtime"] = -1;	
	}
	// 根据操作类型执行对应的方法
	if(1 == _operType){
		// 获取更新前的数据
		var _oldData = get_mytaskOneData(_changedData.id);
		// 判断开始时间或开始时间类型是否改变，若改变，则完成状态变为未完成
		if((_changedData.starttimetype != _oldData.starttimetype ||
				!compareStartTime(_changedData.start, _oldData.start)) &&
				constants.getConstants("taskCard_completed") == _oldData.completed){
			_changedData.completed = constants.getConstants("taskCard_uncompleted");
		}
		if(null == _changedData.notifyid){
			_changedData["notifyid"] = _oldData.notifyid;
		}
		_changedData["endnotifyid"] = _oldData.endnotifyid;
		_isSuccess = update_mytaskData(_changedData, _isRecord, _isSync);	
	} else {
		if(2 == _operType){
			var _cycleData = {};
			_isSuccess = update_mytaskCycleTypeData(_changedData, 
					_cycleData, false, _isSync, _isRecord);
		} else {
			var _data = dbcycle.query_cycleRecordOneData(_changedData.cyclerecordid);
			if(_data != null){
				_isSuccess = update_mytaskCycleTypeData(_changedData, 
						_data, true, _isSync, _isRecord);
			}
		}
	}
	return _isSuccess
}

//更新待办数据
module.exports.update_mytask = function(_changedData){
	update_mytaskAllData(_changedData, true, true);
	// 刷新视图（桌面小部件）
	widgetTools.refresh();
};

//更新待办数据
module.exports.update_mytaskExpSync = function(_changedData, _record){
	var _result = update_mytaskAllData(_changedData, false, false);
	// 更新记录
	var _updRecord = {
			id: _changedData.id,
			moduleid: moduleId,
			recordtime: _record.recordtime,
			recordtype: constants.getConstants("recordType_update"), 
			datatype: constants.getConstants("datatype_timecard")
		};
	if(_record.handlestate){
		// 设置更新记录-已同步
		dbclsyncdata.setUpdRecord(_updRecord);
	} else {
		// 设置更新记录-未同步
		dbclsyncdata.setUpdRecordUnHandle(_updRecord);
	}
	return _result;
};

/**
 * 更新周期性待办数据（同一类型周期的所有待办都更新）
 * @param _changedData
 * @param _cycleRecord
 * @param _isCycle
 * @param _isSync
 * @returns
 */
function update_mytaskCycleTypeSyncData(_changedData, _cycleRecord, _isCycle, _isSync){
	// 待办完成状态（默认为“未完成”）
	var _completed = constants.getConstants("taskCard_uncompleted");
	// 卡片颜色
	var _colorData = _changedData.colors;
	// 完成状态
	var _compData = _changedData.completed;
	//获取更新前的数据
	var _oldData = get_mytaskOneData(_changedData.id);
	// 判断之前是否为周期待办
	if(_isCycle){
		//获取周期性待办的主卡源数据
		var _oldSourceData = get_mytaskOneData(_cycleRecord.taskid);
		// 修改后开始时间与结束时间之间的差值
		var _timeLengthValue = parseInt(_changedData.end) - parseInt(_changedData.start);
		// 周期的起始时间，默认是待办主卡的开始时间
		var _startTimeValue = parseInt(_oldSourceData.start);
		// 重复类型标识
		var _cycleid = parseInt(_changedData.cycle.cycleid);
		// 每周几
		var _week = _changedData.cycle.week;
		// 截止日期
		var _cycleEndTime = parseInt(_changedData.cycle.cycleendtime);
		// 自定义类型
		var _customTypeId = parseInt(_changedData.cycle.cycletype.type);
		// 自定义类型
		var _frequency = parseInt(_changedData.cycle.cycletype.frequency);
		// 自定义类型
		var _selection = _changedData.cycle.cycletype.selection;
		
		var _isChanged = false;
		// 判断待办重复类型是否改变
		if(_cycleid != _oldData.cycleid){
			_isChanged = true;
		} else {
			// 每周几
			if(cycleTypeTools.cycleIdConstants["weekday"] == _cycleid){
				if(_week != _cycleRecord.week){
					_isChanged = true;
				}
			} else {
				 // 自定义
				if(cycleTypeTools.cycleIdConstants["custom"] == _cycleid){
					if(_customTypeId != parseInt(_cycleRecord.type) ||
							_frequency != parseInt(_cycleRecord.frequency) ||
							_selection != _cycleRecord.selection){
						_isChanged = true;
					}
				}
			}
		}
		// 判断开始时间是否改变，若改变的话，主卡的开始时间需要调整为新的；
		// 否则默认为之前的
		if(!compareStartTime(_changedData.start, _oldData.start)){
			_isChanged = true;
			// 修改后的开始时间
			_startTimeValue = parseInt(_changedData.start);
		}
		// 若为待办改为不重复，则删除周期性待办副卡信息；
		// 否则修改所有周期性待办卡片的信息
		if(1 == _cycleid){
			// 删除周期性待办副卡片数据（除过源数据）
			delCycleTaskUnMainCardData(_cycleRecord.taskid,
					_cycleRecord.id);
			
			//删除周期记录
			dbcycle.delete_cyclerecordDataById(_cycleRecord.id);
			
			_changedData.id = _cycleRecord.taskid;
			_changedData.start = _startTimeValue;
			_changedData.end = _startTimeValue + _timeLengthValue;
			_changedData.cyclerecordid = "";
			_changedData.notifyid = _oldSourceData.notifyid;
			_changedData.endnotifyid = _oldSourceData.endnotifyid;
			_changedData.completed = _completed;
			if(null != _compData){
				_changedData.completed = getTaskCardCompleted(_changedData.id,
						_changedData.id, _compData);
			}
			if(null != _colorData){
				var _colors = getTaskCardColors(_changedData.id, 
						_changedData.id, _colorData);
				_changedData.colors = _colors;
			}
			// 更新周期性待办主卡信息
			return update_mytaskData(_changedData, true, _isSync);
		} else {
			// 获取指定周期性待办的所有信息
			var _taskList = query_mytaskDataByCycleRecordId(_cycleRecord.id);
			var _date = new Date();
			if(null != _taskList && _taskList.length > 0){
				var _updTime = _startTimeValue;
				if(0 != _cycleEndTime){
					_date.setTime(_cycleEndTime);
					_date.setHours(23, 59, 59, 999);
					_cycleEndTime = _date.getTime();
				}
				var _isDelCycleTaskData = false;
				// 自定义周几（至周几）
				var _weekDay = _cycleRecord.weekday;
				if(_isChanged){
					_date.setTime(_startTimeValue);
					_weekDay = _date.getDay();
					if(_weekDay == 0){
						_weekDay = 7;
					}
				}
				// 周期卡片计数
				var _count = 0;
				// 遍历并更新所有周期性待办副卡信息（除过主卡），
				// 若某个待办副卡开始时间大于截止日期，则删除该副卡及之后的副卡信息
				for(var i=1; i<_taskList.length; i++){
					var _taskData = _taskList[i];
					if(null == _taskData) continue;
					if(_isDelCycleTaskData) {
						delOneTaskData(_taskData.id, false, false);
						continue;
					}
					_changedData.id = _taskData.id;
					_changedData.notifyid = _taskData.notifyid;
					_changedData.endnotifyid = _taskData.endnotifyid;
					if(_isChanged){
						var _updTimeTmp = 0;
						// 根据周期（重复）类型执行对应的重复时间计算方法;
						// 工作日和每周几
						if(cycleTypeTools.cycleIdConstants["workday"] == _cycleid ||
								cycleTypeTools.cycleIdConstants["weekday"] == _cycleid){
							var _timeData = calendar.getCycleTimeOfWeek({
								updtime: _updTime,
								cycleid: _cycleid,
								week: _week,
								weekday: _weekDay
							});
							_weekDay = _timeData.weekday;
							_updTimeTmp = _timeData.updtime;
						} else {
							// 自定义
							if(cycleTypeTools.cycleIdConstants["custom"] == _cycleid){
								_updTimeTmp = calendar.getCycleTimeOfCustom({
									type: _customTypeId,
									frequency: _frequency,
									selection: _selection,
									starttime: _startTimeValue,
									updtime: _updTime
								});
							} else { // 其他重复（周期）类型
								_updTimeTmp = calendar.getCycleTime(_startTimeValue, _updTime, _cycleid);
							}
						}
						_changedData.start = parseInt(_updTimeTmp);
						_changedData.end = parseInt(_updTimeTmp) + _timeLengthValue;
					} else {
						_changedData.start = parseInt(_taskData.start);
						_changedData.end = parseInt(_taskData.start) + _timeLengthValue;
					}
					_changedData.completed = _completed;
					if(null != _compData){
						_changedData.completed = getTaskCardCompleted(_cycleRecord.taskid,
								_taskData.id, _compData);
					}
					if(null != _colorData){
						var _colors = getTaskCardColors(_cycleRecord.taskid, 
								_taskData.id, _colorData);
						_changedData.colors = _colors;
					}
					if(0 != _cycleEndTime && _changedData.start > _cycleEndTime){
						delOneTaskData(_changedData.id, false, false);
						_isDelCycleTaskData = true;
					} else {
						_count = getUpdCountById(_taskData.id);
						_updTime = parseInt(_changedData.start);
						update_mytaskData(_changedData, false, _isSync);
					}
				}
				_cycleRecord.starttime = _startTimeValue;
				_cycleRecord.updtime = _updTime;
				_cycleRecord.cycleid = _cycleid;
				_cycleRecord.type = _customTypeId;
				_cycleRecord.frequency = _frequency;
				_cycleRecord.selection = _selection;
				_cycleRecord.endtime = _cycleEndTime;
				_cycleRecord.count = _count;
				// 若周期（重复）类型是工作日、自定义周几，则更新week和weekday字段的值;
				// 否则week和weekday字段的值置空
				if(cycleTypeTools.cycleIdConstants["workday"] == _cycleid ||
						cycleTypeTools.cycleIdConstants["weekday"] == _cycleid){
					_date.setTime(_updTime);
					_weekDay = _date.getDay();
					if(0 == _weekDay){
						_weekDay = 7;
					}
					_cycleRecord.weekday = _weekDay;
					// 每周几
					if(cycleTypeTools.cycleIdConstants["weekday"] == _cycleid){
						_cycleRecord.week = _week;
					}
				} else {
					_cycleRecord.weekday = 0;
					_cycleRecord.week = "";
				}
				// 更新周期性记录表的指定的记录
				dbcycle.update_cycleRecordData(_cycleRecord);
			}
			// 设置待办主卡信息
			_changedData.id = _cycleRecord.taskid;
			_changedData.start = _startTimeValue;
			_changedData.end = _startTimeValue + _timeLengthValue;
			_changedData.notifyid = _oldSourceData.notifyid;
			_changedData.endnotifyid = _oldSourceData.endnotifyid;
			_changedData.completed = _compData;
			_changedData.colors = _colorData;
			// 待办主卡片创建时间
			_changedData.create_time = _oldSourceData.create_time;
			// 检查并生成周期性待办的副卡
			insertTaskCycleSyncData(_changedData, _cycleRecord);
			
			_changedData.completed = _completed;
			if(null != _compData){
				_changedData.completed = getTaskCardCompleted(_cycleRecord.taskid,
						_changedData.id, _compData);
			}
			if(null != _colorData){
				var _colors = getTaskCardColors(_cycleRecord.taskid, 
						_changedData.id, _colorData);
				_changedData.colors = _colors;
			}
			// 更新周期性待办主卡信息，并添加更新记录
			return update_mytaskData(_changedData, true, _isSync);
		}
	} else {
		var _id = objectId.getObjectId();
		//插入一条数据到周期记录表中
		_cycleRecord = {
				id: _id,
				taskid: _changedData.id,
				starttime: _changedData.start,
				updtime: _changedData.start,
				endtime: _changedData.cycle.cycleendtime,
				cycleid: _changedData.cycle.cycleid,
				week: _changedData.cycle.week,
				type: _changedData.cycle.cycletype.type,
				frequency: _changedData.cycle.cycletype.frequency,
				selection: _changedData.cycle.cycletype.selection,
				count : 0,
				infocategory : infoCategoryTask
		};
		dbcycle.insert_cycleRecordData(_cycleRecord);
		_changedData.cyclerecordid = _id;
		// 待办主卡片创建时间
		_changedData.create_time = _oldData.create_time;
		//生成周期性待办
		insertTaskCycleSyncData(_changedData, _cycleRecord);
		//结束时间提醒标识有可能为空，需要重新生成
		_changedData.endnotifyid = _oldData.endnotifyid;
		//完成状态
		_changedData.completed = _completed;
		if(null != _compData){
			_changedData.completed = getTaskCardCompleted(_changedData.id,
					_changedData.id, _compData);
		}
		//卡片颜色
		if(null != _colorData){
			_changedData.colors = getTaskCardColors(_changedData.id, 
					_changedData.id, _colorData);
		}
		//更新主卡片信息
		return update_mytaskData(_changedData, true, _isSync);
	}
}

/**
 * 更新待办数据（包括非周期性 和 周期性待办）
 * 
 * @param _changedData
 * @param _isSync
 * @returns
 */
function update_mytaskAllSyncData(_changedData, _isSync){
	var _isSuccess = false;
	var _operType = 1;
	if(null != _changedData.cycle &&
			null != _changedData.cycle.cycleid){
		var _cycleId = _changedData.cycle.cycleid;
		// 若重复标识为不重复，则有可能原来就是不重复的待办，
		// 也有可能原来为重复待办改为不重复待办了，根据不同情况进行处理
		// 否则，认为是重复待办，进行相应的处理
		if(cycleTypeTools.cycleIdConstants["nocycle"] == _cycleId){
			// 若重复记录标识不为空，则认为原来就是一个重复待办
			if(_changedData.cyclerecordid != null 
					&& _changedData.cyclerecordid != ""){
				_operType = 3;
			}
		} else {
			// 若重复记录标识为空，则认为原来就是不重复待办改为重复待办；
			// 否则，认为原来就是重复待办
			if(_changedData.cyclerecordid == null 
					|| _changedData.cyclerecordid == ""){
				_operType = 2;
			} else {
				_operType = 3;
			}
		}
	}
	//若结束时间类型不全，则结束前提醒为“不提醒”
	if(_changedData.endtimetype != globalConst.timeShowType.all){
		_changedData["endremindtime"] = -1;	
	}
	// 根据操作类型执行对应的方法
	if(1 == _operType){
		// 获取更新前的数据
		var _oldData = get_mytaskOneData(_changedData.id);
		// 判断开始时间是否改变
		if((_changedData.starttimetype != _oldData.starttimetype ||
				!compareStartTime(_changedData.start, _oldData.start)) &&
				constants.getConstants("taskCard_completed") == _oldData.completed){
			_changedData.completed = constants.getConstants("taskCard_uncompleted");
		} else {
			//卡片颜色
			if(null != _changedData.colors){
				var _colors = getTaskCardColors(_changedData.id, 
						_changedData.id, _changedData.colors);
				_changedData.colors = _colors;
			}
			//完成状态
			if(null != _changedData.completed){
				var _completed = getTaskCardCompleted(_changedData.id, 
						_changedData.id, _changedData.completed);
				_changedData.completed = _completed;
			}
		}
		//结束时间提醒有可能为空，需要重新生成
		_changedData.endnotifyid = _oldData.endnotifyid;
		_isSuccess = update_mytaskData(_changedData, true, _isSync);	
	} else {
		if(2 == _operType){
			var _cycleData = {};
			_isSuccess = update_mytaskCycleTypeSyncData(_changedData, _cycleData, false, _isSync);
		} else {
			var _data = dbcycle.query_cycleRecordOneData(_changedData.cyclerecordid);
			if(_data != null){
				_isSuccess = update_mytaskCycleTypeSyncData(_changedData, _data, true, _isSync);
			}
		}
	}
	return _isSuccess
}

//更新待办数据
module.exports.update_mytaskSync = function(_changedData){
	var _isSuccess = update_mytaskAllSyncData(_changedData, false);
	// 刷新视图（桌面小部件）
	widgetTools.refresh();
	return _isSuccess;
};


/**
 * 更新待办锚点（指定一个待办）
 * @param _changedData
 * @param _isRecord
 * @returns
 */
function update_mytaskOneCanged(_changedData, _isRecord){
	var _sql_update = "update mytask set " + 
		"canged=" + tools.formatSqlValue(_changedData.canged) +
		" where id="+ tools.formatSqlValue(_changedData.id) + ";";
	var isSuccess = localdb.executeSync(_sql_update);
	if(_isRecord){
		var _nowTime = (new Date()).getTime();
		// 更新记录
		var _updRecord = {
				id: _changedData.id,
				moduleid: moduleId,
				recordtime: _nowTime,
				recordtype: constants.getConstants("recordType_update"), 
				datatype: constants.getConstants("datatype_timecard")
			};
		// 设置更新记录-未同步
		dbclsyncdata.setUpdRecordUnHandle(_updRecord);
		//设置对应信息片段更新记录-未同步
		dbexpsyncdata.setUpdRecordUnHandle({
			dataid: _changedData.id,
			recordtime: _nowTime,
			recordtype: constants.getConstants("recordType_update")
		});
	}
}

/**
 * 更新锚点（也就是卡片固定,包括非周期性 和 周期性待办）
 * @param _changedData
 * @returns
 */
function update_mytaskCanged(_changedData){
	var _oldData = get_mytaskOneData(_changedData.id);
	if(_oldData.cycleid == 1){
		update_mytaskOneCanged(_changedData, true);	
	} else {
		var _data = query_mytaskDataByCycleRecordId(_oldData.cyclerecordid);
		if(_data != null){
			var _recordData = dbcycle.query_cycleRecordOneData(_oldData.cyclerecordid);
			var _taskId = _recordData.taskid;
			for(var i=0; i<_data.length; i++){
				if(_data[i] == null) continue;
				_changedData.id = _data[i].id;
				if(_data[i].id == _taskId){
					update_mytaskOneCanged(_changedData, true);
				} else {
					update_mytaskOneCanged(_changedData, false);
				}
			}
		} 
	}
}

//更新锚点（也就是卡片固定,包括非周期性 和 周期性待办）
module.exports.update_mytaskCanged = function(_changedData){
	update_mytaskCanged(_changedData);
	// 刷新视图（桌面小部件）
	widgetTools.refresh();
};

/**
 * 更新待办完成状态（包括非周期性 和 周期性待办）
 * 
 * @param _changedData
 * @returns
 */
function update_mytaskCompleted(_changedData){
	var _sql_update = "update mytask set completed=" 
		+ tools.formatSqlValue(_changedData.completed) + ","
		+ "colors =" + tools.formatSqlValue(_changedData.colors) + 
		" where id=" + tools.formatSqlValue(_changedData.id) + ";";
	var _isSuccess = localdb.executeSync(_sql_update);
	if(_isSuccess){
		var _taskId = _changedData.id;
		if(cycleTypeTools.cycleIdConstants["nocycle"] != 
			_changedData.cycleid){
			var _recordData = dbcycle.query_cycleRecordOneData(_changedData.cyclerecordid);
			_taskId = _recordData.taskid;
		}
		var _nowTime = (new Date()).getTime();
		// 更新记录
		var _updRecord = {
				id: _taskId,
				moduleid: moduleId,
				recordtime: _nowTime,
				recordtype: constants.getConstants("recordType_update"), 
				datatype: constants.getConstants("datatype_timecard")
			};
		// 设置更新记录-未同步
		dbclsyncdata.setUpdRecordUnHandle(_updRecord);
		//设置对应信息片段更新记录-未同步
		dbexpsyncdata.setUpdRecordUnHandle({
			dataid: _taskId,
			recordtime: _nowTime,
			recordtype: constants.getConstants("recordType_update")
		});
		
		// 若待办未完成，则设置待办本地提醒；否则，移除待办本地提醒
		if(_changedData.completed == constants.getConstants("taskCard_uncompleted")){
			//设置待办结束时间提醒
			notificationTools.setTaskEndTimeNotif(_changedData);
			//设置本地提醒
			notificationTools.setTaskNotification(_changedData, 
					true, "update");
		} else {
			//删除待办结束时间提醒
			notificationTools.delTimeFlowNotify([parseInt(_changedData.endnotifyid)]);
			//移除本地提醒
			notificationTools.removeLocalNotification([parseInt(_changedData.notifyid)], 
					[_changedData.id]);
		}
		// 刷新视图（桌面小部件）
		widgetTools.refresh();
	}
}

// 更新待办完成状态（包括非周期性 和 周期性待办）
module.exports.update_mytaskCompleted = function(_changedData){
	update_mytaskCompleted(_changedData);
};

/**
 * 更新待办开始和结束时间
 * @param _changedData
 * @returns
 */
function updTaskStartAnEndTime(_changedData){
	// 待办开始时间改变，待办完成状态改为未完成
	_changedData.completed = constants.getConstants("taskCard_uncompleted");
	// 获取更新待办的sql语句
	var _sql = getUpdTaskDataSql(_changedData);
	if (_sql.length <= 0) return;
	var _sql_update = "update mytask set " + _sql + " where id="
		+ tools.formatSqlValue(_changedData.id) + ";";
	var _isSuc = localdb.executeSync(_sql_update);
	if(_isSuc){
		// 更新记录
		var _updRecord = {
				id: _changedData.id,
				moduleid: moduleId,
				recordtype: constants.getConstants("recordType_update"), 
				datatype: constants.getConstants("datatype_timecard")
			};
		// 设置更新记录-未同步
		dbclsyncdata.setUpdRecordUnHandle(_updRecord);
		// 刷新视图（桌面小部件）
		widgetTools.refresh();
	}
	return _isSuc;
}

// 更新待办开始和结束时间
module.exports.updTaskStartAnEndTime = function(_changedData){
	return updTaskStartAnEndTime(_changedData);
};

/**
 * 删除待办数据
 * @param _id
 * @param _isRecord
 * @param _isSync
 * @returns
 */
function delOneTaskData(_id, _isRecord, _isSync){
	//移除本地提醒
	var _sql = "select notifyid,endnotifyid,origin from mytask where id="
		+ tools.formatSqlValue(_id) + ";";
	var _taskData = localdb.querySync(_sql);
	var _origin = null;
	if(null != _taskData && 
			_taskData.length > 0){
		//若待办结束时间提醒标识不为空，则删除待办结束时间提醒
		if(null != _taskData[0].endnotifyid){
			//删除待办结束时间提醒
			notificationTools.delTimeFlowNotify([parseInt(_taskData[0].endnotifyid)]);
		}
		//删除开始时间提醒
		notificationTools.removeLocalNotification([parseInt(_taskData[0].notifyid)], 
				[_id]);
		_origin = _taskData[0].origin;
	}
	_sql = "delete from mytask where id=" + tools.formatSqlValue(_id) + ";";
	var isSuccess = localdb.executeSync(_sql);
	if(isSuccess) {
		if(_isRecord){
			// 更新记录
			var _updRecord = {
					id: _id,
					moduleid: moduleId,
					recordtype: constants.getConstants("recordType_delete"), 
					datatype: constants.getConstants("datatype_timecard")
				};
			// 设置更新记录
			if(!_isSync){
				dbclsyncdata.setUpdRecordUnHandle(_updRecord);
			} else {
				dbclsyncdata.setUpdRecord(_updRecord);
			}
			// 删除沟通室相关的数据
			dbcommumain.delCommuRoomDataByOrigin(_id, _origin);
		}
	}
	return isSuccess;
}

/**
 * 删除同一周期待办的所有副卡片数据
 * @param _id
 * @param _cycleRecordId
 * @returns
 */
function delCycleTaskUnMainCardData(_id, _cycleRecordId){
	var _notifyIdList = new Array();
	var _endNotifyIdList = new Array();
	var _taskIdList = new Array();
	var _data = query_mytaskDataByCycleRecordId(_cycleRecordId);
	if(_data != null){
		for(var i=0; i<_data.length; i++){
			var _idNumber = parseInt(_data[i].notifyid);
			_notifyIdList.push(_idNumber);
			if(null != _data[i].endnotifyid){
				_endNotifyIdList.push(parseInt(_data[i].endnotifyid));
			}
			if(_id != _data[i].id){
				_taskIdList.push(_data[i].id);
			}
		}
	}
	//若待办结束时间提醒标识不为空，则删除待办结束时间提醒
	if(_endNotifyIdList.length > 0){
		//删除待办结束时间提醒
		notificationTools.delTimeFlowNotify(_endNotifyIdList);
	}
	//移除所有周期卡片（副卡）的提醒
	notificationTools.removeLocalNotification(_notifyIdList,
			_taskIdList);
	
	var _sql_cycledata_del ="delete from mytask where cyclerecordid=" 
		+ tools.formatSqlValue(_cycleRecordId) + " and id!="
		+ tools.formatSqlValue(_id) + ";";
	localdb.executeSync(_sql_cycledata_del);
}

/**
 * 删除周期性待办的所有卡片数据
 * @param _id
 * @param _cycleRecordId
 * @param _isSync
 * @param _isRecord
 * @returns
 */
function delCycleTaskAllCardData(_id, _cycleRecordId, _isSync, _isRecord){
	var _notifyIdList = new Array();
	var _endNotifyIdList = new Array();
	var _taskIdList = new Array();
	var _origin = null;
	var _data = query_mytaskDataByCycleRecordId(_cycleRecordId);
	if(_data != null){
		for(var i=0; i<_data.length; i++){
			var _idNumber = parseInt(_data[i].notifyid);
			_notifyIdList.push(_idNumber);
			if(null != _data[i].endnotifyid){
				_endNotifyIdList.push(parseInt(_data[i].endnotifyid));
			}
			_taskIdList.push(_data[i].id);
			if(_id == _data[i].id){
				_origin = _data[i].origin;
			}
		}
	}
	var _sql_del ="delete from mytask where cyclerecordid=" 
		+ tools.formatSqlValue(_cycleRecordId) + ";";
	var _isSuc = localdb.executeSync(_sql_del);

	if(_isSuc) {
		//若待办结束时间提醒标识不为空，则删除待办结束时间提醒
		if(_endNotifyIdList.length > 0){
			//删除待办结束时间提醒
			notificationTools.delTimeFlowNotify(_endNotifyIdList);
		}
		//移除开始时间提醒
		notificationTools.removeLocalNotification(_notifyIdList,
				_taskIdList);
		
		if(_isRecord){
			// 更新记录
			var _updRecord = {
					id: _id,
					moduleid: moduleId,
					recordtype: constants.getConstants("recordType_delete"), 
					datatype: constants.getConstants("datatype_timecard")
				};
			// 设置更新记录
			if(!_isSync){
				dbclsyncdata.setUpdRecordUnHandle(_updRecord);
			} else {
				dbclsyncdata.setUpdRecord(_updRecord);
			}
		}
		// 删除沟通室相关的数据
		dbcommumain.delCommuRoomDataByOrigin(_id, _origin);
	}
	return _isSuc;
}

/**
 * 删除待办所有卡片数据（包括非周期性 和 周期性待办）
 * @param _id
 * @param _cycleRecordId
 * @param _cycleId
 * @param _isRecord
 * @param _isSync
 * @returns
 */
function delTaskAllCardData(_id, _cycleRecordId, _cycleId, _isSync, _isRecord){
	var _isSuc;
	var _taskId = _id;
	if(_cycleId == 1 || _cycleRecordId == null){
		_isSuc = delOneTaskData(_taskId, _isRecord, _isSync);
	} else {
		_isSuc = delCycleTaskAllCardData(_taskId, 
				_cycleRecordId, _isSync, _isRecord);
		//删除周期记录表对应记录
		dbcycle.delete_cyclerecordDataById(_cycleRecordId);
	}
	return _isSuc;
}

/**
 * 删除待办数据
 * @param _id
 * @param _cycleRecordId
 * @param _cycleId
 * @returns
 */
function delTaskData(_id, _cycleRecordId, _cycleId){
	var _isSuc = delTaskAllCardData(_id,
			_cycleRecordId, _cycleId, false, true);
	// 刷新视图（桌面小部件）
	widgetTools.refresh();
	return _isSuc;
}

//通过id删除待办数据
module.exports.delTaskData = function(_id, _cycleRecordId, _cycleId){
	return delTaskData(_id, _cycleRecordId, _cycleId);
};

/**
 * 删除待办数据（周期和非周期）-数据同步
 * @param _id
 * @param _cycleRecordId
 * @param _cycleId
 * @returns
 */
function delTaskSyncData(_id, _cycleRecordId, _cycleId){
	var _isSuc = delTaskAllCardData(_id,
			_cycleRecordId, _cycleId, true, true);
	// 刷新视图（桌面小部件）
	widgetTools.refresh();
	return _isSuc;
}

// 删除待办数据-数据同步
module.exports.delTaskSyncData = function(_id, _cycleRecordId, _cycleId){
	return delTaskSyncData(_id, _cycleRecordId, _cycleId);
};

/**
 * 删除待办数据（周期和非周期）-信息同步
 * @param _id
 * @param _cycleRecordId
 * @param _cycleId
 * @returns
 */
function delTaskExpSync(_id, _cycleRecordId, _cycleId, _record){
	var _isSuc = delTaskAllCardData(_id,
			_cycleRecordId, _cycleId, true, false);
	// 更新记录
	var _updRecord = {
			id: _id,
			moduleid: moduleId,
			recordtime: _record.recordtime,
			recordtype: constants.getConstants("recordType_delete"), 
			datatype: constants.getConstants("datatype_timecard")
		};
	if(_record.handlestate){
		// 设置更新记录-已同步
		dbclsyncdata.setUpdRecord(_updRecord);
	} else {
		// 设置更新记录-未同步
		dbclsyncdata.setUpdRecordUnHandle(_updRecord);
	}
	return _isSuc;
}

// 删除待办数据-信息同步
module.exports.delTaskExpSync = function(_id, _cycleRecordId, _cycleId, _record){
	return delTaskExpSync(_id, _cycleRecordId, _cycleId, _record);
};

/**
 * 清除过去的待办数据
 * 
 * @returns
 */
function clearAgoTask(){
	//设置时间为当前年时间起点（当前的1月1日0时0分0秒0毫秒）
	var _time = new Date();
	_time.setMonth(0, 1);
	_time.setHours(0, 0, 0, 0);
	//查询过去的所有待办
	var _sql = "select id, cycleid, cyclerecordid from mytask where deleted=0 and canged='0' and infocategory="
		+ infoCategoryTask + " and end<" + _time.getTime() + ";";
	var _taskList = localdb.querySync(_sql);
	//是否清理成功
	var _isSuccess = false;
	if(null != _taskList && _taskList.length > 0){
		var _sql_update = "";
		for(var i=0; i<_taskList.length; i++){
			var _oneData = _taskList[i];
			if(null == _oneData ||
					tools.isNullOrEmpty(_oneData.id)) continue;
			//卡片id
			var _id = _oneData.id;
			// 删除待办卡片
			if(_oneData.cycleid != 1 && 
					!tools.isNullOrEmpty(_oneData.cyclerecordid)){
				var _cycleData = dbcycle.query_cycleRecordOneData(_oneData.cyclerecordid);
				//判断待办的周期性信息是否存在
				//若存在且为主卡，则更新周期记录的开始时间字段（starttime）
				//若存在且为副卡，则直接删除
				//若不存在，则直接删除
				if(_cycleData != null &&　_cycleData.taskid == _id){
					// 周期截止时间
					var _endTime = parseInt(_cycleData.endtime);
					// 若周期截止时间不为空且为永不截止或大于等于当前年份起始时间，
					// 则更新周期记录的开始时间字段（starttime）,且不删除主卡片；
					// 否则删除主卡片和周期记录表中对应的记录数据
					if(null != _endTime &&
							(0 == _endTime ||
							_endTime >= _time.getTime())){
						_sql = "select id, end, min(start) as start from mytask where start>="
							+ _time.getTime()
							+ " and cyclerecordid=" + tools.formatSqlValue(_oneData.cyclerecordid) + ";";
						var _oneTask = localdb.querySync(_sql);
						if(null != _oneTask){
							//更新周期记录表
							dbcycle.update_cycleRecordData({
								starttime:_oneTask.start 
							});
						}
						continue;
					} else {
						// 删除周期记录表对应记录
						dbcycle.delete_cyclerecordDataById(_oneData.cyclerecordid);
					}
				}
			}
			// 删除待办卡片数据
			delOneTaskData(_id, false, false);
			// 需要将周期待办副卡去除掉，
			// 所以数据标识id长度为1到24位待办才可以
			if(_id.length > 0 && _id.length <= 24){
				// 插入一条数据清理的记录
				dbcleardata.insertDataClearRecord({
					id: _id,
					moduleid: moduleId,
					infocategory: infoCategoryTask
				});
			}
		}
		_isSuccess = true;
	}
	// 刷新视图（桌面小部件）
	widgetTools.refresh();
	return _isSuccess;
};

//清除过去的待办数据
module.exports.clearAgoTask = function(){
	return clearAgoTask();
};

/**
 * 通过cyclerecordid从mytask表中获取所有数据
 * @param _id
 * @returns
 */
function query_mytaskDataByCycleRecordId(_cyclerecordid){
	var sql ="select * from mytask where cyclerecordid=" 
		+ tools.formatSqlValue(_cyclerecordid) + " order by start ASC;";
	var _data=localdb.querySync(sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data;
}

//通过cyclerecordid从mytask表中获取所有数据
module.exports.query_mytaskByCycleRecordId = function(_cyclerecordid){
	return query_mytaskDataByCycleRecordId(_cyclerecordid);
};

/**
 * 通过id从mytask表中获取对应的cyclerecordid
 * @param _id
 * @returns
 */
function query_mytaskCycleRecordIdById(_id){
	var sql ="select cyclerecordid from mytask where id=" + tools.formatSqlValue(_id) + ";";
	var _data = localdb.querySync(sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data[0];
}

//通过id从mytask表中获取对应的cyclerecordid
module.exports.query_mytaskCycleRecordId = function(_id){
	return query_mytaskCycleRecordIdById(_id);
};

/**
 * 查询待办总数量（按照标题去重）
 * @returns
 */
function query_countMyTask(){
	var sql ="select count(distinct title) as sum from mytask where infocategory="
		+ infoCategoryTask + ";";
	var _data = localdb.querySync(sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data[0];
}

//查询待办总数量（按照标题去重）
module.exports.query_countMyTask = function(){
	return query_countMyTask();
};

/**
 * 查询指定条件下的卡片数量（开始时间在指定范围内的待办卡片数量）
 * @param _startTime
 * @param _endTime
 * @returns
 */
function query_mytaskNumByTime(_startTime, _endTime){
	var sql ="select count(*) as sum from mytask where infocategory="
		+ infoCategoryTask + " and start>=" 
		+ _startTime + " and start<="
		+ _endTime + ";";
	var _data = localdb.querySync(sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data[0];
}

//查询指定条件下的卡片数量（开始时间在指定范围内的待办卡片数量）
module.exports.query_mytaskNumByTime = function(_startTime, _endTime){
	return query_mytaskNumByTime(_startTime, _endTime);
};

/**
 * 查询指定时间范围的各类型待办卡片数量（开始时间在指定范围内的待办卡片数量）
 * @param _startTime
 * @param _endTime
 * @returns
 */
function queryTaskTypeNumByTime(_startTime, _endTime){
	var _sql ="select type, count(type) as num from mytask where infocategory="
		+ infoCategoryTask + " and start<=" 
		+ _endTime + " and end>="
		+ _startTime + " group by type;";
	var _data = localdb.querySync(_sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data;
}

//查询指定时间范围的各类型待办卡片数量（开始时间在指定范围内的待办卡片数量）
module.exports.queryTaskTypeNumByTime = function(_startTime, _endTime){
	return queryTaskTypeNumByTime(_startTime, _endTime);
};

/**
 * 查询指定条件下的待办卡片开始时间和结束时间（开始时间在指定时间范围内的待办卡片）
 * @param _startTime
 * @param _endTime
 * @returns
 */
function query_mytaskStartAndEndByTime(_startTime, _endTime){
	var _sql ="select start, end from mytask where infocategory="
		+ infoCategoryTask + " and start<=" 
		+ _endTime + " and end>="
		+ _startTime + " order by start ASC;";
	var _data = localdb.querySync(_sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data;
}

//查询指定条件下的待办卡片开始时间和结束时间（开始时间在指定时间范围内的待办卡片）
module.exports.query_mytaskStartAndEndByTime = function(_startTime, _endTime){
	return query_mytaskStartAndEndByTime(_startTime, _endTime);
};

/**
 * 异步查询指定条件和字段的卡片信息
 * @param _fields
 * @param _conditions
 * @param _callFunc
 * @returns
 */
function query_taskFieldsByCondition(_fields, _conditions, _callFunc){
	var _sql ="select " +  _fields + " from mytask where infocategory="
		+ infoCategoryTask + " and ";
	if(null != _conditions && _conditions.length > 0){
		_sql += _conditions;
	}
	_sql += ";";
	localdb.query({sql: _sql}, function(_data){
		_callFunc.call(this, _data);
	});
}

// 异步查询指定条件和字段的卡片信息
module.exports.query_taskFieldsByCondition = function(_fields, _condition, _callFunc){
	query_taskFieldsByCondition(_fields, _condition, _callFunc);
};

/**
 * 查询指定条件（id标识、类型和事项名称）下待办数据--用于同一个类型下重名判断
 * @param _id
 * @param _type
 * @param _title
 * @returns
 */
function query_taskDataByTypeTitle(_id, _type, _title){
	var _sql ="select id from mytask where type=" 
		+ tools.formatSqlValue(_type); 
	_sql += " and title=" + tools.formatSqlValue(_title);
	_sql += " and id not like " + tools.formatSqlValue(_id + "%") + " limit 1;";
	var _data = localdb.querySync(_sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data[0];
}

// 查询指定条件（类型和事项名称）下待办数据--用于同一个类型下重名判断
module.exports.query_taskDataByTypeTitle = function(_id, _type, _title){
	return query_taskDataByTypeTitle(_id, _type, _title);
};

/**
 * 查询待办主卡的id标识
 * @param _id
 * @returns
 */
function queryTaskMainCardId(_id, _cycleRecordId, _cycleId){
	if(null == _cycleRecordId){
		var _taskData = get_mytaskOneData(_id);
		if(null != _taskData){
			if(1 != parseInt(_taskData.cycleid)){
				_cycleRecordId = _taskData.cyclerecordid;
			}
		}
	} else {
		if(1 == parseInt(_cycleId)){
			_cycleRecordId = null;
		}
	}
	if(null != _cycleRecordId &&
			"" != _cycleRecordId){
		var _cycleRecordData = dbcycle.query_taskidByCycleRecordId(_cycleRecordId);
		if(null != _cycleRecordData){
			_id = _cycleRecordData.taskid;
		}
	}
	return _id;
}

// 查询待办主卡的id标识
module.exports.queryTaskMainCardId = function(_id){
	return queryTaskMainCardId(_id);
};

/**
 * 查询待办数据
 * @returns
 */
function queryAllTaskData(){
	var _sql ="select * from mytask";
	var _data = localdb.querySync(_sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data;
}

// 查询待办数据
module.exports.queryAllTaskData = function(){
	return queryAllTaskData();
};

/**
 * 通过id从mytask表中获取指定的一条数据
 * @param _id
 * @returns
 */
function get_mytaskOneData(_id){
	var _sql ="select * from mytask where id=" + tools.formatSqlValue(_id) + ";";
	var _data = localdb.querySync(_sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data[0];
}

//通过id获取一条待办数据
module.exports.get_mytaskOneData = function(_id){
	return get_mytaskOneData(_id);	
};

/**
 * 异步查询指定id的信息
 * @param _id
 * @param _callFunc
 * @returns
 */
function queryAsyncMyTaskDataById(_id, _callFunc){
	var _sql ="select * from mytask where id=?;";
	localdb.query(_sql, [_id], function(_data){
		if(null == _data || _data.length <= 0){
			_callFunc.call(this, null);
		} else {
			_callFunc.call(this, _data[0]);
		}
	});
}

//异步查询指定id的信息
module.exports.queryAsyncMyTaskDataById = function(_id, _callFunc){
	queryAsyncMyTaskDataById(_id, _callFunc);
};

/**
 * 是否存在待办卡片数据
 * @param _id
 * @returns
 */
function isExistTaskCardData(_id){
	var _taskData = get_mytaskOneData(_id);
	if(null != _taskData){
		return true;
	}
	return false;
}

// 是否存在待办卡片数据
module.exports.isExistTaskCardData = function(_id){
	return isExistTaskCardData(_id);
};

// ----------------------------------- 数据同步
var taskNotifyList = null;
var taskNotifyIndex = 0;

/**
 * 设置待办提醒
 * @param _callFunc
 * @returns
 */
function setTaskNotify(_callFunc){
	if(taskNotifyIndex < taskNotifyList.length){
		var _taskNotifyData = taskNotifyList[taskNotifyIndex];
		if(null != _taskNotifyData){
			//设置本地提醒
			notificationTools.setSycCalNotifySync(_taskNotifyData,
					function(){
				taskNotifyList[taskNotifyIndex] = null;
				taskNotifyIndex++;
				setTaskNotify(_callFunc);
			});
		} else {
			taskNotifyIndex++;
			setTaskNotify(_callFunc);
		}
	} else {
		taskNotifyIndex = 0;
		taskNotifyList = null;
		// 回调函数
		_callFunc.call(this);
	}
}

/**
 * 设置所有待办提醒-数据同步
 * @param _callFunc
 * @returns
 */
function setAllTaskNotify(_callFunc){
	if(notificationTools.checkIsSycCalNotify() && 
			null != taskNotifyList && 
			taskNotifyList.length > 0){
		setTaskNotify(_callFunc);
	} else {
		_callFunc.call(this);
	}
}

// 设置所有待办提醒-数据同步
module.exports.setTaskNotifySync = function(_callFunc){
	setAllTaskNotify(_callFunc);
};

/**
 * 插入一条待办数据-数据同步
 * @param _changedData
 * @param _isRecord
 * @returns
 */
function insertOneTaskSyncData(_changedData, _isRecord){
	var _sql_insert = getInsertTaskDataSql(_changedData);
	var isSuccess = localdb.executeSync(_sql_insert);
	if(isSuccess){
		
		if (_changedData.remindtime != null && 
				_changedData.remindtime != -1){
			//提醒时间
			var _promptTime = calendar.getPromptTime(parseInt(_changedData.start), 
					parseInt(_changedData.remindtime));
			//判断提醒时间是否已经过去（暂时过去的时间不设置提醒）
			var _nowTime = new Date();
			if(_nowTime.getTime() < _promptTime.getTime()){
				var _isSysCalendarNotify = do_global.getMemory("allowSysCalendarNotify");
				// 根据需要设置为时间流内部本地提醒或系统日历提醒（解决不提醒问题）
				if(0 == _isSysCalendarNotify){
					//设置本地提醒
					notificationTools.setTaskNotification(_changedData, true, "add");
				} else {
					if(null == taskNotifyList){
						taskNotifyList = [];
					}
					taskNotifyList.push({
						id: _changedData.id,
						content: _changedData.title,
						start: _changedData.start,
						end: _changedData.end,
						remindtime: _changedData.remindtime,	
						notifyid: _changedData.notifyid
					});
				}
			}
		}
		
		if(_isRecord){
			// 更新记录
			var _updRecord = {
					id: _changedData.id,
					moduleid: moduleId,
					recordtype: constants.getConstants("recordType_create"), 
					datatype: constants.getConstants("datatype_timecard")
				};
			// 设置更新记录-已同步
			dbclsyncdata.setUpdRecord(_updRecord);
		}
	}
	return isSuccess;
}

/**
 * 插入周期性数据到mytask表中 -数据同步
 * （根据周期类型采用不同生成的规则，创建待办卡片）
 * @param _changedData
 * @param _cycleRecord
 */
function insertTaskCycleSyncData(_changedData, _cycleRecord){
	var _cycleid = parseInt(_cycleRecord.cycleid);
	var _count = parseInt(_cycleRecord.count);
	var _date = new Date();
	var _cycleEndTime = parseInt(_cycleRecord.endtime);
	var _customTypeId = parseInt(_cycleRecord.type);
	if(0 != _cycleEndTime){
		_date.setTime(_cycleEndTime);
		_date.setHours(23, 59, 59, 999);
		_cycleEndTime = _date.getTime();
		_date = new Date(); 
	}
	var _nowTime = _date.getTime();
	var _lengthTime = 0;
	var _startTime = parseInt(_changedData.start);
	var _endTime = parseInt(_changedData.end);
	var _timeValue = _endTime - _startTime;
	// 若开始时间大于当前时间，则计算截止时间从开始时间开始；否则从当前时间开始
	if(_startTime > _nowTime){
		_lengthTime = calendar.getLengthTimeValue(_startTime, _cycleid, _customTypeId);
	} else {
		_lengthTime = calendar.getLengthTimeValue(_nowTime, _cycleid, _customTypeId);
	}
	// 若计算截止时间为大于重复截止时间，则计算截止时间等于重复截止时间；否则不变
	if(0 != _cycleEndTime && _lengthTime > _cycleEndTime){
		_lengthTime = _cycleEndTime;
	}
	var _updTime = parseInt(_cycleRecord.updtime);
	if(_updTime < _cycleRecord.starttime){
		_updTime = parseInt(_cycleRecord.starttime);
	}
	var _oldUpTime = _updTime;
	var _week = _cycleRecord.week;
	var _weekDay = 0;
	var _weekDayTmp = _weekDay;
	// 根据周期（重复）类型执行对应的重复时间计算方法;
	// 工作日和每周几
	if(cycleTypeTools.cycleIdConstants["workday"] == _cycleid ||
			cycleTypeTools.cycleIdConstants["weekday"] == _cycleid){
		if(null == _cycleRecord.weekday || "" == _cycleRecord.weekday){
			_date.setTime(_startTime);
			_weekDay = _date.getDay();
			if(_weekDay == 0){
				_weekDay = 7;
			}
		} else {
			_weekDay = _cycleRecord.weekday;
		}
		_weekDayTmp = _weekDay;
		var _timeData = calendar.getCycleTimeOfWeek({
			updtime: _updTime,
			cycleid: _cycleid,
			week: _week,
			weekday: _weekDay
		});
		_weekDay = _timeData.weekday;
		_updTime = _timeData.updtime;
	} else {
		// 自定义
		if(cycleTypeTools.cycleIdConstants["custom"] == _cycleid){
			_cycleRecord.updtime = _updTime;
			_updTime = calendar.getCycleTimeOfCustom(_cycleRecord);
		} else { // 其他重复（周期）类型
			_updTime = calendar.getCycleTime(_startTime, _updTime, _cycleid);
		}
	}
	// 若计算出来下一张卡片的开始时间一样的话，则直接返回
	if(_oldUpTime == _updTime){
		return true;
	}
	while(_updTime <= _lengthTime){
		_endTime = _updTime + _timeValue;
		var _id = tools.createTaskId(_cycleRecord.taskid, ++_count);
		var _colors = jsonTools.jsonObjToStr(colors);
		if(null != _changedData.colors){
			_colors = getTaskCardColors(_changedData.id, 
					_id, _changedData.colors);
		}
		var _completed = getTaskCardCompleted(_changedData.id, 
				_id, _changedData.completed);
		insertOneTaskSyncData({
			id: _id,
			infoid: _changedData.id,
			title: _changedData.title,
			type: _changedData.type,
			start: _updTime,
			starttimetype: _changedData.starttimetype,
			end: _endTime,
			endtimetype: _changedData.endtimetype,
			createby: _changedData.createby,
			destpersonname: _changedData.destpersonname,
			connectby: _changedData.connectby,
			connectphone: _changedData.connectphone,
			remindtime: _changedData.remindtime,
			location: _changedData.location,
			comment: _changedData.comment,
			canged: _changedData.canged,
			cycle: {
				cycleid: _cycleid,
			},
			cyclerecordid: _cycleRecord.id,
			source: _changedData.source,
			colors: _colors,
			completed: _completed,
			morefields: _changedData.morefields,
			create_time: _changedData.create_time,
			update_time: _changedData.update_time
		}, false);
		_oldUpTime = _updTime;
		_weekDayTmp = _weekDay;
		// 根据周期（重复）类型执行对应的重复时间计算方法;
		// 工作日和每周几
		if(cycleTypeTools.cycleIdConstants["workday"] == _cycleid ||
				cycleTypeTools.cycleIdConstants["weekday"] == _cycleid){
			var _timeData = calendar.getCycleTimeOfWeek({
				updtime: _updTime,
				cycleid: _cycleid,
				week: _week,
				weekday: _weekDay
			});
			_weekDay = _timeData.weekday;
			_updTime = _timeData.updtime;
		} else {
			// 自定义
			if(cycleTypeTools.cycleIdConstants["custom"] == _cycleid){
				_cycleRecord.updtime = _updTime;
				_updTime = calendar.getCycleTimeOfCustom(_cycleRecord);
			} else { // 其他重复（周期）类型
				_updTime = calendar.getCycleTime(_startTime, _updTime, _cycleid);
			}
		}
	}
	
	var _cycleRecordData = {
			id: _cycleRecord.id,
			updtime: _oldUpTime,
			weekday: _weekDayTmp,
			count: _count
		};
	//更新周期记录表指定id的数据
	dbcycle.update_cycleRecordData(_cycleRecordData);
	return true;
}

/**
 * 获取待办卡片背景颜色
 * @param _mainId
 * @param _dataId
 * @param _colors
 * @returns
 */
function getTaskCardColors(_mainId, _dataId, _colors){
	var _defColors = _colors.def;
	var _otherColors = _colors.other;
	var _colorData = {
			colors_uncompleted: _defColors.color1,
			colors_completed: _defColors.color2	
	};
	for(var i=0; i<_otherColors.length; i++){
		if(null == _otherColors[i]) continue;
		if("000000" == _otherColors[i].id){
			if(_mainId == _dataId){
				_colorData = {
						colors_uncompleted: _otherColors[i].color1,
						colors_completed: _otherColors[i].color2	
				}
				break;
			}
		} else {
			if((_mainId + _otherColors[i].id) == _dataId){
				_colorData = {
						colors_uncompleted: _otherColors[i].color1,
						colors_completed: _otherColors[i].color2	
				}
				break;
			}
		}
	}
	return jsonTools.jsonObjToStr(_colorData);
}

/**
 * 获取完成状态
 * @param _mainId
 * @param _dataId
 * @param _compData
 * @returns
 */
function getTaskCardCompleted(_mainId, _dataId, _compData){
	var _completed = constants.getConstants("taskCard_uncompleted");
	if(null != _compData){
		if(_mainId != _dataId){
			var _otherComp = _compData.other;
			for(var i=0; i<_otherComp.length; i++){
				if(null == _otherComp[i]) continue;
				if((_mainId + _otherComp[i]) == _dataId){
					_completed = constants.getConstants("taskCard_completed");;
					break;
				}
			}
		} else {
			_completed = _compData.main;
		}
	}
	return _completed;
}

/**
 * 插入周期性源数据到mytask表中
 * （插入周期源数据并生成同一类型周期从当前时间到未来1年内的所有待办）
 * @param _changedData
 */
function insertTaskCycleSourceSyncData(_changedData){
	if(null == _changedData.id || "" == _changedData.id){
		_changedData.id = objectId.getObjectId();
	}
	if(null == _changedData.source || "" == _changedData.source){
		_changedData.source = "0";
	}
	var _colors = jsonTools.jsonObjToStr(colors);
	if(null != _changedData.colors){
		_colors = getTaskCardColors(_changedData.id, 
				_changedData.id, _changedData.colors);
	}
	var _completed = getTaskCardCompleted(_changedData.id, 
				_changedData.id, _changedData.completed);
	var _cycleRecordId = objectId.getObjectId();
	var _taskData = {
			id: _changedData.id,
			infoid: _changedData.id,
			title: _changedData.title,
			type: _changedData.type,
			start: _changedData.start,
			end: _changedData.end,
			createby: _changedData.createby,
			destpersonname: _changedData.destpersonname,
			connectby: _changedData.connectby,
			connectphone: _changedData.connectphone,
			remindtime: _changedData.remindtime,
			location: _changedData.location,
			comment: _changedData.comment,
			canged: _changedData.canged,
			cycle: _changedData.cycle,
			cyclerecordid: _cycleRecordId,
			source: _changedData.source,
			completed: _completed,
			colors: _colors,
			origin: _changedData.origin,
			presrc: _changedData.presrc,
			morefields: _changedData.morefields,
			create_time: _changedData.create_time,
			update_time: _changedData.update_time
		};
	// 插入待办数据
	insertOneTaskSyncData(_taskData, true);
	_taskData.completed = _changedData.completed;
	_taskData.colors = _changedData.colors;
	// 重复（周期）数据
	var _cycleData = _changedData.cycle;
	//周期性记录表增加一条记录
	var _cycleRecordData = {
			id: _cycleRecordId,
			taskid: _changedData.id,
			starttime: _changedData.start,
			updtime: _changedData.start,
			cycleid: _cycleData.cycleid,
			type: _cycleData.cycletype.type,
			frequency: _cycleData.cycletype.frequency,
			selection: _cycleData.cycletype.selection,
			week: _cycleData.week,
			endtime: _cycleData.cycleendtime,
			count: 0,
			infocategory: infoCategoryTask
		};
	dbcycle.insert_cycleRecordData(_cycleRecordData);
	//生成周期性待办数据
	return insertTaskCycleSyncData(_taskData, _cycleRecordData);
}

/**
 * 新建待办数据（包括非周期性 和 周期性待办）-数据同步
 * 
 * @param _changedData
 * @returns
 */
function insertTaskSyncData(_changedData){
	var _result = true;
	// 若重复（周期）数据不为空且重复（周期）标识也不为空，
	// 则根据重复（周期）类型创建待办；否则直接创建不重复（非周期）待办
	if(null != _changedData.cycle && 
			null != _changedData.cycle.cycleid){
		var _cycleId = parseInt(_changedData.cycle.cycleid);
		// 若重复（周期）标识为不重复（非周期），则新建不重复（非周期）待办
		if(cycleTypeTools.cycleIdConstants["nocycle"] == _cycleId){
			if(null != _changedData.colors){
				var _defColors = _changedData.colors.def;
				var _colors = {
						colors_uncompleted: _defColors.color1,
						colors_completed: _defColors.color2	
				};
				_changedData.colors = jsonTools.jsonObjToStr(_colors);
			}
			if(null != _changedData.completed){
				var _completedData = _changedData.completed;
				_changedData.completed = _completedData.main;
			}
			_result = insertOneTaskSyncData(_changedData, true);
		} else {
			_result = insertTaskCycleSourceSyncData(_changedData);
		}
	} else {
		if(null != _changedData.colors){
			var _defColors = _changedData.colors.def;
			var _colors = {
					colors_uncompleted: _defColors.color1,
					colors_completed: _defColors.color2	
			};
			_changedData.colors = jsonTools.jsonObjToStr(_colors);
		}
		if(null != _changedData.completed){
			var _completedData = _changedData.completed;
			_changedData.completed = _completedData.main;
		}
		_result = insertOneTaskSyncData(_changedData, true);
	}
	return _result;
	
};

//插入一条待办数据-数据同步
module.exports.insertTaskSyncData = function(_changedData){
	var _isSuccess = insertTaskSyncData(_changedData);
	// 刷新视图（桌面小部件）
	widgetTools.refresh();
	return _isSuccess;
};

/**
 * 插入周期性数据到mytask表中 -信息库同步
 * （根据周期类型采用不同生成的规则，创建待办卡片）
 * @param _changedData
 * @param _cycleRecord
 */
function insertTaskCycleExpSync(_changedData, _cycleRecord){
	var _cycleid = parseInt(_cycleRecord.cycleid);
	var _count = parseInt(_cycleRecord.count);
	var _date = new Date();
	var _cycleEndTime = parseInt(_cycleRecord.endtime);
	var _customTypeId = parseInt(_cycleRecord.type);
	if(0 != _cycleEndTime){
		_date.setTime(_cycleEndTime);
		_date.setHours(23, 59, 59, 999);
		_cycleEndTime = _date.getTime();
		_date = new Date(); 
	}
	var _nowTime = _date.getTime();
	var _lengthTime = 0;
	var _startTime = parseInt(_changedData.start);
	var _endTime = parseInt(_changedData.end);
	var _timeValue = _endTime - _startTime;
	// 若开始时间大于当前时间，则计算截止时间从开始时间开始；否则从当前时间开始
	if(_startTime > _nowTime){
		_lengthTime = calendar.getLengthTimeValue(_startTime, _cycleid, _customTypeId);
	} else {
		_lengthTime = calendar.getLengthTimeValue(_nowTime, _cycleid, _customTypeId);
	}
	// 若计算截止时间为大于重复截止时间，则计算截止时间等于重复截止时间；否则不变
	if(0 != _cycleEndTime && _lengthTime > _cycleEndTime){
		_lengthTime = _cycleEndTime;
	}
	var _updTime = parseInt(_cycleRecord.updtime);
	if(_updTime < _cycleRecord.starttime){
		_updTime = parseInt(_cycleRecord.starttime);
	}
	var _oldUpTime = _updTime;
	var _week = _cycleRecord.week;
	var _weekDay = 0;
	var _weekDayTmp = _weekDay;
	// 根据周期（重复）类型执行对应的重复时间计算方法;
	// 工作日和每周几
	if(cycleTypeTools.cycleIdConstants["workday"] == _cycleid ||
			cycleTypeTools.cycleIdConstants["weekday"] == _cycleid){
		if(null == _cycleRecord.weekday || "" == _cycleRecord.weekday){
			_date.setTime(_startTime);
			_weekDay = _date.getDay();
			if(_weekDay == 0){
				_weekDay = 7;
			}
		} else {
			_weekDay = _cycleRecord.weekday;
		}
		_weekDayTmp = _weekDay;
		var _timeData = calendar.getCycleTimeOfWeek({
			updtime: _updTime,
			cycleid: _cycleid,
			week: _week,
			weekday: _weekDay
		});
		_weekDay = _timeData.weekday;
		_updTime = _timeData.updtime;
	} else {
		// 自定义
		if(cycleTypeTools.cycleIdConstants["custom"] == _cycleid){
			_cycleRecord.updtime = _updTime;
			_updTime = calendar.getCycleTimeOfCustom(_cycleRecord);
		} else { // 其他重复（周期）类型
			_updTime = calendar.getCycleTime(_startTime, _updTime, _cycleid);
		}
	}
	// 若计算出来下一张卡片的开始时间一样的话，则直接返回
	if(_oldUpTime == _updTime){
		return true;
	}
	while(_updTime <= _lengthTime){
		_endTime = _updTime + _timeValue;
		var _id = tools.createTaskId(_cycleRecord.taskid, ++_count);
		// 添加副卡片数据
		insertOneTaskSyncData({
			id: _id,
			infoid: _changedData.id,
			title: _changedData.title,
			type: _changedData.type,
			start: _updTime,
			starttimetype: _changedData.starttimetype,
			end: _endTime,
			endtimetype: _changedData.endtimetype,
			createby: _changedData.createby,
			destpersonname: _changedData.destpersonname,
			connectby: _changedData.connectby,
			connectphone: _changedData.connectphone,
			remindtime: _changedData.remindtime,
			location: _changedData.location,
			comment: _changedData.comment,
			cycle: {
				cycleid: _cycleid,
			},
			cyclerecordid: _cycleRecord.id,
			create_time: _changedData.create_time,
			update_time: _changedData.update_time
		}, false);
		_oldUpTime = _updTime;
		_weekDayTmp = _weekDay;
		// 根据周期（重复）类型执行对应的重复时间计算方法;
		// 工作日和每周几
		if(cycleTypeTools.cycleIdConstants["workday"] == _cycleid ||
				cycleTypeTools.cycleIdConstants["weekday"] == _cycleid){
			var _timeData = calendar.getCycleTimeOfWeek({
				updtime: _updTime,
				cycleid: _cycleid,
				week: _week,
				weekday: _weekDay
			});
			_weekDay = _timeData.weekday;
			_updTime = _timeData.updtime;
		} else {
			// 自定义
			if(cycleTypeTools.cycleIdConstants["custom"] == _cycleid){
				_cycleRecord.updtime = _updTime;
				_updTime = calendar.getCycleTimeOfCustom(_cycleRecord);
			} else { // 其他重复（周期）类型
				_updTime = calendar.getCycleTime(_startTime, _updTime, _cycleid);
			}
		}
	}
	
	var _cycleRecordData = {
			id: _cycleRecord.id,
			updtime: _oldUpTime,
			weekday: _weekDayTmp,
			count: _count
		};
	//更新周期记录表指定id的数据
	dbcycle.update_cycleRecordData(_cycleRecordData);
	return true;
}

/**
 * 插入周期性源数据到mytask表中-信息库同步
 * （插入周期源数据并生成同一类型周期从当前时间到未来1年内的所有待办）
 * @param _changedData
 */
function insertTaskCycleSourceExpSync(_changedData){
	var _cycleRecordId = objectId.getObjectId();
	var _taskData = {
			id: _changedData.id,
			infoid: _changedData.id,
			title: _changedData.title,
			type: _changedData.type,
			start: _changedData.start,
			starttimetype: _changedData.starttimetype,
			end: _changedData.end,
			endtimetype: _changedData.endtimetype,
			createby: _changedData.createby,
			destpersonname: _changedData.destpersonname,
			connectby: _changedData.connectby,
			connectphone: _changedData.connectphone,
			remindtime: _changedData.remindtime,
			location: _changedData.location,
			comment: _changedData.comment,
			cycle: _changedData.cycle,
			cyclerecordid: _cycleRecordId,
			create_time: _changedData.create_time,
			update_time: _changedData.update_time
		};
	// 插入待办数据（主卡片数据）
	insertOneTaskSyncData(_taskData, false);
	
	// 重复（周期）数据
	var _cycleData = _changedData.cycle;
	//周期性记录表增加一条记录
	var _cycleRecordData = {
			id: _cycleRecordId,
			taskid: _changedData.id,
			starttime: _changedData.start,
			updtime: _changedData.start,
			cycleid: _cycleData.cycleid,
			type: _cycleData.cycletype.type,
			frequency: _cycleData.cycletype.frequency,
			selection: _cycleData.cycletype.selection,
			week: _cycleData.week,
			endtime: _cycleData.cycleendtime,
			count: 0,
			infocategory: infoCategoryTask
		};
	dbcycle.insert_cycleRecordData(_cycleRecordData);
	
	//生成周期性待办数据
	return insertTaskCycleExpSync(_taskData, _cycleRecordData);
}

/**
 * 新建待办数据（包括非周期性 和 周期性待办）-信息库同步
 * 
 * @param _changedData
 * @returns
 */
function insertTaskExpSync(_changedData){
	var _result = true;
	// 若重复（周期）数据不为空且重复（周期）标识也不为空，
	// 则根据重复（周期）类型创建待办；否则直接创建不重复（非周期）待办
	if(null != _changedData.cycle && 
			null != _changedData.cycle.cycleid){
		var _cycleId = parseInt(_changedData.cycle.cycleid);
		// 若重复（周期）标识为不重复（非周期），则新建不重复（非周期）待办
		if(cycleTypeTools.cycleIdConstants["nocycle"] == _cycleId){
			_result = insertOneTaskSyncData(_changedData, false);
		} else {
			_result = insertTaskCycleSourceExpSync(_changedData);
		}
	} else {
		_result = insertOneTaskSyncData(_changedData, false);
	}
	return _result;
};

//插入一条待办数据-信息库同步
module.exports.insertTaskExpSync = function(_changedData, _record, _callFunc){
	var _isSuccess = insertTaskExpSync(_changedData);
	// 更新记录
	var _updRecord = {
			id: _changedData.id,
			moduleid: moduleId,
			recordtime: _record.recordtime,
			recordtype: constants.getConstants("recordType_create"), 
			datatype: constants.getConstants("datatype_timecard")
		};
	// 设置更新记录-已同步
	dbclsyncdata.setUpdRecord(_updRecord);
	//设置提醒
	setAllTaskNotify(function(){
		_callFunc.call(this, _isSuccess);
	});
};

