/**
 * 用户
 * 
 * @Author : Cydow
 * @Timestamp : 2017-08-09
 */
//引入组件库
var deviceone = require("deviceone");

var tools = require("tools");            //工具
var constants = require("constants");    //常量

//数据库
var localdb = deviceone.mm("M0026_sqlite", "localdb", "app");

/**
 * 向cydwouser表中插入一条数据
 * @param _changedData
 */
function insert_cydowUserData(_changedData){
	var _nowTime = new Date();
	if (_changedData.username == null){
		_changedData.username = "";
	}
	if (_changedData.fullname == null){
		_changedData.fullname = "";
	}
	if (_changedData.mailadd == null){
		_changedData.mailadd = "";
	}
	if (_changedData.regdate == null){
		_changedData.regdate = _nowTime.getTime();
	}
	if(_changedData.lastlogindate == null){
		_changedData.lastlogindate = _nowTime.getTime();
	}
	if(_changedData.lastlogindevicename == null){
		_changedData.lastlogindevicename = "";
	}
	if(_changedData.lastlogindeviceid == null){
		_changedData.lastlogindeviceid  = "";
	}
	if(_changedData.lastloginip == null){
		_changedData.lastloginip  = "";
	}
	if(_changedData.status == null){
		_changedData.status  = 1;
	}
	if(_changedData.userrole == null){
		_changedData.userrole  = 0;
	}
	if(_changedData.headurl == null){
		_changedData.headurl  = "";
	}
	if(_changedData.otherinfo == null){
		_changedData.otherinfo  = "";
	}
	var _sql_insert = "insert into cydowuser(userid, username, fullname, userpass, " +
			" mailadd, mobileno, globaluid, regdate, lastlogindate, " +
			"lastlogindevicename, lastlogindeviceid, lastloginip, status, " +
			" userrole, headurl, otherinfo) values("
		+ tools.formatSqlValue(_changedData.userid) + ","
		+ tools.formatSqlValue(_changedData.username) + ","
		+ tools.formatSqlValue(_changedData.fullname) + ","
		+ tools.formatSqlValue(_changedData.userpass) + ","
		+ tools.formatSqlValue(_changedData.mailadd) + ","
		+ tools.formatSqlValue(_changedData.mobileno) + ","
		+ tools.formatSqlValue(_changedData.globaluid) + ","
		+ _changedData.regdate + ","
		+ _changedData.lastlogindate + ","
		+ tools.formatSqlValue(_changedData.lastlogindevicename) + ","
		+ tools.formatSqlValue(_changedData.lastlogindeviceid) + ","
		+ tools.formatSqlValue(_changedData.lastloginip) + ","
		+ _changedData.status + ","
		+ _changedData.userrole + ","
		+ tools.formatSqlValue(_changedData.headurl) + ","
		+ tools.formatSqlValue(_changedData.otherinfo) + ");";
	var isSuccess = localdb.executeSync(_sql_insert);
	return isSuccess;
}

//向cydowuser表中插入一条数据
module.exports.insert_cydowUserData = function(_changedData){
	return insert_cydowUserData(_changedData);	
};

/**
 * 更新cydowuser表中的数据
 * @param _changedData
 */
function update_cydowUserData(_changedData){
	var _nowTime = new Date();
	var _setList="";
	if (_changedData.username != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "username=" + tools.formatSqlValue(_changedData.username);
	}
	if (_changedData.fullname!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "fullname=" + tools.formatSqlValue(_changedData.fullname);
	}
	if (_changedData.userpass!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "userpass=" + tools.formatSqlValue(_changedData.userpass);
	}
	if (_changedData.mobileno != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "mobileno=" + tools.formatSqlValue(_changedData.mobileno);
	}
	if (_changedData.mailadd != null){
		if (_setList.length > 0) _setList+=",";
		_setList += "mailadd=" + tools.formatSqlValue(_changedData.mailadd);
	}
	if (_changedData.globaluid!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "globaluid=" + tools.formatSqlValue(_changedData.globaluid);
	}
	if (_changedData.regdate!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "regdate=" + _changedData.regdate;
	}
	if (_changedData.lastlogindate!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "lastlogindate=" + _changedData.lastlogindate;
	}
	if (_changedData.lastlogindevicename!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "lastlogindevicename=" + tools.formatSqlValue(_changedData.lastlogindevicename);
	}
	if (_changedData.lastlogindeviceid!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "lastlogindeviceid=" + tools.formatSqlValue(_changedData.lastlogindeviceid);
	}
	if (_changedData.lastloginip!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "lastloginip=" + tools.formatSqlValue(_changedData.lastloginip);
	}
	if (_changedData.status!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "status=" + _changedData.status;
	}
	if (_changedData.userrole!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "userrole=" + _changedData.userrole;
	}
	if (_changedData.headurl!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "headurl=" + tools.formatSqlValue(_changedData.headurl);
	}
	if (_changedData.otherinfo!=null){
		if (_setList.length > 0) _setList+=",";
		_setList += "otherinfo=" + tools.formatSqlValue(_changedData.otherinfo);
	}
	if (_setList.length <= 0) return;
	var _sql_update = "update cydowuser set " + _setList + " where userid="
		+ tools.formatSqlValue(_changedData.userid) + ";";
	var isSuccess = localdb.executeSync(_sql_update);
	return isSuccess;
}

//更新用户数据
module.exports.update_cydowUserData = function(_changedData){
	return update_cydowUserData(_changedData);	
};

/**
 * 删除cydowuser表中指定id的数据
 * @param _id
 */
function delete_cydowUserData(_id){
	var _sql_del ="delete from cydowuser where userid=" + tools.formatSqlValue(_id) + ";";
	var isSuccess = localdb.executeSync(_sql_del);
	return isSuccess;
}

//删除cydowuser表中指定id的数据
module.exports.delete_cydowUserData = function(_id){
	delete_cydowUserData(_id);	
};

/**
 * 查询指定条件（_id）下用户数据
 * @param _id
 * @returns
 */
function query_userDataById(_id){
	var sql ="select * from cydowuser where userid="
		+ tools.formatSqlValue(_id) + ";";
	var _data = localdb.querySync(sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data[0];
}

//查询指定条件（_id）下用户数据
module.exports.query_userDataById = function(_id){
	return query_userDataById(_id);
};

/**
 * 根据手机号查询下用户数据
 * @param _mobileno
 * @returns
 */
function query_userDataByMobileNo(_mobileno){
	var sql ="select * from cydowuser where mobileno="
		+ tools.formatSqlValue(_mobileno) + ";";
	var _data = localdb.querySync(sql);
	if(_data == null || _data.length <= 0){
		return null;
	}
	return _data[0];
}

//根据手机号查询下用户数据
module.exports.query_userDataByMobileNo = function(_mobileno){
	return query_userDataByMobileNo(_mobileno);
};
