/* Buffalo by Marcello Bastea-Forte - zlib license */

//引入组件库
var deviceone = require("deviceone");
var do_DataCache = deviceone.sm("do_DataCache");

// Generate machine hash
//  from docs: This is the first three bytes of the (md5) hash of the machine host name, or of the mac/network address,
//     or the virtual machine id.

var machineHashCode = Math.random() * 100000000;
var pidHashCode = Math.random() * 100000;

//获取机器码id
if(do_DataCache.hasData("machineId")){
	var machineuuid = do_DataCache.loadData("machineId");
	machineHashCode = hashCode(machineuuid);
}

//获取进程id
if(do_DataCache.hasData("processId")){
	var piduuid = do_DataCache.loadData("processId");
	pidHashCode = hashCode(piduuid);
}

var machineHash = writeInt3(machineHashCode);

// Pre-cache the machine hash / pid
var machineAndPid = [
    machineHash[0],
    machineHash[1],
    machineHash[2],
    pidHashCode & 0xFF,
    (pidHashCode >> 8) & 0xFF
]

// ObjectId increment
var inc = 1

// 32 bit time
// 24 bit machine id
// 16 bit pid
// 24 bit increment
module.exports.getObjectId = function() {
    var bytes = _objectId(Date.now());
    return toString(bytes);
    
    function _objectId(time) {
        var timestamp = (time / 1000) & 0xFFFFFFFF
//        inc = ~~inc+1 // keep as integer
        inc = Math.random() * 10000000;
        return [
            timestamp>>24,
            timestamp>>16,
            timestamp>>8,
            timestamp,
            machineAndPid[0],
            machineAndPid[1],
            machineAndPid[2],
            machineAndPid[3],
            machineAndPid[4],
            inc>>16,
            inc>>8,
            inc   
        ];
    }
    
}

//32 bit time
//24 bit machine id
//16 bit pid
//24 bit increment
module.exports.getNodeId = function() {
 var bytes = _objectId(Date.now());
 return toString(bytes);
 
 function _objectId(time) {
     var timestamp = (time / 1000) & 0xFFFFFFFF
//     inc = ~~inc+1 // keep as integer
     inc = Math.random() * 10000000;
     return [
         timestamp>>24,
         timestamp>>16,
         timestamp>>8,
         timestamp,
         inc>>8,
         inc   
     ];
 }
 
}

function toString(bytes) {
    return toHex(bytes);
} 

function toHex(buffer) {
	var _ids = '';
	for(var i=0; i<buffer.length; i++){
		var id = buffer[i] & 0xFF;
		_ids += id >= 16 ? id.toString(16) : '0' + id.toString(16);
	}
    return _ids;
}

function hashCode(value) {
    var hash = 0;
    if (hash == 0 && value != null) {
        var len = value.length;
        for (var i = len-1; i >= 0; i--) {
        	var temp = 31*hash + value.charCodeAt(i);
        	if(temp > 4294967295){
        		break;
        	}
        	hash = temp;
        }
    }
    return hash;
}

function writeInt3 (value) {
	var buffer = new Array();
	var offset = 0;
    buffer[offset++] = (value) & 0xff
    buffer[offset++] = (value>>8) & 0xff
    buffer[offset++] = (value>>16) & 0xff
    return buffer;
}
