/**
 * 工具（数据同步）
 */
var deviceone = require("deviceone");
var tools = require("tools");
var constants = require("constants");

//信息类型常量
var typeconstants = require("typeconstants.ui");

/**
 * 转换固定标识（本地到信息库）
 * @param canged
 * @returns {Boolean}
 */
module.exports.canged2IsPastAnchor = function(canged){
	var isPastAnchor = false;
	if(canged == "1") {
		isPastAnchor = true;
	}
	return isPastAnchor;
}

/**
 * 转换固定标识（信息库到本地）
 * @param isPastAnchor
 * @returns {Number}
 */
module.exports.isPastAnchor2Canged = function(isPastAnchor){
	var canged = "0";
	if(isPastAnchor) {
		canged = "1";
	}
	return canged;
}

/**
 * 提醒时长本地转为远端
 * @param _remindTime
 * @returns
 */
module.exports.remindTimeLocalToRemote = function(_remindTime){
	return tools.getRemoteRemindTime(_remindTime);
}

/**
 * 提醒时长远端转为本地
 * @param _remindTime
 * @returns
 */
module.exports.remindTimeRemoteToLocal = function(_remindTime){
	return tools.getLocalRemindTime(_remindTime);
}

/**
 * 转换时间卡片类别（本地到远端）
 * @param canged
 * @returns {Boolean}
 */
module.exports.infoCategoryLocal2Remote = function(_infocategory){
	var _destInfoCategory = _infocategory;
	if(_infocategory == constants.getConstants("infoCategory_task")) {
		_destInfoCategory = constants.getConstants("infoCategory_comm");
	} else if(_infocategory == constants.getConstants("infoCategory_comm")){
		_destInfoCategory = constants.getConstants("infoCategory_task");
	} else if(_infocategory == constants.getConstants("infoCategory_lesson")){
		_destInfoCategory = _infocategory;
	}
	return _destInfoCategory;
}

/**
 * 转换时间卡片类别（远端到本地）
 * @param _infocategory
 * @returns {Number}
 */
module.exports.infoCategoryRemote2Local = function(_infocategory){
	var _destInfoCategory = null;
	if(_infocategory == constants.getConstants("infoCategory_task")) {
		_destInfoCategory = constants.getConstants("infoCategory_comm");
	} else if(_infocategory == constants.getConstants("infoCategory_comm")){
		_destInfoCategory = constants.getConstants("infoCategory_task");
	} else if(_infocategory == constants.getConstants("infoCategory_lesson")){
		_destInfoCategory = _infocategory;
	}
	return _destInfoCategory;
}

/**
 * 系统调用（信息库到本地）
 * @param _syscall
 * @returns {String}
 */
module.exports.syscallRemote2Local = function(_syscall){
	var _destSysCall = constants.getConstants("syscall_system");
	if(_syscall == "system_1") {
		_destSysCall = constants.getConstants("syscall_system_1");
	} else if(_syscall == "system_2") {
		_destSysCall = constants.getConstants("syscall_system_2");
	} else if(_syscall == "system_3") {
		_destSysCall = constants.getConstants("syscall_system_3");
	} else if(_syscall == "system_4") {
		_destSysCall = constants.getConstants("syscall_system_4");
	} else if(_syscall == "system_5") {
		_destSysCall = constants.getConstants("syscall_system_5");
	}
	return _destSysCall;
}

/**
 * 系统调用（本地到信息库）
 * @param _syscall
 * @returns {String}
 */
module.exports.syscallLocal2Remote = function(_syscall){
	var _destSysCall = "system";
	if(_syscall == constants.getConstants("syscall_system_1")) {
		_destSysCall = "system_1";
	} else if(_syscall == constants.getConstants("syscall_system_2")) {
		_destSysCall = "system_2";
	} else if(_syscall == constants.getConstants("syscall_system_3")) {
		_destSysCall = "system_3";
	} else if(_syscall == constants.getConstants("syscall_system_4")) {
		_destSysCall = "system_4";
	} else if(_syscall == constants.getConstants("syscall_system_5")) {
		_destSysCall = "system_5";
	}
	return _destSysCall;
}

/**
 * 使用或共享格式（信息库到本地）
 * @param _syscall
 * @returns {String}
 */
module.exports.useformatRemote2Local = function(_useformat){
	if("" == _useformat || "1" == _useformat){
		return constants.getConstants("useformat_common");
	} else if("0" == _useformat){
		return constants.getConstants("useformat_special");
	} 
	return constants.getConstants("useformat_common");
}