/**
 * 时间工具
 * 
 * @Author : Cydow
 * @Timestamp : 2017-02-28
 */
//引入组件库
var deviceone = require("deviceone");
var calendar = require("calendar"); // 日期

// js文件路径管理
var jsPathManager = require("jsPathManager.ui");
// 全局常量
var globalConst = require(jsPathManager.getGlobalConstPath());
// 文本资源
var string = require(jsPathManager.getStringPath());

//完整的格式化  var time2 = new Date().format("yyyy-MM-dd HH:mm:ss.SSS");
Date.prototype.format = function (fmt) {
	var o = {
		"M+": this.getMonth() + 1, //月份
		"d+": this.getDate(), //日
		"H+": this.getHours(), //小时
		"m+": this.getMinutes(), //分
		"s+": this.getSeconds(), //秒
		"q+": Math.floor((this.getMonth() + 3) / 3), //季度
		"S+": this.getMilliseconds() //毫秒
	};
	//处理年份
	var reYear = /(y+)/;
	var resultYear = reYear.exec(fmt);
	if (resultYear) {
		var yearformatPart = resultYear[0]; //匹配到的格式化字符
		var yearVal = (this.getFullYear() + "").substr(4 - yearformatPart.length);
		fmt = fmt.replace(yearformatPart, yearVal);
	}
	//周
    var week = {
        "0": "日",
        "1": "一",
        "2": "二",
        "3": "三",
        "4": "四",
        "5": "五",
        "6": "六"
    };
	// 处理周几
	var reWeek = /(E+)/;
	var resultWeek = reWeek.exec(fmt);
	if(resultWeek) {
		var weelformatPart = resultWeek[0]; //匹配到的格式化字符
		var weekVal = ((resultWeek.length > 1) ? "周" : "") + week[this.getDay() + ""];
		fmt = fmt.replace(weelformatPart, weekVal);
	}
	// 处理其他
	for (var k in o) {
		var re = new RegExp("(" + k + ")");
		var res = re.exec(fmt);
		if (res) {
			var Val = "" + o[k]; //本次需要替换的数据
			var formatPart = res[0]; //匹配到的格式化字符
			var replaceVal = "";
			if('SSS' == formatPart){
				replaceVal = ("000" + Val).substr(("" + Val).length);
			} else {
				replaceVal = (formatPart.length == 1) ? (Val) : (("00" + Val).substr(Val.length));
			}
			fmt = fmt.replace(formatPart, replaceVal);
		}
	}
	return fmt;
}
Date.prototype.AddDays = function (days) {
	var olddays = this.getDate();
	var newdays = olddays + days;
	this.setDate(newdays);
	return this;
}

// 将格式化的字符串转换为日期对象
module.exports.parseToDate = function(dateText, format){
	return parseToDate(dateText, format);
}

/*获取到年月日，时分秒，毫秒几个值，然后生成日期
第一个参数为格式化的日期字符串，格式化的字符串
测试代码
var data=new Date();
var  format ="yyyy-MM-dd HH:mm:ss";
var text=data.format(format);
alert(text);
var data2=parserToDate(text,format);
alert(data2.format(format));
 */
function parseToDate(dateText, format) {
	if (!dateText) { //空值
		return null;
	}	
	//定义默认值，默认值根据当前时间生成
	var defaultVal = new Date();
	var year = defaultVal.getFullYear();
	var month = defaultVal.getMonth() + 1;
	var day = defaultVal.getDate();
	var hours = defaultVal.getHours();
	var minutes = defaultVal.getMinutes();
	var seconds = defaultVal.getSeconds();
	var milliseconds = defaultVal.getMilliseconds();
	//定义正则
	var o = [{
			reg: "y+"
		}, //年份
		{
			reg: "M+"
		}, //月份
		{
			reg: "d+"
		}, //日
		{
			reg: "H+"
		}, //小时
		{
			reg: "m+"
		}, //分
		{
			reg: "s+"
		}, //秒
		{
			reg: "S+"
		} //毫秒
	];
	var index = dateText.lastIndexOf('.');
	if(index > -1){
		var dateList = dateText.split('.');
		if(dateList.length > 1 && null != dateList[1]){
			dateList[1] = ("000" + dateList[1]).substr(("" + dateList[1]).length);
			dateText = dateList.join('.');
		}
	}
	//获取到年月日，时分秒，毫秒几个值在字符串中的先后位置
	index = 1;
	for (var j = 0; j < format.length; j++) {
		var onechar = format[j];
		for (var i = 0; i < o.length; i++) {
			var onepart = o[i];
			var onepartReg = onepart.reg;
			if (onepartReg[0] == onechar) {
				if (!onepart.index) {
					onepart.index = index; //获取到年月日，时分秒，毫秒几个值在字符串中的先后位置
					index++;
				}
				break;
			}
		}
 
	}
	//生成匹配的正则表达式
	for (var i = 0; i < o.length; i++) {
		var onepart = o[i];
		var onepartReg = onepart.reg;
		var re = new RegExp("(" + onepartReg + ")");
		var res = re.exec(format);
		if (res) {
			var formatPart = res[0]; //匹配到的格式化字符
			var replaceVal = "([0-9]{" + formatPart.length + "})"; //不能使用/d匹配,会和日期的d冲突
			format = format.replace(formatPart, replaceVal);
		}
	}
	//保存获取到的各个部分和位置
	var dataInfo = {};
	var re = new RegExp(format);
	var res = re.exec(dateText);
	//去掉第一个匹配，记录匹配到的数据
	if (res) {
		for (var i = 1; i < res.length; i++) {
			dataInfo[i] = res[i]; //记录年月日，时分秒，毫秒几个值在字符串中的位置和对应的值
		}
	} else {
		return new Date();
	}
	if (o[0].index) //年份存在
	{
		var index = o[0].index;
		year = dataInfo[index];
	}
	if (o[1].index) //月份存在
	{
		var index = o[1].index;
		month = dataInfo[index]; 
	}
	if (o[2].index) //日存在
	{
		var index = o[2].index;
		day = dataInfo[index];
	}
	if (o[3].index) //小时存在
	{
		var index = o[3].index;
		hours = dataInfo[index];
	}
	if (o[4].index) //分存在
	{
		var index = o[4].index;
		minutes = dataInfo[index];
	}
	if (o[5].index) //秒存在
	{
		var index = o[5].index;
		seconds = dataInfo[index];
	}
	if (o[6].index) //毫秒存在
	{
		var index = o[6].index;
		milliseconds = dataInfo[index];
	}
	//月份是从0开始的
	return new Date(year, month - 1, day, hours, minutes, seconds, milliseconds);
}

/**
 * 使用记录页面时间格式（xx年xx月xx日 xx时:xx分）
 * @param _time
 * @returns
 */
function formatUseTime(_time){
	var _timeValue = new Date();
	_timeValue.setTime(_time);
	var _month =_timeValue.getMonth() + 1;
	var _day =_timeValue.getDate();
	var _hour =_timeValue.getHours();
	var _minute =_timeValue.getMinutes();
	return (_timeValue.getFullYear() + "年" + 
		_month + "月" +
		_day + "日  " +
		_hour + "点" +
		_minute + "分");
}

module.exports.formatUseTime = function(_time){
	return formatUseTime(_time);
}

/**
 * 待办事宜卡片详情页面时间格式（xx月xx日 xx:xx）
 * @param _time
 * @returns
 */
function formatTaskDetailsTime(_time){
	var _timeValue = new Date();
	_timeValue.setTime(_time);
	var _month =_timeValue.getMonth() + 1;
	var _day =_timeValue.getDate();
	var _hour =_timeValue.getHours();
	var _minute =_timeValue.getMinutes();
	return  (_month < 10 ? "0" + _month:_month)  + "月" +
			(_day < 10 ? "0" + _day:_day) + "日 " +
			(_hour < 10 ? "0" + _hour:_hour) + ":" +
			(_minute < 10 ? "0" + _minute:_minute);
}

//待办事宜卡片详情页面时间格式（xx月xx日 xx时:xx分）
module.exports.taskDetailsTime = function(_time){
	return formatTaskDetailsTime(_time);
}

/**
 * 比较两个日期是否同一天
 * @param _date1
 * @param _date2
 * @returns
 */
function datesAreOnSameDay(_date1, _date2){
	if(_date1.getFullYear() === _date2.getFullYear() &&
    _date1.getMonth() === _date2.getMonth() &&
    _date1.getDate() === _date2.getDate()){
		return true;
	} else {
		return false;
	}
}

/**
 * 待办事宜卡片详情页面时间格式（xx月xx日 xx:xx）
 * 开始时间-结束时间
 * @param _start
 * @param _startTimeType
 * @param _end
 * @param _endTimeType
 * @param _dateFormat
 * @returns
 */
function formatStartAndEndTime(_start, _startTimeType, 
		_end, _endTimeType, _dateFormat){
	var _startTime = new Date();
	_startTime.setTime(_start);
	var _endTime = new Date();
	_endTime.setTime(_end);
	// 若开始时间显示类型为空，则设置开始时间为显示全格式
	if(undefined == _startTimeType ||
			null == _startTimeType){
		_startTimeType = globalConst.timeShowType.all;
	}
	// 若结束时间显示类型为空，则设置结束时间为显示全格式
	if(undefined == _endTimeType ||
			null == _endTimeType){
		_endTimeType = globalConst.timeShowType.all;
	}
	var _timeText = "";
	var _timeFormat = globalConst.timeFormat.time;
	var _dateTimeFormat = _dateFormat + " " + _timeFormat;
	var _unsettingStr = string.global.unsetting;
	// 根据开始和结束时间的显示类型进行相应处理
	if(_startTimeType == globalConst.timeShowType.all){ // 开始时间全
		_timeText = _startTime.format(_dateTimeFormat) + "-";
		if(_endTimeType == globalConst.timeShowType.all){ // 结束时间全
			// 比较开始和结束时间是否同一天
			if(datesAreOnSameDay(_startTime, _endTime)){
				_timeText += _endTime.format(_timeFormat);
			} else {
				_timeText += _endTime.format(_dateTimeFormat);
			}
		} else if(_endTimeType == globalConst.timeShowType.part){ // 结束时间只有日期
			// 比较开始和结束时间是否同一天
			if(datesAreOnSameDay(_startTime, _endTime)){
				_timeText += _unsettingStr;
			} else {
				_timeText += _endTime.format(_dateFormat) + " " + _unsettingStr;
			}
		} else { // 结束时间无
			_timeText += _unsettingStr;
		}
	} else if(_startTimeType == globalConst.timeShowType.part){ // 开始时间只有日期
		_timeText = _startTime.format(_dateFormat);
		if(_endTimeType == globalConst.timeShowType.all){ // 结束时间全
			_timeText += " " + _unsettingStr + "-";
			// 比较开始和结束时间是否同一天
			if(datesAreOnSameDay(_startTime, _endTime)){
				_timeText += _endTime.format(_timeFormat);
			} else {
				_timeText += _endTime.format(_dateTimeFormat);
			}
		} else if(_endTimeType == globalConst.timeShowType.part){ // 结束时间只有日期
			// 比较开始和结束时间是否同一天
			if(datesAreOnSameDay(_startTime, _endTime)){
			} else {
				_timeText += "-";
				_timeText += _endTime.format(_dateFormat);
			}
		} else { // 结束时间无
			_timeText += "-" + _unsettingStr;
		}
	} else { // 开始时间无
		_timeText = _unsettingStr + "-";
		if(_endTimeType == globalConst.timeShowType.all){ // 结束时间全
			_timeText += _endTime.format(_dateTimeFormat);
		} else if(_endTimeType == globalConst.timeShowType.part){ // 结束时间只有日期
			_timeText += _endTime.format(_dateFormat);
		} else {
			_timeText += _unsettingStr;
		}
	}
	return _timeText;
}

//待办事宜卡片详情页面时间格式（xx月xx日 xx时:xx分）
module.exports.formatStartAndEndTime = function(_start, _startTimeType, 
		_end, _endTimeType, _dateFormat){
	return formatStartAndEndTime(_start, _startTimeType, 
			_end, _endTimeType, _dateFormat);
}

/**
 * 课程上课时间格式化（xx月xx日 xx时:xx分）
 * 上课时间：开始时间-结束时间
 * @param _start
 * @param _startTimeType
 * @param _end
 * @param _endTimeType
 * @param _dateFormat
 * @returns
 */
function formatLessonTime(_start, _startTimeType, 
		_end, _endTimeType, _dateFormat){
	var _startTime = new Date();
	_startTime.setTime(_start);
	var _endTime = new Date();
	_endTime.setTime(_end);
	// 若开始时间显示类型为空，则设置开始时间为显示全格式
	if(undefined == _startTimeType ||
			null == _startTimeType){
		_startTimeType = globalConst.timeShowType.all;
	}
	// 若结束时间显示类型为空，则设置结束时间为显示全格式
	if(undefined == _endTimeType ||
			null == _endTimeType){
		_endTimeType = globalConst.timeShowType.all;
	}
	var _timeText = "";
	var _timeFormat = globalConst.timeFormat.time;
	var _dateTimeFormat = _dateFormat + " " + _timeFormat;
	// 根据开始和结束时间的显示类型进行相应处理
	if(_startTimeType == globalConst.timeShowType.all){ // 开始时间全
		_timeText = _startTime.format(_dateTimeFormat);
		if(_endTimeType == globalConst.timeShowType.all){ // 结束时间全
			_timeText += "-";
			_timeText += _endTime.format(_timeFormat);
		}
	} else if(_startTimeType == globalConst.timeShowType.part){ // 开始时间只有日期
		_timeText = _startTime.format(_dateFormat);
	} else { // 开始时间无
		_timeText = "";
	}
	return _timeText;
}

//课程上课时间格式化（xx月xx日 xx时:xx分）
module.exports.formatLessonTime = function(_start, _startTimeType, 
		_end, _endTimeType, _dateFormat){
	return formatLessonTime(_start, _startTimeType, 
			_end, _endTimeType, _dateFormat);
}

/**
 * 待办分享时显示的时间格式（全格式：xx年xx月xx日 周x xx:xx）
 * @param _time
 * @param _timeType
 * @returns
 */
function formatTaskShareTime(_time, _timeType){
	var _dateTime = new Date();
	_dateTime.setTime(_time);
	// 若时间显示类型为空，则设置时间为显示全格式
	if(undefined == _timeType ||
			null == _timeType){
		_timeType = globalConst.timeShowType.all;
	}
	var _timeText = "";
	// 根据时间的显示类型进行相应处理
	if(_timeType == globalConst.timeShowType.all){ // 时间全
		_timeText = _dateTime.format(globalConst.timeFormat.dateweektime);
	} else if(_timeType == globalConst.timeShowType.part){ // 时间只有日期
		_timeText = _dateTime.format(globalConst.timeFormat.dateweek);
	} else { // 开始时间无
		_timeText = string.global.unsetting;
	}
	return _timeText;
}

// 待办分享时显示的时间格式
module.exports.formatTaskShareTime = function(_time, _timeType){
	return formatTaskShareTime(_time, _timeType);
}

/**
 * 消息接收时间格式（xx年xx月xx日 xx:xx）
 * @param _time
 * @returns
 */
function formatMsgReceiveTime(_time){
	var _timeValue = new Date();
	_timeValue.setTime(_time);
	var _year = _timeValue.getFullYear();
	var _month =_timeValue.getMonth() + 1;
	var _day =_timeValue.getDate();
	var _hour =_timeValue.getHours();
	var _minute =_timeValue.getMinutes();
	return  _year + "年" + 
			(_month < 10 ? "0" + _month : _month)  + "月" +
			(_day < 10 ? "0" + _day : _day)  + "日 " +
			(_hour < 10 ? "0" + _hour : _hour) + ":" +
			(_minute < 10 ? "0" + _minute : _minute);
}

//消息接收时间格式（xx年xx月xx日 xx:xx）
module.exports.formatMsgReceiveTime = function(_time){
	return formatMsgReceiveTime(_time);
}

/**
 * 获取周几大写
 * @param _week
 * @returns
 */
function getWeekText(_week){
	var _weekText;
	switch(_week)
	{
		case 1:
			_weekText = "一";
			break;
		case 2:
			_weekText = "二";
			break;
		case 3:
			_weekText = "三";
			break;
		case 4:
			_weekText = "四";
			break;
		case 5:
			_weekText = "五";
			break;
		case 6:
			_weekText = "六";
			break;
		default:
			_weekText = "日";
			break;
	}
	return "周" + _weekText;
}

// 获取周几大写
module.exports.getWeekText = function(_week){
	return getWeekText(_week);
}

/**
 * 待办事宜编辑页面时间格式（xx年xx月xx日 周x xx时:xx分）
 * 
 * @param _time
 * @returns
 */
function formatTaskEditTime(_time)
{
	var _month = _time.getMonth() + 1;
	var _day = _time.getDate();
	var _hour = _time.getHours();
	var _minute = _time.getMinutes();
	var _week = _time.getDay();
	var _weekText = getWeekText(_week);
	return _time.getFullYear() + "年" + 
		(_month < 10 ? "0" + _month:_month) + "月" + 
		(_day < 10 ? "0" + _day:_day) + "日" +
		" " + _weekText + " " + 
		(_hour < 10 ? "0" + _hour:_hour) + ":" +
		(_minute < 10 ? "0" + _minute:_minute);
}

//待办事宜编辑页面时间格式（xx年xx月xx日 周x xx时:xx分）
module.exports.taskEditTime = function(_time){
	return formatTaskEditTime(_time);
}

/**
 * 公历时间格式
 * _type=0 xx年xx月xx日 周x xx时:xx分
 * _type=1 xx年xx月xx日）
 * 
 * @param _time
 * @param _type
 * @returns
 */
function formatGregorianTime(_time, _type){
	var _year = _time.getFullYear();
	var _month =_time.getMonth() + 1;
	var _day =_time.getDate();
	var _hour =_time.getHours();
	var _minute =_time.getMinutes();
	var _week = getWeekText(_time.getDay());
	if(0 == _type){
		return _year + "年" + 
			(_month < 10 ? "0" + _month:_month) + "月" +
			(_day < 10 ? "0" + _day:_day) + "日" + 
			" " + _week + " " + 
			(_hour < 10 ? "0" + _hour:_hour) + ":" +
			(_minute < 10 ? "0" + _minute:_minute);
	} else {
		return _year + "年" + 
		(_month < 10 ? "0" + _month:_month) + "月" +
		(_day < 10 ? "0" + _day:_day) + "日";
	}
}

// 公历时间格式（xx年xx月xx日 周x xx时:xx分 或 xx年xx月xx日）
module.exports.formatGregorianTime = function(_time, _type){
	return formatGregorianTime(_time, _type);
}

// 农历月
var lunarMonths = ["正","二","三","四","五","六","七","八","九","十","冬","腊"];
// 农历日
var lunarDays = ["初一","初二","初三","初四","初五","初六","初七","初八","初九","初十",
				"十一","十二","十三","十四","十五","十六","十七","十八","十九","二十",
				"廿一","廿二","廿三","廿四","廿五","廿六","廿七","廿八","廿九","三十"];
/**
 * 农历时间格式
 * _type=0 xx年xx月xx日 周x xx时:xx分
 * _type=1 xx年xx月xx日）
 * 
 * @param _time
 * @param _type
 * @returns
 */
function formatLunarTime(_time, _type){
	var _year = _time.year;
	var _month = lunarMonths[_time.month - 1];
	if(_time.isLeap){
		_month = "闰" + _month;
	}
	var _day = lunarDays[_time.day - 1];
	var _week = getWeekText(_time.week);
	var _hour = _time.hours;
	var _minute = _time.minutes;
	if(0 == _type){
		return _year + "年" + _month + "月" + _day  + " " + _week + " " + 
			(_hour < 10 ? "0" + _hour:_hour) + ":" +
			(_minute < 10 ? "0" + _minute:_minute);
	} else {
		return _year + "年" + _month + "月" + _day;
	}
}

// 农历时间格式（xx年xx月xx日 周x xx时:xx分 或 xx年xx月xx日）
module.exports.formatLunarTime = function(_date, _type){
	var _lunarDate = calendar.greg2lunar(_date);
	return formatLunarTime(_lunarDate, _type);
}

/**
 * 获得本周的开始日期
 * @param year
 * @returns
 */
function getWeekStartDate(_nowYear, _nowMonth, _nowDay, _nowDayOfWeek) {      
    return new Date(_nowYear, _nowMonth, _nowDay - _nowDayOfWeek);     
}      

/**
 * 获得本周的结束日期
 * @param year
 * @returns
 */
function getWeekEndDate(_nowYear, _nowMonth, _nowDay, _nowDayOfWeek) {      
    return new Date(_nowYear, _nowMonth, _nowDay + (6 - _nowDayOfWeek));     
}

//计算本周起始和截止日期（每周一到周日），并返回
module.exports.getWeekTime = function(){
	var _dayLengthTime = 24 * 3600 * 1000;
	var _now = new Date();
	var _year = _now.getFullYear();
	var _month = _now.getMonth();
	var _day = _now.getDate();
	var _weekDay = _now.getDay();
	if(0 == _weekDay){
		_weekDay = 7;
	}
	var _weekStartDate = getWeekStartDate(_year, _month, _day, _weekDay);
	_weekStartDate.setHours(0, 0, 0, 0);
	_weekStartDate.setTime(_weekStartDate.getTime() + _dayLengthTime);
	var _weekEndDate = getWeekEndDate(_year, _month, _day, _weekDay);
	_weekEndDate.setHours(23, 59, 59, 999);
	_weekEndDate.setTime(_weekEndDate.getTime() + _dayLengthTime);
	
	return {weekStartTime: _weekStartDate.getTime(), weekEndTime: _weekEndDate.getTime()};
}

/** 
 * 获取某一年份的某一月份的天数 
 *  
 * @param {Number} year 
 * @param {Number} month
 * @returns 
 */ 
function getMonthDays(year, month) { 
    return [31, null, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31][month] || (calendar.isLeapYear(year) ? 29 : 28); 
}

/**
 * 计算一年中的第几个周
 * @returns
 */
function getWeekOfYear() { 
    var _now = new Date();
    var _year = _now.getFullYear();
    var _month = _now.getMonth();
    var _days = _now.getDate(); 
 
    //计算是一年中的第多少天 
    for (var i = 0; i < _month; i++) { 
    	_days += getMonthDays(_year, i); 
    }
    //计算一年的第一天是星期几 
    var _yearFirstDay = new Date(_year, 0, 1).getDay() || 7;
    var _week = null; 
    if (_yearFirstDay == 1) { 
        _week = Math.ceil(_days / 7); 
    } else { 
    	_days -= (7 - _yearFirstDay + 1); 
        _week = Math.ceil(_days / 7) + 1; 
    }
    return {year: _year, week: _week}
}

//计算一年中的第几个周
module.exports.getWeekOfYear = function(){
	return getWeekOfYear();
}

//获取纪念日、生日重复（周期）对应的时间
module.exports.getCycleTimeOfComm = function(_cycleData){
	return calendar.getCycleTimeOfComm(_cycleData);
}

//获取未来最近纪念日、生日重复（周期）对应的时间
module.exports.getFutureCycleTimeOfComm = function(_commData){
	return calendar.getFutureCycleTimeOfComm(_commData);
}

/**
 * 获取正数日（年、月、日）
 * @param _commTime
 * @returns
 */
function getPositiveDays(_commTime){
	var _nowTime = new Date();
	_nowTime.setHours(0, 0, 0, 0);
	var _destTime = new Date();
	_destTime.setTime(_commTime);
	_destTime.setHours(0, 0, 0, 0);
	//计算倒数日的年、月、日
	var _positiveYear = 0;
	var _positiveMonth = 0;
	var _positiveDay = 0;
	if(_nowTime.getTime() > _destTime.getTime()){
		var _nowYear = _nowTime.getFullYear();
		var _nowMonth = _nowTime.getMonth() + 1;
		var _nowDay = _nowTime.getDate();
		var _destYear = _destTime.getFullYear();
		var _destMonth = _destTime.getMonth() + 1;
		var _destDay = _destTime.getDate();
		//若当前年大于目标年，则需要分别计算距离目标日的年、月、日；
		if(_nowYear > _destYear){
			_positiveYear = _nowYear - _destYear;
		}
		//注意：当前日期是2月29日，则将天当作28日来进行计算
		if(2 == _nowMonth && 29 == _nowDay){
			if(calendar.isLeapYear(_destYear)){
				if(_destMonth > 2){
					_nowDay = 28;
				}
			} else {
				if(_positiveYear > 4){
					if(_destMonth <= 2){
						_nowDay = 28;
					}
				} else {
					_nowDay = 28;
				}
			}
		}
		//若当前月份小于目标月份或当前日小于目标日，则说明不满足一年，
		//需要计算出来的年份减1
		if(_nowMonth < _destMonth || 
				(_nowMonth == _destMonth && 
						_nowDay < _destDay)){
			_positiveYear -= 1;
		}
		//获取目标所在月份的天数
		var _destMonthDays = getMonthDays(_destYear, _destMonth - 1);
		//若目标月份大于当前月份，则计算出来的月份等于目标年剩余月份数加上当前年月份，
		//并根据当前日和目标日进一步计算月份数和天数；
		//若目标月份小于当前月份，则计算出来的月份等于当前年月份减去目标年月份，
		//并根据当前日和目标日进一步计算月份数和天数；
		//若目标月份等于当前月份，则根据当前日和目标日计算月份数和天数；
		if(_nowMonth < _destMonth){
			_positiveMonth = (12 - _destMonth) + _nowMonth;
			//若目标日大于当前日，则计算出来的月份减1，
			//并且天数等于目标月份剩余天数加上当前天数；
			//否则，天数等于当前日减去目标日
			if(_nowDay < _destDay){
				_positiveMonth -= 1;
				_positiveDay = (_destMonthDays - _destDay) + _nowDay;
			} else {
				_positiveDay = _nowDay - _destDay;
			}
		} else if(_nowMonth > _destMonth){
			_positiveMonth = _nowMonth - _destMonth;
			//若目标日大于当前日，则计算出来的月份减1，
			//并且天数等于目标月份剩余天数加上当前天数；
			//否则，天数等于当前日减去目标日
			if(_nowDay < _destDay){
				_positiveMonth -= 1;
				_positiveDay = (_destMonthDays - _destDay) + _nowDay;
			} else {
				_positiveDay = _nowDay - _destDay;
			}
		} else {
			//若目标日大于当前日，则计算出来的月份等于目标年剩余月份加上当前月份减1，
			//并且天数等于目标月份剩余天数加上当前天数；
			//否则，天数等于当前日减去目标日
			if(_nowDay < _destDay){
				_positiveMonth = (12 - _destMonth) + _nowMonth - 1;
				_positiveDay = (_destMonthDays - _destDay) + _nowDay;
			} else {
				_positiveDay = _nowDay - _destDay;
			}
		}
	} 
	var _timeText = "";
	if(_positiveYear > 0){
		_timeText = _positiveYear + string.global.year;
	}
	if(_positiveMonth > 0){
		_timeText += _positiveMonth + string.global.months;
	}
	if(_positiveDay > 0){
		_timeText += _positiveDay + string.global.day1;
	}
	return _timeText;
}

//获取正数日（年、月、日）
module.exports.getPositiveDays = function(_commTime){
	return getPositiveDays(_commTime);
}

/**
 * 转换HH:mm格式字符串为日期对象
 * @param _timeStr
 * @returns
 */
function parseHHmmToDate(_timeStr){
	var _date = new Date();
	if(_timeStr == null || _timeStr == ""){
		return _date;
	}
	var _HHmm = _timeStr.split(":");
	_date.setHours(parseInt(_HHmm[0]));
	_date.setMinutes(parseInt(_HHmm[1]));
	return _date;
}

// 转换HH:mm字符串为日期
module.exports.parseHHmmToDate = parseHHmmToDate;

/**
 * 比较两个HH:mm格式的时间大小
 * @param _stime
 * @param _etime
 * @returns
 */
function compareHHmmTime(_stime, _etime){
	var _sdate = parseHHmmToDate(_stime).getTime();
	var _edate = parseHHmmToDate(_etime).getTime();
	if(_sdate > _edate){
		return 1;
	}else if(_sdate < _edate){
		return -1;
	}else{
		return 0;
	}
}

// 比较两个HH:mm格式的时间大小
module.exports.compareHHmmTime = compareHHmmTime;